#ifndef FIX_FIELD_NUMBERS_H
#define FIX_FIELD_NUMBERS_H

namespace FIX
{
  namespace FIELD
  {
    const int BeginSeqNo = 7;
    const int BeginString = 8;
    const int BodyLength = 9;
    const int CheckSum = 10;
    const int EndSeqNo = 16;
    const int MsgSeqNum = 34;
    const int MsgType = 35;
    const int NewSeqNo = 36;
    const int PossDupFlag = 43;
    const int RefSeqNum = 45;
    const int SenderCompID = 49;
    const int SenderSubID = 50;
    const int SendingTime = 52;
    const int TargetCompID = 56;
    const int TargetSubID = 57;
    const int Text = 58;
    const int Signature = 89;
    const int SecureDataLen = 90;
    const int SecureData = 91;
    const int SignatureLength = 93;
    const int RawDataLength = 95;
    const int RawData = 96;
    const int PossResend = 97;
    const int EncryptMethod = 98;
    const int HeartBtInt = 108;
    const int TestReqID = 112;
    const int OnBehalfOfCompID = 115;
    const int OnBehalfOfSubID = 116;
    const int OrigSendingTime = 122;
    const int GapFillFlag = 123;
    const int DeliverToCompID = 128;
    const int DeliverToSubID = 129;
    const int ResetSeqNumFlag = 141;
    const int SenderLocationID = 142;
    const int TargetLocationID = 143;
    const int OnBehalfOfLocationID = 144;
    const int DeliverToLocationID = 145;
    const int XmlDataLen = 212;
    const int XmlData = 213;
    const int MessageEncoding = 347;
    const int EncodedTextLen = 354;
    const int EncodedText = 355;
    const int LastMsgSeqNumProcessed = 369;
    const int RefTagID = 371;
    const int RefMsgType = 372;
    const int SessionRejectReason = 373;
    const int MaxMessageSize = 383;
    const int TestMessageIndicator = 464;
    const int Username = 553;
    const int Password = 554;
    const int NoHops = 627;
    const int HopCompID = 628;
    const int HopSendingTime = 629;
    const int HopRefID = 630;
    const int NextExpectedMsgSeqNum = 789;
    const int NewPassword = 925;
    const int ApplVerID = 1128;
    const int CstmApplVerID = 1129;
    const int RefApplVerID = 1130;
    const int RefCstmApplVerID = 1131;
    const int DefaultApplVerID = 1137;
    const int ApplExtID = 1156;
    const int EncryptedPasswordMethod = 1400;
    const int EncryptedPasswordLen = 1401;
    const int EncryptedPassword = 1402;
    const int EncryptedNewPasswordLen = 1403;
    const int EncryptedNewPassword = 1404;
    const int RefApplExtID = 1406;
    const int DefaultApplExtID = 1407;
    const int DefaultCstmApplVerID = 1408;
    const int SessionStatus = 1409;
    const int Account = 1;
    const int AdvId = 2;
    const int AdvRefID = 3;
    const int AdvSide = 4;
    const int AdvTransType = 5;
    const int AvgPx = 6;
    const int ClOrdID = 11;
    const int Commission = 12;
    const int CommType = 13;
    const int CumQty = 14;
    const int Currency = 15;
    const int ExecID = 17;
    const int ExecInst = 18;
    const int ExecRefID = 19;
    const int ExecTransType = 20;
    const int HandlInst = 21;
    const int IDSource = 22;
    const int IOIid = 23;
    const int IOIOthSvc = 24;
    const int IOIQltyInd = 25;
    const int IOIRefID = 26;
    const int IOIShares = 27;
    const int IOITransType = 28;
    const int LastCapacity = 29;
    const int LastMkt = 30;
    const int LastPx = 31;
    const int LastShares = 32;
    const int LinesOfText = 33;
    const int OrderID = 37;
    const int OrderQty = 38;
    const int OrdStatus = 39;
    const int OrdType = 40;
    const int OrigClOrdID = 41;
    const int OrigTime = 42;
    const int Price = 44;
    const int RelatdSym = 46;
    const int Rule80A = 47;
    const int SecurityID = 48;
    const int Shares = 53;
    const int Side = 54;
    const int Symbol = 55;
    const int TimeInForce = 59;
    const int TransactTime = 60;
    const int Urgency = 61;
    const int ValidUntilTime = 62;
    const int SettlmntTyp = 63;
    const int FutSettDate = 64;
    const int SymbolSfx = 65;
    const int ListID = 66;
    const int ListSeqNo = 67;
    const int ListNoOrds = 68;
    const int ListExecInst = 69;
    const int AllocID = 70;
    const int AllocTransType = 71;
    const int RefAllocID = 72;
    const int NoOrders = 73;
    const int AvgPrxPrecision = 74;
    const int TradeDate = 75;
    const int ExecBroker = 76;
    const int OpenClose = 77;
    const int NoAllocs = 78;
    const int AllocAccount = 79;
    const int AllocShares = 80;
    const int ProcessCode = 81;
    const int NoRpts = 82;
    const int RptSeq = 83;
    const int CxlQty = 84;
    const int NoDlvyInst = 85;
    const int DlvyInst = 86;
    const int AllocStatus = 87;
    const int AllocRejCode = 88;
    const int BrokerOfCredit = 92;
    const int EmailType = 94;
    const int StopPx = 99;
    const int ExDestination = 100;
    const int CxlRejReason = 102;
    const int OrdRejReason = 103;
    const int IOIQualifier = 104;
    const int WaveNo = 105;
    const int Issuer = 106;
    const int SecurityDesc = 107;
    const int ClientID = 109;
    const int MinQty = 110;
    const int MaxFloor = 111;
    const int ReportToExch = 113;
    const int LocateReqd = 114;
    const int QuoteID = 117;
    const int NetMoney = 118;
    const int SettlCurrAmt = 119;
    const int SettlCurrency = 120;
    const int ForexReq = 121;
    const int NoExecs = 124;
    const int CxlType = 125;
    const int ExpireTime = 126;
    const int DKReason = 127;
    const int IOINaturalFlag = 130;
    const int QuoteReqID = 131;
    const int BidPx = 132;
    const int OfferPx = 133;
    const int BidSize = 134;
    const int OfferSize = 135;
    const int NoMiscFees = 136;
    const int MiscFeeAmt = 137;
    const int MiscFeeCurr = 138;
    const int MiscFeeType = 139;
    const int PrevClosePx = 140;
    const int NoRelatedSym = 146;
    const int Subject = 147;
    const int Headline = 148;
    const int URLLink = 149;
    const int ExecType = 150;
    const int LeavesQty = 151;
    const int CashOrderQty = 152;
    const int AllocAvgPx = 153;
    const int AllocNetMoney = 154;
    const int SettlCurrFxRate = 155;
    const int SettlCurrFxRateCalc = 156;
    const int NumDaysInterest = 157;
    const int AccruedInterestRate = 158;
    const int AccruedInterestAmt = 159;
    const int SettlInstMode = 160;
    const int AllocText = 161;
    const int SettlInstID = 162;
    const int SettlInstTransType = 163;
    const int EmailThreadID = 164;
    const int SettlInstSource = 165;
    const int SettlLocation = 166;
    const int SecurityType = 167;
    const int EffectiveTime = 168;
    const int StandInstDbType = 169;
    const int StandInstDbName = 170;
    const int StandInstDbID = 171;
    const int SettlDeliveryType = 172;
    const int SettlDepositoryCode = 173;
    const int SettlBrkrCode = 174;
    const int SettlInstCode = 175;
    const int SecuritySettlAgentName = 176;
    const int SecuritySettlAgentCode = 177;
    const int SecuritySettlAgentAcctNum = 178;
    const int SecuritySettlAgentAcctName = 179;
    const int SecuritySettlAgentContactName = 180;
    const int SecuritySettlAgentContactPhone = 181;
    const int CashSettlAgentName = 182;
    const int CashSettlAgentCode = 183;
    const int CashSettlAgentAcctNum = 184;
    const int CashSettlAgentAcctName = 185;
    const int CashSettlAgentContactName = 186;
    const int CashSettlAgentContactPhone = 187;
    const int BidSpotRate = 188;
    const int BidForwardPoints = 189;
    const int OfferSpotRate = 190;
    const int OfferForwardPoints = 191;
    const int OrderQty2 = 192;
    const int FutSettDate2 = 193;
    const int LastSpotRate = 194;
    const int LastForwardPoints = 195;
    const int AllocLinkID = 196;
    const int AllocLinkType = 197;
    const int SecondaryOrderID = 198;
    const int NoIOIQualifiers = 199;
    const int MaturityMonthYear = 200;
    const int PutOrCall = 201;
    const int StrikePrice = 202;
    const int CoveredOrUncovered = 203;
    const int CustomerOrFirm = 204;
    const int MaturityDay = 205;
    const int OptAttribute = 206;
    const int SecurityExchange = 207;
    const int NotifyBrokerOfCredit = 208;
    const int AllocHandlInst = 209;
    const int MaxShow = 210;
    const int PegDifference = 211;
    const int SendingDate = 51;
    const int TotNoOrders = 68;
    const int SettlInstRefID = 214;
    const int NoRoutingIDs = 215;
    const int RoutingType = 216;
    const int RoutingID = 217;
    const int SpreadToBenchmark = 218;
    const int Benchmark = 219;
    const int CouponRate = 223;
    const int ContractMultiplier = 231;
    const int MDReqID = 262;
    const int SubscriptionRequestType = 263;
    const int MarketDepth = 264;
    const int MDUpdateType = 265;
    const int AggregatedBook = 266;
    const int NoMDEntryTypes = 267;
    const int NoMDEntries = 268;
    const int MDEntryType = 269;
    const int MDEntryPx = 270;
    const int MDEntrySize = 271;
    const int MDEntryDate = 272;
    const int MDEntryTime = 273;
    const int TickDirection = 274;
    const int MDMkt = 275;
    const int QuoteCondition = 276;
    const int TradeCondition = 277;
    const int MDEntryID = 278;
    const int MDUpdateAction = 279;
    const int MDEntryRefID = 280;
    const int MDReqRejReason = 281;
    const int MDEntryOriginator = 282;
    const int LocationID = 283;
    const int DeskID = 284;
    const int DeleteReason = 285;
    const int OpenCloseSettleFlag = 286;
    const int SellerDays = 287;
    const int MDEntryBuyer = 288;
    const int MDEntrySeller = 289;
    const int MDEntryPositionNo = 290;
    const int FinancialStatus = 291;
    const int CorporateAction = 292;
    const int DefBidSize = 293;
    const int DefOfferSize = 294;
    const int NoQuoteEntries = 295;
    const int NoQuoteSets = 296;
    const int QuoteAckStatus = 1865;
    const int QuoteCancelType = 298;
    const int QuoteEntryID = 299;
    const int QuoteRejectReason = 300;
    const int QuoteResponseLevel = 301;
    const int QuoteSetID = 302;
    const int QuoteRequestType = 303;
    const int TotQuoteEntries = 304;
    const int UnderlyingIDSource = 305;
    const int UnderlyingIssuer = 306;
    const int UnderlyingSecurityDesc = 307;
    const int UnderlyingSecurityExchange = 308;
    const int UnderlyingSecurityID = 309;
    const int UnderlyingSecurityType = 310;
    const int UnderlyingSymbol = 311;
    const int UnderlyingSymbolSfx = 312;
    const int UnderlyingMaturityMonthYear = 313;
    const int UnderlyingMaturityDay = 314;
    const int UnderlyingPutOrCall = 315;
    const int UnderlyingStrikePrice = 316;
    const int UnderlyingOptAttribute = 317;
    const int UnderlyingCurrency = 318;
    const int RatioQty = 319;
    const int SecurityReqID = 320;
    const int SecurityRequestType = 321;
    const int SecurityResponseID = 322;
    const int SecurityResponseType = 323;
    const int SecurityStatusReqID = 324;
    const int UnsolicitedIndicator = 325;
    const int SecurityTradingStatus = 326;
    const int HaltReasonChar = 327;
    const int InViewOfCommon = 328;
    const int DueToRelated = 329;
    const int BuyVolume = 330;
    const int SellVolume = 331;
    const int HighPx = 332;
    const int LowPx = 333;
    const int Adjustment = 334;
    const int TradSesReqID = 335;
    const int TradingSessionID = 336;
    const int ContraTrader = 337;
    const int TradSesMethod = 338;
    const int TradSesMode = 339;
    const int TradSesStatus = 340;
    const int TradSesStartTime = 341;
    const int TradSesOpenTime = 342;
    const int TradSesPreCloseTime = 343;
    const int TradSesCloseTime = 344;
    const int TradSesEndTime = 345;
    const int NumberOfOrders = 346;
    const int EncodedIssuerLen = 348;
    const int EncodedIssuer = 349;
    const int EncodedSecurityDescLen = 350;
    const int EncodedSecurityDesc = 351;
    const int EncodedListExecInstLen = 352;
    const int EncodedListExecInst = 353;
    const int EncodedSubjectLen = 356;
    const int EncodedSubject = 357;
    const int EncodedHeadlineLen = 358;
    const int EncodedHeadline = 359;
    const int EncodedAllocTextLen = 360;
    const int EncodedAllocText = 361;
    const int EncodedUnderlyingIssuerLen = 362;
    const int EncodedUnderlyingIssuer = 363;
    const int EncodedUnderlyingSecurityDescLen = 364;
    const int EncodedUnderlyingSecurityDesc = 365;
    const int AllocPrice = 366;
    const int QuoteSetValidUntilTime = 367;
    const int QuoteEntryRejectReason = 368;
    const int OnBehalfOfSendingTime = 370;
    const int BidRequestTransType = 374;
    const int ContraBroker = 375;
    const int ComplianceID = 376;
    const int SolicitedFlag = 377;
    const int ExecRestatementReason = 378;
    const int BusinessRejectRefID = 379;
    const int BusinessRejectReason = 380;
    const int GrossTradeAmt = 381;
    const int NoContraBrokers = 382;
    const int NoMsgTypes = 384;
    const int MsgDirection = 385;
    const int NoTradingSessions = 386;
    const int TotalVolumeTraded = 387;
    const int DiscretionInst = 388;
    const int DiscretionOffset = 389;
    const int BidID = 390;
    const int ClientBidID = 391;
    const int ListName = 392;
    const int TotalNumSecurities = 393;
    const int BidType = 394;
    const int NumTickets = 395;
    const int SideValue1 = 396;
    const int SideValue2 = 397;
    const int NoBidDescriptors = 398;
    const int BidDescriptorType = 399;
    const int BidDescriptor = 400;
    const int SideValueInd = 401;
    const int LiquidityPctLow = 402;
    const int LiquidityPctHigh = 403;
    const int LiquidityValue = 404;
    const int EFPTrackingError = 405;
    const int FairValue = 406;
    const int OutsideIndexPct = 407;
    const int ValueOfFutures = 408;
    const int LiquidityIndType = 409;
    const int WtAverageLiquidity = 410;
    const int ExchangeForPhysical = 411;
    const int OutMainCntryUIndex = 412;
    const int CrossPercent = 413;
    const int ProgRptReqs = 414;
    const int ProgPeriodInterval = 415;
    const int IncTaxInd = 416;
    const int NumBidders = 417;
    const int TradeType = 418;
    const int BasisPxType = 419;
    const int NoBidComponents = 420;
    const int Country = 421;
    const int TotNoStrikes = 422;
    const int PriceType = 423;
    const int DayOrderQty = 424;
    const int DayCumQty = 425;
    const int DayAvgPx = 426;
    const int GTBookingInst = 427;
    const int NoStrikes = 428;
    const int ListStatusType = 429;
    const int NetGrossInd = 430;
    const int ListOrderStatus = 431;
    const int ExpireDate = 432;
    const int ListExecInstType = 433;
    const int CxlRejResponseTo = 434;
    const int UnderlyingCouponRate = 435;
    const int UnderlyingContractMultiplier = 436;
    const int ContraTradeQty = 437;
    const int ContraTradeTime = 438;
    const int ClearingFirm = 439;
    const int ClearingAccount = 440;
    const int LiquidityNumSecurities = 441;
    const int MultiLegReportingType = 442;
    const int StrikeTime = 443;
    const int ListStatusText = 444;
    const int EncodedListStatusTextLen = 445;
    const int EncodedListStatusText = 446;
    const int SecurityIDSource = 22;
    const int IOIQty = 27;
    const int LastQty = 32;
    const int Quantity = 53;
    const int PositionEffect = 77;
    const int AllocQty = 80;
    const int Spread = 218;
    const int BenchmarkCurveCurrency = 220;
    const int BenchmarkCurveName = 221;
    const int BenchmarkCurvePoint = 222;
    const int CouponPaymentDate = 224;
    const int IssueDate = 225;
    const int RepurchaseTerm = 226;
    const int RepurchaseRate = 227;
    const int Factor = 228;
    const int TradeOriginationDate = 229;
    const int ExDate = 230;
    const int NoStipulations = 232;
    const int StipulationType = 233;
    const int StipulationValue = 234;
    const int YieldType = 235;
    const int Yield = 236;
    const int TotalTakedown = 237;
    const int Concession = 238;
    const int RepoCollateralSecurityType = 239;
    const int RedemptionDate = 240;
    const int UnderlyingCouponPaymentDate = 241;
    const int UnderlyingIssueDate = 242;
    const int UnderlyingRepoCollateralSecurityType = 243;
    const int UnderlyingRepurchaseTerm = 244;
    const int UnderlyingRepurchaseRate = 245;
    const int UnderlyingFactor = 246;
    const int UnderlyingRedemptionDate = 247;
    const int LegCouponPaymentDate = 248;
    const int LegIssueDate = 249;
    const int LegRepoCollateralSecurityType = 250;
    const int LegRepurchaseTerm = 251;
    const int LegRepurchaseRate = 252;
    const int LegFactor = 253;
    const int LegRedemptionDate = 254;
    const int CreditRating = 255;
    const int UnderlyingCreditRating = 256;
    const int LegCreditRating = 257;
    const int TradedFlatSwitch = 258;
    const int BasisFeatureDate = 259;
    const int BasisFeaturePrice = 260;
    const int QuoteStatus = 297;
    const int UnderlyingSecurityIDSource = 305;
    const int PartyIDSource = 447;
    const int PartyID = 448;
    const int TotalVolumeTradedDate = 449;
    const int TotalVolumeTradedTime = 450;
    const int NetChgPrevDay = 451;
    const int PartyRole = 452;
    const int NoPartyIDs = 453;
    const int NoSecurityAltID = 454;
    const int SecurityAltID = 455;
    const int SecurityAltIDSource = 456;
    const int NoUnderlyingSecurityAltID = 457;
    const int UnderlyingSecurityAltID = 458;
    const int UnderlyingSecurityAltIDSource = 459;
    const int Product = 460;
    const int CFICode = 461;
    const int UnderlyingProduct = 462;
    const int UnderlyingCFICode = 463;
    const int QuantityType = 465;
    const int BookingRefID = 466;
    const int IndividualAllocID = 467;
    const int RoundingDirection = 468;
    const int RoundingModulus = 469;
    const int CountryOfIssue = 470;
    const int StateOrProvinceOfIssue = 471;
    const int LocaleOfIssue = 472;
    const int NoRegistDtls = 473;
    const int MailingDtls = 474;
    const int InvestorCountryOfResidence = 475;
    const int PaymentRef = 476;
    const int DistribPaymentMethod = 477;
    const int CashDistribCurr = 478;
    const int CommCurrency = 479;
    const int CancellationRights = 480;
    const int MoneyLaunderingStatus = 481;
    const int MailingInst = 482;
    const int TransBkdTime = 483;
    const int ExecPriceType = 484;
    const int ExecPriceAdjustment = 485;
    const int DateOfBirth = 486;
    const int TradeReportTransType = 487;
    const int CardHolderName = 488;
    const int CardNumber = 489;
    const int CardExpDate = 490;
    const int CardIssNo = 491;
    const int PaymentMethod = 492;
    const int RegistAcctType = 493;
    const int Designation = 494;
    const int TaxAdvantageType = 495;
    const int RegistRejReasonText = 496;
    const int FundRenewWaiv = 497;
    const int CashDistribAgentName = 498;
    const int CashDistribAgentCode = 499;
    const int CashDistribAgentAcctNumber = 500;
    const int CashDistribPayRef = 501;
    const int CardStartDate = 503;
    const int PaymentDate = 504;
    const int PaymentRemitterID = 505;
    const int RegistStatus = 506;
    const int RegistRejReasonCode = 507;
    const int RegistRefID = 508;
    const int RegistDetls = 509;
    const int NoDistribInsts = 510;
    const int RegistEmail = 511;
    const int DistribPercentage = 512;
    const int RegistID = 513;
    const int RegistTransType = 514;
    const int ExecValuationPoint = 515;
    const int OrderPercent = 516;
    const int OwnershipType = 517;
    const int NoContAmts = 518;
    const int ContAmtType = 519;
    const int ContAmtValue = 520;
    const int ContAmtCurr = 521;
    const int OwnerType = 522;
    const int PartySubID = 523;
    const int NestedPartyID = 524;
    const int NestedPartyIDSource = 525;
    const int SecondaryClOrdID = 526;
    const int SecondaryExecID = 527;
    const int OrderCapacity = 528;
    const int OrderRestrictions = 529;
    const int MassCancelRequestType = 530;
    const int MassCancelResponse = 531;
    const int MassCancelRejectReason = 532;
    const int TotalAffectedOrders = 533;
    const int NoAffectedOrders = 534;
    const int AffectedOrderID = 535;
    const int AffectedSecondaryOrderID = 536;
    const int QuoteType = 537;
    const int NestedPartyRole = 538;
    const int NoNestedPartyIDs = 539;
    const int TotalAccruedInterestAmt = 540;
    const int MaturityDate = 541;
    const int UnderlyingMaturityDate = 542;
    const int InstrRegistry = 543;
    const int CashMargin = 544;
    const int NestedPartySubID = 545;
    const int Scope = 546;
    const int MDImplicitDelete = 547;
    const int CrossID = 548;
    const int CrossType = 549;
    const int CrossPrioritization = 550;
    const int OrigCrossID = 551;
    const int NoSides = 552;
    const int NoLegs = 555;
    const int LegCurrency = 556;
    const int TotalNumSecurityTypes = 557;
    const int NoSecurityTypes = 558;
    const int SecurityListRequestType = 559;
    const int SecurityRequestResult = 560;
    const int RoundLot = 561;
    const int MinTradeVol = 562;
    const int MultiLegRptTypeReq = 563;
    const int LegPositionEffect = 564;
    const int LegCoveredOrUncovered = 565;
    const int LegPrice = 566;
    const int TradSesStatusRejReason = 567;
    const int TradeRequestID = 568;
    const int TradeRequestType = 569;
    const int PreviouslyReported = 570;
    const int TradeReportID = 571;
    const int TradeReportRefID = 572;
    const int MatchStatus = 573;
    const int MatchType = 574;
    const int OddLot = 575;
    const int NoClearingInstructions = 576;
    const int ClearingInstruction = 577;
    const int TradeInputSource = 578;
    const int TradeInputDevice = 579;
    const int NoDates = 580;
    const int AccountType = 581;
    const int CustOrderCapacity = 582;
    const int ClOrdLinkID = 583;
    const int MassStatusReqID = 584;
    const int MassStatusReqType = 585;
    const int OrigOrdModTime = 586;
    const int LegSettlmntTyp = 587;
    const int LegFutSettDate = 588;
    const int DayBookingInst = 589;
    const int BookingUnit = 590;
    const int PreallocMethod = 591;
    const int UnderlyingCountryOfIssue = 592;
    const int UnderlyingStateOrProvinceOfIssue = 593;
    const int UnderlyingLocaleOfIssue = 594;
    const int UnderlyingInstrRegistry = 595;
    const int LegCountryOfIssue = 596;
    const int LegStateOrProvinceOfIssue = 597;
    const int LegLocaleOfIssue = 598;
    const int LegInstrRegistry = 599;
    const int LegSymbol = 600;
    const int LegSymbolSfx = 601;
    const int LegSecurityID = 602;
    const int LegSecurityIDSource = 603;
    const int NoLegSecurityAltID = 604;
    const int LegSecurityAltID = 605;
    const int LegSecurityAltIDSource = 606;
    const int LegProduct = 607;
    const int LegCFICode = 608;
    const int LegSecurityType = 609;
    const int LegMaturityMonthYear = 610;
    const int LegMaturityDate = 611;
    const int LegStrikePrice = 612;
    const int LegOptAttribute = 613;
    const int LegContractMultiplier = 614;
    const int LegCouponRate = 615;
    const int LegSecurityExchange = 616;
    const int LegIssuer = 617;
    const int EncodedLegIssuerLen = 618;
    const int EncodedLegIssuer = 619;
    const int LegSecurityDesc = 620;
    const int EncodedLegSecurityDescLen = 621;
    const int EncodedLegSecurityDesc = 622;
    const int LegRatioQty = 623;
    const int LegSide = 624;
    const int TradingSessionSubID = 625;
    const int AllocType = 626;
    const int MidPx = 631;
    const int BidYield = 632;
    const int MidYield = 633;
    const int OfferYield = 634;
    const int ClearingFeeIndicator = 635;
    const int WorkingIndicator = 636;
    const int LegLastPx = 637;
    const int PriorityIndicator = 638;
    const int PriceImprovement = 639;
    const int Price2 = 640;
    const int LastForwardPoints2 = 641;
    const int BidForwardPoints2 = 642;
    const int OfferForwardPoints2 = 643;
    const int RFQReqID = 644;
    const int MktBidPx = 645;
    const int MktOfferPx = 646;
    const int MinBidSize = 647;
    const int MinOfferSize = 648;
    const int QuoteStatusReqID = 649;
    const int LegalConfirm = 650;
    const int UnderlyingLastPx = 651;
    const int UnderlyingLastQty = 652;
    const int LegRefID = 654;
    const int ContraLegRefID = 655;
    const int SettlCurrBidFxRate = 656;
    const int SettlCurrOfferFxRate = 657;
    const int QuoteRequestRejectReason = 658;
    const int SideComplianceID = 659;
    const int IOIID = 23;
    const int NoLinesOfText = 33;
    const int SettlType = 63;
    const int SettlDate = 64;
    const int AvgPxPrecision = 74;
    const int SettlDate2 = 193;
    const int PegOffsetValue = 211;
    const int OpenCloseSettlFlag = 286;
    const int TotNoQuoteEntries = 304;
    const int DiscretionOffsetValue = 389;
    const int TotNoRelatedSym = 393;
    const int BidTradeType = 418;
    const int CardIssNum = 491;
    const int CashDistribAgentAcctName = 502;
    const int RegistDtls = 509;
    const int TotNoSecurityTypes = 557;
    const int LegSettlType = 587;
    const int LegSettlDate = 588;
    const int AcctIDSource = 660;
    const int AllocAcctIDSource = 661;
    const int BenchmarkPrice = 662;
    const int BenchmarkPriceType = 663;
    const int ConfirmID = 664;
    const int ConfirmStatus = 665;
    const int ConfirmTransType = 666;
    const int ContractSettlMonth = 667;
    const int DeliveryForm = 668;
    const int LastParPx = 669;
    const int NoLegAllocs = 670;
    const int LegAllocAccount = 671;
    const int LegIndividualAllocID = 672;
    const int LegAllocQty = 673;
    const int LegAllocAcctIDSource = 674;
    const int LegSettlCurrency = 675;
    const int LegBenchmarkCurveCurrency = 676;
    const int LegBenchmarkCurveName = 677;
    const int LegBenchmarkCurvePoint = 678;
    const int LegBenchmarkPrice = 679;
    const int LegBenchmarkPriceType = 680;
    const int LegBidPx = 681;
    const int LegIOIQty = 682;
    const int NoLegStipulations = 683;
    const int LegOfferPx = 684;
    const int LegPriceType = 686;
    const int LegQty = 687;
    const int LegStipulationType = 688;
    const int LegStipulationValue = 689;
    const int LegSwapType = 690;
    const int Pool = 691;
    const int QuotePriceType = 692;
    const int QuoteRespID = 693;
    const int QuoteRespType = 694;
    const int QuoteQualifier = 695;
    const int YieldRedemptionDate = 696;
    const int YieldRedemptionPrice = 697;
    const int YieldRedemptionPriceType = 698;
    const int BenchmarkSecurityID = 699;
    const int ReversalIndicator = 700;
    const int YieldCalcDate = 701;
    const int NoPositions = 702;
    const int PosType = 703;
    const int LongQty = 704;
    const int ShortQty = 705;
    const int PosQtyStatus = 706;
    const int PosAmtType = 707;
    const int PosAmt = 708;
    const int PosTransType = 709;
    const int PosReqID = 710;
    const int NoUnderlyings = 711;
    const int PosMaintAction = 712;
    const int OrigPosReqRefID = 713;
    const int PosMaintRptRefID = 714;
    const int ClearingBusinessDate = 715;
    const int SettlSessID = 716;
    const int SettlSessSubID = 717;
    const int AdjustmentType = 718;
    const int ContraryInstructionIndicator = 719;
    const int PriorSpreadIndicator = 720;
    const int PosMaintRptID = 721;
    const int PosMaintStatus = 722;
    const int PosMaintResult = 723;
    const int PosReqType = 724;
    const int ResponseTransportType = 725;
    const int ResponseDestination = 726;
    const int TotalNumPosReports = 727;
    const int PosReqResult = 728;
    const int PosReqStatus = 729;
    const int SettlPrice = 730;
    const int SettlPriceType = 731;
    const int UnderlyingSettlPrice = 732;
    const int UnderlyingSettlPriceType = 733;
    const int PriorSettlPrice = 734;
    const int NoQuoteQualifiers = 735;
    const int AllocSettlCurrency = 736;
    const int AllocSettlCurrAmt = 737;
    const int InterestAtMaturity = 738;
    const int LegDatedDate = 739;
    const int LegPool = 740;
    const int AllocInterestAtMaturity = 741;
    const int AllocAccruedInterestAmt = 742;
    const int DeliveryDate = 743;
    const int AssignmentMethod = 744;
    const int AssignmentUnit = 745;
    const int OpenInterest = 746;
    const int ExerciseMethod = 747;
    const int TotNumTradeReports = 748;
    const int TradeRequestResult = 749;
    const int TradeRequestStatus = 750;
    const int TradeReportRejectReason = 751;
    const int SideMultiLegReportingType = 752;
    const int NoPosAmt = 753;
    const int AutoAcceptIndicator = 754;
    const int AllocReportID = 755;
    const int NoNested2PartyIDs = 756;
    const int Nested2PartyID = 757;
    const int Nested2PartyIDSource = 758;
    const int Nested2PartyRole = 759;
    const int Nested2PartySubID = 760;
    const int BenchmarkSecurityIDSource = 761;
    const int SecuritySubType = 762;
    const int UnderlyingSecuritySubType = 763;
    const int LegSecuritySubType = 764;
    const int AllowableOneSidednessPct = 765;
    const int AllowableOneSidednessValue = 766;
    const int AllowableOneSidednessCurr = 767;
    const int NoTrdRegTimestamps = 768;
    const int TrdRegTimestamp = 769;
    const int TrdRegTimestampType = 770;
    const int TrdRegTimestampOrigin = 771;
    const int ConfirmRefID = 772;
    const int ConfirmType = 773;
    const int ConfirmRejReason = 774;
    const int BookingType = 775;
    const int IndividualAllocRejCode = 776;
    const int SettlInstMsgID = 777;
    const int NoSettlInst = 778;
    const int LastUpdateTime = 779;
    const int AllocSettlInstType = 780;
    const int NoSettlPartyIDs = 781;
    const int SettlPartyID = 782;
    const int SettlPartyIDSource = 783;
    const int SettlPartyRole = 784;
    const int SettlPartySubID = 785;
    const int SettlPartySubIDType = 786;
    const int DlvyInstType = 787;
    const int TerminationType = 788;
    const int OrdStatusReqID = 790;
    const int SettlInstReqID = 791;
    const int SettlInstReqRejCode = 792;
    const int SecondaryAllocID = 793;
    const int AllocReportType = 794;
    const int AllocReportRefID = 795;
    const int AllocCancReplaceReason = 796;
    const int CopyMsgIndicator = 797;
    const int AllocAccountType = 798;
    const int OrderAvgPx = 799;
    const int OrderBookingQty = 800;
    const int NoSettlPartySubIDs = 801;
    const int NoPartySubIDs = 802;
    const int PartySubIDType = 803;
    const int NoNestedPartySubIDs = 804;
    const int NestedPartySubIDType = 805;
    const int NoNested2PartySubIDs = 806;
    const int Nested2PartySubIDType = 807;
    const int AllocIntermedReqType = 808;
    const int UnderlyingPx = 810;
    const int PriceDelta = 811;
    const int ApplQueueMax = 812;
    const int ApplQueueDepth = 813;
    const int ApplQueueResolution = 814;
    const int ApplQueueAction = 815;
    const int NoAltMDSource = 816;
    const int AltMDSourceID = 817;
    const int SecondaryTradeReportID = 818;
    const int AvgPxIndicator = 819;
    const int TradeLinkID = 820;
    const int OrderInputDevice = 821;
    const int UnderlyingTradingSessionID = 822;
    const int UnderlyingTradingSessionSubID = 823;
    const int TradeLegRefID = 824;
    const int ExchangeRule = 825;
    const int TradeAllocIndicator = 826;
    const int ExpirationCycle = 827;
    const int TrdType = 828;
    const int TrdSubType = 829;
    const int TransferReason = 830;
    const int TotNumAssignmentReports = 832;
    const int AsgnRptID = 833;
    const int ThresholdAmount = 834;
    const int PegMoveType = 835;
    const int PegOffsetType = 836;
    const int PegLimitType = 837;
    const int PegRoundDirection = 838;
    const int PeggedPrice = 839;
    const int PegScope = 840;
    const int DiscretionMoveType = 841;
    const int DiscretionOffsetType = 842;
    const int DiscretionLimitType = 843;
    const int DiscretionRoundDirection = 844;
    const int DiscretionPrice = 845;
    const int DiscretionScope = 846;
    const int TargetStrategy = 847;
    const int TargetStrategyParameters = 848;
    const int ParticipationRate = 849;
    const int TargetStrategyPerformance = 850;
    const int LastLiquidityInd = 851;
    const int PublishTrdIndicator = 852;
    const int ShortSaleReason = 853;
    const int QtyType = 854;
    const int SecondaryTrdType = 855;
    const int TradeReportType = 856;
    const int AllocNoOrdersType = 857;
    const int SharedCommission = 858;
    const int ConfirmReqID = 859;
    const int AvgParPx = 860;
    const int ReportedPx = 861;
    const int NoCapacities = 862;
    const int OrderCapacityQty = 863;
    const int NoEvents = 864;
    const int EventType = 865;
    const int EventDate = 866;
    const int EventPx = 867;
    const int EventText = 868;
    const int PctAtRisk = 869;
    const int NoInstrAttrib = 870;
    const int InstrAttribType = 871;
    const int InstrAttribValue = 872;
    const int DatedDate = 873;
    const int InterestAccrualDate = 874;
    const int CPProgram = 875;
    const int CPRegType = 876;
    const int UnderlyingCPProgram = 877;
    const int UnderlyingCPRegType = 878;
    const int UnderlyingQty = 879;
    const int TrdMatchID = 880;
    const int SecondaryTradeReportRefID = 881;
    const int UnderlyingDirtyPrice = 882;
    const int UnderlyingEndPrice = 883;
    const int UnderlyingStartValue = 884;
    const int UnderlyingCurrentValue = 885;
    const int UnderlyingEndValue = 886;
    const int NoUnderlyingStips = 887;
    const int UnderlyingStipType = 888;
    const int UnderlyingStipValue = 889;
    const int MaturityNetMoney = 890;
    const int MiscFeeBasis = 891;
    const int TotNoAllocs = 892;
    const int LastFragment = 893;
    const int CollReqID = 894;
    const int CollAsgnReason = 895;
    const int CollInquiryQualifier = 896;
    const int NoTrades = 897;
    const int MarginRatio = 898;
    const int MarginExcess = 899;
    const int TotalNetValue = 900;
    const int CashOutstanding = 901;
    const int CollAsgnID = 902;
    const int CollAsgnTransType = 903;
    const int CollRespID = 904;
    const int CollAsgnRespType = 905;
    const int CollAsgnRejectReason = 906;
    const int CollAsgnRefID = 907;
    const int CollRptID = 908;
    const int CollInquiryID = 909;
    const int CollStatus = 910;
    const int TotNumReports = 911;
    const int LastRptRequested = 912;
    const int AgreementDesc = 913;
    const int AgreementID = 914;
    const int AgreementDate = 915;
    const int StartDate = 916;
    const int EndDate = 917;
    const int AgreementCurrency = 918;
    const int DeliveryType = 919;
    const int EndAccruedInterestAmt = 920;
    const int StartCash = 921;
    const int EndCash = 922;
    const int UserRequestID = 923;
    const int UserRequestType = 924;
    const int UserStatus = 926;
    const int UserStatusText = 927;
    const int StatusValue = 928;
    const int StatusText = 929;
    const int RefCompID = 930;
    const int RefSubID = 931;
    const int NetworkResponseID = 932;
    const int NetworkRequestID = 933;
    const int LastNetworkResponseID = 934;
    const int NetworkRequestType = 935;
    const int NoCompIDs = 936;
    const int NetworkStatusResponseType = 937;
    const int NoCollInquiryQualifier = 938;
    const int TrdRptStatus = 939;
    const int AffirmStatus = 940;
    const int UnderlyingStrikeCurrency = 941;
    const int LegStrikeCurrency = 942;
    const int TimeBracket = 943;
    const int CollAction = 944;
    const int CollInquiryStatus = 945;
    const int CollInquiryResult = 946;
    const int StrikeCurrency = 947;
    const int NoNested3PartyIDs = 948;
    const int Nested3PartyID = 949;
    const int Nested3PartyIDSource = 950;
    const int Nested3PartyRole = 951;
    const int NoNested3PartySubIDs = 952;
    const int Nested3PartySubID = 953;
    const int Nested3PartySubIDType = 954;
    const int LegContractSettlMonth = 955;
    const int LegInterestAccrualDate = 956;
    const int LegOrderQty = 685;
    const int NoStrategyParameters = 957;
    const int StrategyParameterName = 958;
    const int StrategyParameterType = 959;
    const int StrategyParameterValue = 960;
    const int HostCrossID = 961;
    const int SideTimeInForce = 962;
    const int MDReportID = 963;
    const int SecurityReportID = 964;
    const int SecurityStatus = 965;
    const int SettleOnOpenFlag = 966;
    const int StrikeMultiplier = 967;
    const int StrikeValue = 968;
    const int MinPriceIncrement = 969;
    const int PositionLimit = 970;
    const int NTPositionLimit = 971;
    const int UnderlyingAllocationPercent = 972;
    const int UnderlyingCashAmount = 973;
    const int UnderlyingCashType = 974;
    const int UnderlyingSettlementType = 975;
    const int QuantityDate = 976;
    const int ContIntRptID = 977;
    const int LateIndicator = 978;
    const int InputSource = 979;
    const int SecurityUpdateAction = 980;
    const int NoExpiration = 981;
    const int ExpType = 982;
    const int ExpQty = 983;
    const int NoUnderlyingAmounts = 984;
    const int UnderlyingPayAmount = 985;
    const int UnderlyingCollectAmount = 986;
    const int UnderlyingSettlementDate = 987;
    const int UnderlyingSettlementStatus = 988;
    const int SecondaryIndividualAllocID = 989;
    const int LegReportID = 990;
    const int RndPx = 991;
    const int IndividualAllocType = 992;
    const int AllocCustomerCapacity = 993;
    const int TierCode = 994;
    const int UnitofMeasure = 996;
    const int TimeUnit = 997;
    const int UnderlyingUnitofMeasure = 998;
    const int LegUnitofMeasure = 999;
    const int UnderlyingTimeUnit = 1000;
    const int LegTimeUnit = 1001;
    const int AllocMethod = 1002;
    const int TradeID = 1003;
    const int SideTradeReportID = 1005;
    const int SideFillStationCd = 1006;
    const int SideReasonCd = 1007;
    const int SideTrdSubTyp = 1008;
    const int SideQty = 1009;
    const int MessageEventSource = 1011;
    const int SideTrdRegTimestamp = 1012;
    const int SideTrdRegTimestampType = 1013;
    const int SideTrdRegTimestampSrc = 1014;
    const int AsOfIndicator = 1015;
    const int NoSideTrdRegTS = 1016;
    const int LegOptionRatio = 1017;
    const int NoInstrumentParties = 1018;
    const int InstrumentPartyID = 1019;
    const int TradeVolume = 1020;
    const int MDBookType = 1021;
    const int MDFeedType = 1022;
    const int MDPriceLevel = 1023;
    const int MDOriginType = 1024;
    const int FirstPx = 1025;
    const int MDEntrySpotRate = 1026;
    const int MDEntryForwardPoints = 1027;
    const int ManualOrderIndicator = 1028;
    const int CustDirectedOrder = 1029;
    const int ReceivedDeptID = 1030;
    const int CustOrderHandlingInst = 1031;
    const int OrderHandlingInstSource = 1032;
    const int DeskType = 1033;
    const int DeskTypeSource = 1034;
    const int DeskOrderHandlingInst = 1035;
    const int ExecAckStatus = 1036;
    const int UnderlyingDeliveryAmount = 1037;
    const int UnderlyingCapValue = 1038;
    const int UnderlyingSettlMethod = 1039;
    const int SecondaryTradeID = 1040;
    const int FirmTradeID = 1041;
    const int SecondaryFirmTradeID = 1042;
    const int CollApplType = 1043;
    const int UnderlyingAdjustedQuantity = 1044;
    const int UnderlyingFXRate = 1045;
    const int UnderlyingFXRateCalc = 1046;
    const int AllocPositionEffect = 1047;
    const int DealingCapacity = 1048;
    const int InstrmtAssignmentMethod = 1049;
    const int InstrumentPartyIDSource = 1050;
    const int InstrumentPartyRole = 1051;
    const int NoInstrumentPartySubIDs = 1052;
    const int InstrumentPartySubID = 1053;
    const int InstrumentPartySubIDType = 1054;
    const int PositionCurrency = 1055;
    const int CalculatedCcyLastQty = 1056;
    const int AggressorIndicator = 1057;
    const int NoUndlyInstrumentParties = 1058;
    const int UndlyInstrumentPartyID = 1059;
    const int UndlyInstrumentPartyIDSource = 1060;
    const int UndlyInstrumentPartyRole = 1061;
    const int NoUndlyInstrumentPartySubIDs = 1062;
    const int UndlyInstrumentPartySubID = 1063;
    const int UndlyInstrumentPartySubIDType = 1064;
    const int BidSwapPoints = 1065;
    const int OfferSwapPoints = 1066;
    const int LegBidForwardPoints = 1067;
    const int LegOfferForwardPoints = 1068;
    const int SwapPoints = 1069;
    const int MDQuoteType = 1070;
    const int LastSwapPoints = 1071;
    const int SideGrossTradeAmt = 1072;
    const int LegLastForwardPoints = 1073;
    const int LegCalculatedCcyLastQty = 1074;
    const int LegGrossTradeAmt = 1075;
    const int MaturityTime = 1079;
    const int RefOrderID = 1080;
    const int RefOrderIDSource = 1081;
    const int SecondaryDisplayQty = 1082;
    const int DisplayWhen = 1083;
    const int DisplayMethod = 1084;
    const int DisplayLowQty = 1085;
    const int DisplayHighQty = 1086;
    const int DisplayMinIncr = 1087;
    const int RefreshQty = 1088;
    const int MatchIncrement = 1089;
    const int MaxPriceLevels = 1090;
    const int PreTradeAnonymity = 1091;
    const int PriceProtectionScope = 1092;
    const int LotType = 1093;
    const int PegPriceType = 1094;
    const int PeggedRefPrice = 1095;
    const int PegSecurityIDSource = 1096;
    const int PegSecurityID = 1097;
    const int PegSymbol = 1098;
    const int PegSecurityDesc = 1099;
    const int TriggerType = 1100;
    const int TriggerAction = 1101;
    const int TriggerPrice = 1102;
    const int TriggerSymbol = 1103;
    const int TriggerSecurityID = 1104;
    const int TriggerSecurityIDSource = 1105;
    const int TriggerSecurityDesc = 1106;
    const int TriggerPriceType = 1107;
    const int TriggerPriceTypeScope = 1108;
    const int TriggerPriceDirection = 1109;
    const int TriggerNewPrice = 1110;
    const int TriggerOrderType = 1111;
    const int TriggerNewQty = 1112;
    const int TriggerTradingSessionID = 1113;
    const int TriggerTradingSessionSubID = 1114;
    const int OrderCategory = 1115;
    const int NoRootPartyIDs = 1116;
    const int RootPartyID = 1117;
    const int RootPartyIDSource = 1118;
    const int RootPartyRole = 1119;
    const int NoRootPartySubIDs = 1120;
    const int RootPartySubID = 1121;
    const int RootPartySubIDType = 1122;
    const int TradeHandlingInstr = 1123;
    const int OrigTradeHandlingInstr = 1124;
    const int OrigTradeDate = 1125;
    const int OrigTradeID = 1126;
    const int OrigSecondaryTradeID = 1127;
    const int TZTransactTime = 1132;
    const int ExDestinationIDSource = 1133;
    const int ReportedPxDiff = 1134;
    const int RptSys = 1135;
    const int AllocClearingFeeIndicator = 1136;
    const int DisplayQty = 1138;
    const int ExchangeSpecialInstructions = 1139;
    const int ExpirationQtyType = 982;
    const int UnitOfMeasure = 996;
    const int UnderlyingUnitOfMeasure = 998;
    const int LegUnitOfMeasure = 999;
    const int UnderlyingMaturityTime = 1213;
    const int LegMaturityTime = 1212;
    const int MaxTradeVol = 1140;
    const int NoMDFeedTypes = 1141;
    const int MatchAlgorithm = 1142;
    const int MaxPriceVariation = 1143;
    const int ImpliedMarketIndicator = 1144;
    const int EventTime = 1145;
    const int MinPriceIncrementAmount = 1146;
    const int UnitOfMeasureQty = 1147;
    const int LowLimitPrice = 1148;
    const int HighLimitPrice = 1149;
    const int TradingReferencePrice = 1150;
    const int SecurityGroup = 1151;
    const int LegNumber = 1152;
    const int SettlementCycleNo = 1153;
    const int SideCurrency = 1154;
    const int SideSettlCurrency = 1155;
    const int CcyAmt = 1157;
    const int NoSettlDetails = 1158;
    const int SettlObligMode = 1159;
    const int SettlObligMsgID = 1160;
    const int SettlObligID = 1161;
    const int SettlObligTransType = 1162;
    const int SettlObligRefID = 1163;
    const int SettlObligSource = 1164;
    const int NoSettlOblig = 1165;
    const int QuoteMsgID = 1166;
    const int QuoteEntryStatus = 1167;
    const int TotNoCxldQuotes = 1168;
    const int TotNoAccQuotes = 1169;
    const int TotNoRejQuotes = 1170;
    const int PrivateQuote = 1171;
    const int RespondentType = 1172;
    const int MDSubBookType = 1173;
    const int SecurityTradingEvent = 1174;
    const int NoStatsIndicators = 1175;
    const int StatsType = 1176;
    const int NoOfSecSizes = 1177;
    const int MDSecSizeType = 1178;
    const int MDSecSize = 1179;
    const int ApplID = 1180;
    const int ApplSeqNum = 1181;
    const int ApplBegSeqNum = 1182;
    const int ApplEndSeqNum = 1183;
    const int SecurityXMLLen = 1184;
    const int SecurityXML = 1185;
    const int SecurityXMLSchema = 1186;
    const int RefreshIndicator = 1187;
    const int Volatility = 1188;
    const int TimeToExpiration = 1189;
    const int RiskFreeRate = 1190;
    const int PriceUnitOfMeasure = 1191;
    const int PriceUnitOfMeasureQty = 1192;
    const int SettlMethod = 1193;
    const int ExerciseStyle = 1194;
    const int UnderlyingExerciseStyle = 1419;
    const int LegExerciseStyle = 1420;
    const int OptPayAmount = 1195;
    const int PriceQuoteMethod = 1196;
    const int FuturesValuationMethod = 1197;
    const int ListMethod = 1198;
    const int CapPrice = 1199;
    const int FloorPrice = 1200;
    const int NoStrikeRules = 1201;
    const int StartStrikePxRange = 1202;
    const int EndStrikePxRange = 1203;
    const int StrikeIncrement = 1204;
    const int NoTickRules = 1205;
    const int StartTickPriceRange = 1206;
    const int EndTickPriceRange = 1207;
    const int TickIncrement = 1208;
    const int TickRuleType = 1209;
    const int NestedInstrAttribType = 1210;
    const int NestedInstrAttribValue = 1211;
    const int DerivativeSymbol = 1214;
    const int DerivativeSymbolSfx = 1215;
    const int DerivativeSecurityID = 1216;
    const int DerivativeSecurityIDSource = 1217;
    const int NoDerivativeSecurityAltID = 1218;
    const int DerivativeSecurityAltID = 1219;
    const int DerivativeSecurityAltIDSource = 1220;
    const int SecondaryLowLimitPrice = 1221;
    const int SecondaryHighLimitPrice = 1230;
    const int MaturityRuleID = 1222;
    const int StrikeRuleID = 1223;
    const int DerivativeOptPayAmount = 1225;
    const int EndMaturityMonthYear = 1226;
    const int ProductComplex = 1227;
    const int DerivativeProductComplex = 1228;
    const int MaturityMonthYearIncrement = 1229;
    const int MinLotSize = 1231;
    const int NoExecInstRules = 1232;
    const int NoLotTypeRules = 1234;
    const int NoMatchRules = 1235;
    const int NoMaturityRules = 1236;
    const int NoOrdTypeRules = 1237;
    const int NoTimeInForceRules = 1239;
    const int SecondaryTradingReferencePrice = 1240;
    const int StartMaturityMonthYear = 1241;
    const int FlexProductEligibilityIndicator = 1242;
    const int DerivFlexProductEligibilityIndicator = 1243;
    const int FlexibleIndicator = 1244;
    const int TradingCurrency = 1245;
    const int DerivativeProduct = 1246;
    const int DerivativeSecurityGroup = 1247;
    const int DerivativeCFICode = 1248;
    const int DerivativeSecurityType = 1249;
    const int DerivativeSecuritySubType = 1250;
    const int DerivativeMaturityMonthYear = 1251;
    const int DerivativeMaturityDate = 1252;
    const int DerivativeMaturityTime = 1253;
    const int DerivativeSettleOnOpenFlag = 1254;
    const int DerivativeInstrmtAssignmentMethod = 1255;
    const int DerivativeSecurityStatus = 1256;
    const int DerivativeInstrRegistry = 1257;
    const int DerivativeCountryOfIssue = 1258;
    const int DerivativeStateOrProvinceOfIssue = 1259;
    const int DerivativeLocaleOfIssue = 1260;
    const int DerivativeStrikePrice = 1261;
    const int DerivativeStrikeCurrency = 1262;
    const int DerivativeStrikeMultiplier = 1263;
    const int DerivativeStrikeValue = 1264;
    const int DerivativeOptAttribute = 1265;
    const int DerivativeContractMultiplier = 1266;
    const int DerivativeMinPriceIncrement = 1267;
    const int DerivativeMinPriceIncrementAmount = 1268;
    const int DerivativeUnitOfMeasure = 1269;
    const int DerivativeUnitOfMeasureQty = 1270;
    const int DerivativeTimeUnit = 1271;
    const int DerivativeSecurityExchange = 1272;
    const int DerivativePositionLimit = 1273;
    const int DerivativeNTPositionLimit = 1274;
    const int DerivativeIssuer = 1275;
    const int DerivativeIssueDate = 1276;
    const int DerivativeEncodedIssuerLen = 1277;
    const int DerivativeEncodedIssuer = 1278;
    const int DerivativeSecurityDesc = 1279;
    const int DerivativeEncodedSecurityDescLen = 1280;
    const int DerivativeEncodedSecurityDesc = 1281;
    const int DerivativeSecurityXMLLen = 1282;
    const int DerivativeSecurityXML = 1283;
    const int DerivativeSecurityXMLSchema = 1284;
    const int DerivativeContractSettlMonth = 1285;
    const int NoDerivativeEvents = 1286;
    const int DerivativeEventType = 1287;
    const int DerivativeEventDate = 1288;
    const int DerivativeEventTime = 1289;
    const int DerivativeEventPx = 1290;
    const int DerivativeEventText = 1291;
    const int NoDerivativeInstrumentParties = 1292;
    const int DerivativeInstrumentPartyID = 1293;
    const int DerivativeInstrumentPartyIDSource = 1294;
    const int DerivativeInstrumentPartyRole = 1295;
    const int NoDerivativeInstrumentPartySubIDs = 1296;
    const int DerivativeInstrumentPartySubID = 1297;
    const int DerivativeInstrumentPartySubIDType = 1298;
    const int DerivativeExerciseStyle = 1299;
    const int MarketSegmentID = 1300;
    const int MarketID = 1301;
    const int MaturityMonthYearIncrementUnits = 1302;
    const int MaturityMonthYearFormat = 1303;
    const int StrikeExerciseStyle = 1304;
    const int SecondaryPriceLimitType = 1305;
    const int PriceLimitType = 1306;
    const int ExecInstValue = 1308;
    const int NoTradingSessionRules = 1309;
    const int NoMarketSegments = 1310;
    const int NoDerivativeInstrAttrib = 1311;
    const int NoNestedInstrAttrib = 1312;
    const int DerivativeInstrAttribType = 1313;
    const int DerivativeInstrAttribValue = 1314;
    const int DerivativePriceUnitOfMeasure = 1315;
    const int DerivativePriceUnitOfMeasureQty = 1316;
    const int DerivativeSettlMethod = 1317;
    const int DerivativePriceQuoteMethod = 1318;
    const int DerivativeFuturesValuationMethod = 1319;
    const int DerivativeListMethod = 1320;
    const int DerivativeCapPrice = 1321;
    const int DerivativeFloorPrice = 1322;
    const int DerivativePutOrCall = 1323;
    const int ListUpdateAction = 1324;
    const int LegPutOrCall = 1358;
    const int LegUnitOfMeasureQty = 1224;
    const int LegPriceUnitOfMeasure = 1421;
    const int LegPriceUnitOfMeasureQty = 1422;
    const int UnderlyingUnitOfMeasureQty = 1423;
    const int UnderlyingPriceUnitOfMeasure = 1424;
    const int UnderlyingPriceUnitOfMeasureQty = 1425;
    const int MarketReqID = 1393;
    const int MarketReportID = 1394;
    const int MarketUpdateAction = 1395;
    const int MarketSegmentDesc = 1396;
    const int EncodedMktSegmDescLen = 1397;
    const int EncodedMktSegmDesc = 1398;
    const int ParentMktSegmID = 1325;
    const int TradingSessionDesc = 1326;
    const int TradSesUpdateAction = 1327;
    const int RejectText = 1328;
    const int FeeMultiplier = 1329;
    const int UnderlyingLegSymbol = 1330;
    const int UnderlyingLegSymbolSfx = 1331;
    const int UnderlyingLegSecurityID = 1332;
    const int UnderlyingLegSecurityIDSource = 1333;
    const int NoUnderlyingLegSecurityAltID = 1334;
    const int UnderlyingLegSecurityAltID = 1335;
    const int UnderlyingLegSecurityAltIDSource = 1336;
    const int UnderlyingLegSecurityType = 1337;
    const int UnderlyingLegSecuritySubType = 1338;
    const int UnderlyingLegMaturityMonthYear = 1339;
    const int UnderlyingLegPutOrCall = 1343;
    const int UnderlyingLegStrikePrice = 1340;
    const int UnderlyingLegSecurityExchange = 1341;
    const int NoOfLegUnderlyings = 1342;
    const int UnderlyingLegCFICode = 1344;
    const int UnderlyingLegMaturityDate = 1345;
    const int UnderlyingLegMaturityTime = 1405;
    const int UnderlyingLegOptAttribute = 1391;
    const int UnderlyingLegSecurityDesc = 1392;
    const int DefaultVerIndicator = 1410;
    const int NoUsernames = 809;
    const int LegAllocSettlCurrency = 1367;
    const int TotNoFills = 1361;
    const int NoFills = 1362;
    const int FillExecID = 1363;
    const int FillPx = 1364;
    const int FillQty = 1365;
    const int LegAllocID = 1366;
    const int TradSesEvent = 1368;
    const int MassActionReportID = 1369;
    const int NoNotAffectedOrders = 1370;
    const int NotAffectedOrderID = 1371;
    const int NotAffOrigClOrdID = 1372;
    const int MassActionType = 1373;
    const int MassActionScope = 1374;
    const int MassActionResponse = 1375;
    const int MassActionRejectReason = 1376;
    const int MultilegModel = 1377;
    const int MultilegPriceMethod = 1378;
    const int LegVolatility = 1379;
    const int DividendYield = 1380;
    const int LegDividendYield = 1381;
    const int CurrencyRatio = 1382;
    const int LegCurrencyRatio = 1383;
    const int LegExecInst = 1384;
    const int ContingencyType = 1385;
    const int ListRejectReason = 1386;
    const int NoTrdRepIndicators = 1387;
    const int TrdRepPartyRole = 1388;
    const int TrdRepIndicator = 1389;
    const int TradePublishIndicator = 1390;
    const int ApplReqID = 1346;
    const int ApplReqType = 1347;
    const int ApplResponseType = 1348;
    const int ApplTotalMessageCount = 1349;
    const int ApplLastSeqNum = 1350;
    const int NoApplIDs = 1351;
    const int ApplResendFlag = 1352;
    const int ApplResponseID = 1353;
    const int ApplResponseError = 1354;
    const int RefApplID = 1355;
    const int ApplReportID = 1356;
    const int RefApplLastSeqNum = 1357;
    const int ApplNewSeqNum = 1399;
    const int ApplReportType = 1426;
    const int Nested4PartySubIDType = 1411;
    const int Nested4PartySubID = 1412;
    const int NoNested4PartySubIDs = 1413;
    const int NoNested4PartyIDs = 1414;
    const int Nested4PartyID = 1415;
    const int Nested4PartyIDSource = 1416;
    const int Nested4PartyRole = 1417;
    const int LegLastQty = 1418;
    const int HaltReasonInt = 327;
    const int SideTrdSubType = 1008;
    const int SideLastQty = 1009;
    const int UnderlyingInstrumentPartyID = 1059;
    const int UnderlyingInstrumentPartyIDSource = 1060;
    const int UnderlyingInstrumentPartyRole = 1061;
    const int UnderlyingInstrumentPartySubID = 1063;
    const int UnderlyingInstrumentPartySubIDType = 1064;
    const int OptPayoutAmount = 1195;
    const int ValuationMethod = 1197;
    const int DerivativeValuationMethod = 1319;
    const int SideExecID = 1427;
    const int OrderDelay = 1428;
    const int OrderDelayUnit = 1429;
    const int VenueType = 1430;
    const int RefOrdIDReason = 1431;
    const int OrigCustOrderCapacity = 1432;
    const int RefApplReqID = 1433;
    const int ModelType = 1434;
    const int ContractMultiplierUnit = 1435;
    const int LegContractMultiplierUnit = 1436;
    const int UnderlyingContractMultiplierUnit = 1437;
    const int DerivativeContractMultiplierUnit = 1438;
    const int FlowScheduleType = 1439;
    const int LegFlowScheduleType = 1440;
    const int UnderlyingFlowScheduleType = 1441;
    const int DerivativeFlowScheduleType = 1442;
    const int FillLiquidityInd = 1443;
    const int SideLiquidityInd = 1444;
    const int NoRateSources = 1445;
    const int RateSource = 1446;
    const int RateSourceType = 1447;
    const int ReferencePage = 1448;
    const int RestructuringType = 1449;
    const int Seniority = 1450;
    const int NotionalPercentageOutstanding = 1451;
    const int OriginalNotionalPercentageOutstanding = 1452;
    const int UnderlyingRestructuringType = 1453;
    const int UnderlyingSeniority = 1454;
    const int UnderlyingNotionalPercentageOutstanding = 1455;
    const int UnderlyingOriginalNotionalPercentageOutstanding = 1456;
    const int AttachmentPoint = 1457;
    const int DetachmentPoint = 1458;
    const int UnderlyingAttachmentPoint = 1459;
    const int UnderlyingDetachmentPoint = 1460;
    const int NoTargetPartyIDs = 1461;
    const int TargetPartyID = 1462;
    const int TargetPartyIDSource = 1463;
    const int TargetPartyRole = 1464;
    const int SecurityListID = 1465;
    const int SecurityListRefID = 1466;
    const int SecurityListDesc = 1467;
    const int EncodedSecurityListDescLen = 1468;
    const int EncodedSecurityListDesc = 1469;
    const int SecurityListType = 1470;
    const int SecurityListTypeSource = 1471;
    const int NewsID = 1472;
    const int NewsCategory = 1473;
    const int LanguageCode = 1474;
    const int NoNewsRefIDs = 1475;
    const int NewsRefID = 1476;
    const int NewsRefType = 1477;
    const int StrikePriceDeterminationMethod = 1478;
    const int StrikePriceBoundaryMethod = 1479;
    const int StrikePriceBoundaryPrecision = 1480;
    const int UnderlyingPriceDeterminationMethod = 1481;
    const int OptPayoutType = 1482;
    const int NoComplexEvents = 1483;
    const int ComplexEventType = 1484;
    const int ComplexOptPayoutAmount = 1485;
    const int ComplexEventPrice = 1486;
    const int ComplexEventPriceBoundaryMethod = 1487;
    const int ComplexEventPriceBoundaryPrecision = 1488;
    const int ComplexEventPriceTimeType = 1489;
    const int ComplexEventCondition = 1490;
    const int NoComplexEventDates = 1491;
    const int ComplexEventStartDate = 1492;
    const int ComplexEventEndDate = 1493;
    const int NoComplexEventTimes = 1494;
    const int ComplexEventStartTime = 1495;
    const int ComplexEventEndTime = 1496;
    const int StreamAsgnReqID = 1497;
    const int StreamAsgnReqType = 1498;
    const int NoAsgnReqs = 1499;
    const int MDStreamID = 1500;
    const int StreamAsgnRptID = 1501;
    const int StreamAsgnRejReason = 1502;
    const int StreamAsgnAckType = 1503;
    const int StreamAsgnType = 1617;
    const int RelSymTransactTime = 1504;
    const int FillYieldType = 1622;
    const int FillYield = 1623;
    const int NoMatchInst = 1624;
    const int MatchInst = 1625;
    const int MatchAttribTagID = 1626;
    const int MatchAttribValue = 1627;
    const int MatchInstMarketID = 1673;
    const int TriggerScope = 1628;
    const int ExposureDuration = 1629;
    const int NoLimitAmts = 1630;
    const int LimitAmtType = 1631;
    const int LastLimitAmt = 1632;
    const int LimitAmtRemaining = 1633;
    const int LimitAmtCurrency = 1634;
    const int MarginReqmtInqID = 1635;
    const int NoMarginReqmtInqQualifier = 1636;
    const int MarginReqmtInqQualifier = 1637;
    const int MarginReqmtRptType = 1638;
    const int MarginClass = 1639;
    const int MarginReqmtInqStatus = 1640;
    const int MarginReqmtInqResult = 1641;
    const int MarginReqmtRptID = 1642;
    const int NoMarginAmt = 1643;
    const int MarginAmtType = 1644;
    const int MarginAmt = 1645;
    const int MarginAmtCcy = 1646;
    const int NoRelatedInstruments = 1647;
    const int RelatedInstrumentType = 1648;
    const int RelatedSymbol = 1649;
    const int RelatedSecurityID = 1650;
    const int RelatedSecurityIDSource = 1651;
    const int RelatedSecurityType = 1652;
    const int RelatedMaturityMonthYear = 1653;
    const int CoveredQty = 1654;
    const int MarketMakerActivity = 1655;
    const int PartyDetailsListRequestID = 1505;
    const int NoRequestedPartyRoles = 1508;
    const int RequestedPartyRole = 1509;
    const int PartyDetailsListReportID = 1510;
    const int RequestResult = 1511;
    const int TotNoParties = 1512;
    const int NoPartyRelationships = 1514;
    const int PartyRelationship = 1515;
    const int NoPartyDetailAltID = 1516;
    const int PartyDetailAltID = 1517;
    const int PartyDetailAltIDSource = 1518;
    const int NoPartyDetailAltSubIDs = 1519;
    const int PartyDetailAltSubID = 1520;
    const int PartyDetailAltSubIDType = 1521;
    const int NoRiskLimitTypes = 1529;
    const int RiskLimitType = 1530;
    const int RiskLimitAmount = 1531;
    const int RiskLimitCurrency = 1532;
    const int RiskLimitPlatform = 1533;
    const int NoRiskInstrumentScopes = 1534;
    const int InstrumentScopeOperator = 1535;
    const int InstrumentScopeSymbol = 1536;
    const int InstrumentScopeSymbolSfx = 1537;
    const int InstrumentScopeSecurityID = 1538;
    const int InstrumentScopeSecurityIDSource = 1539;
    const int NoInstrumentScopeSecurityAltID = 1540;
    const int InstrumentScopeSecurityAltID = 1541;
    const int InstrumentScopeSecurityAltIDSource = 1542;
    const int InstrumentScopeProduct = 1543;
    const int InstrumentScopeProductComplex = 1544;
    const int InstrumentScopeSecurityGroup = 1545;
    const int InstrumentScopeCFICode = 1546;
    const int InstrumentScopeSecurityType = 1547;
    const int InstrumentScopeSecuritySubType = 1548;
    const int InstrumentScopeMaturityMonthYear = 1549;
    const int InstrumentScopeMaturityTime = 1550;
    const int InstrumentScopeRestructuringType = 1551;
    const int InstrumentScopeSeniority = 1552;
    const int InstrumentScopePutOrCall = 1553;
    const int InstrumentScopeFlexibleIndicator = 1554;
    const int InstrumentScopeCouponRate = 1555;
    const int InstrumentScopeSecurityDesc = 1556;
    const int InstrumentScopeSettlType = 1557;
    const int RiskInstrumentMultiplier = 1558;
    const int NoRiskWarningLevels = 1559;
    const int RiskWarningLevelPercent = 1560;
    const int RiskWarningLevelName = 1561;
    const int NoRelatedPartyDetailID = 1562;
    const int RelatedPartyDetailID = 1563;
    const int RelatedPartyDetailIDSource = 1564;
    const int RelatedPartyDetailRole = 1565;
    const int NoRelatedPartyDetailSubIDs = 1566;
    const int RelatedPartyDetailSubID = 1567;
    const int RelatedPartyDetailSubIDType = 1568;
    const int NoRelatedPartyDetailAltID = 1569;
    const int RelatedPartyDetailAltID = 1570;
    const int RelatedPartyDetailAltIDSource = 1571;
    const int NoRelatedPartyDetailAltSubIDs = 1572;
    const int RelatedPartyDetailAltSubID = 1573;
    const int RelatedPartyDetailAltSubIDType = 1574;
    const int InstrumentScopeSecurityExchange = 1616;
    const int InstrumentScopeEncodedSecurityDescLen = 1620;
    const int InstrumentScopeEncodedSecurityDesc = 1621;
    const int NoInstrumentScopes = 1656;
    const int NoRequestingPartyIDs = 1657;
    const int RequestingPartyID = 1658;
    const int RequestingPartyIDSource = 1659;
    const int RequestingPartyRole = 1660;
    const int NoRequestingPartySubIDs = 1661;
    const int RequestingPartySubID = 1662;
    const int RequestingPartySubIDType = 1663;
    const int EncodedRejectTextLen = 1664;
    const int EncodedRejectText = 1665;
    const int RiskLimitRequestID = 1666;
    const int RiskLimitReportID = 1667;
    const int NoRequestedRiskLimitType = 1668;
    const int NoRiskLimits = 1669;
    const int RiskLimitID = 1670;
    const int NoPartyDetails = 1671;
    const int PartyDetailStatus = 1672;
    const int PartyDetailRoleQualifier = 1674;
    const int RelatedPartyDetailRoleQualifier = 1675;
    const int NoPartyUpdates = 1676;
    const int NoPartyRiskLimits = 1677;
    const int PartyDetailID = 1691;
    const int PartyDetailIDSource = 1692;
    const int PartyDetailRole = 1693;
    const int NoPartyDetailSubIDs = 1694;
    const int PartyDetailSubID = 1695;
    const int PartyDetailSubIDType = 1696;
    const int SecurityMassTradingStatus = 1679;
    const int SecurityMassTradingEvent = 1680;
    const int MassHaltReason = 1681;
    const int MDSecurityTradingStatus = 1682;
    const int MDSubFeedType = 1683;
    const int MDHaltReason = 1684;
    const int SideTradeID = 1506;
    const int SideOrigTradeID = 1507;
    const int DifferentialPrice = 1522;
    const int TrdAckStatus = 1523;
    const int PriceQuoteCurrency = 1524;
    const int UnderlyingPriceQuoteCurrency = 1526;
    const int LegPriceQuoteCurrency = 1528;
    const int DerivativePriceQuoteCurrency = 1576;
    const int NoSecurityClassifications = 1582;
    const int SecurityClassificationReason = 1583;
    const int SecurityClassificationValue = 1584;
    const int PosAmtReason = 1585;
    const int NoLegPosAmt = 1586;
    const int LegPosAmt = 1587;
    const int LegPosAmtType = 1588;
    const int LegPosCurrency = 1589;
    const int LegPosAmtReason = 1590;
    const int LegQtyType = 1591;
    const int DiscountFactor = 1592;
    const int ParentAllocID = 1593;
    const int LegSecurityGroup = 1594;
    const int PositionContingentPrice = 1595;
    const int ClearingTradePrice = 1596;
    const int SideClearingTradePrice = 1597;
    const int SideClearingTradePriceType = 1598;
    const int SidePriceDifferential = 1599;
    const int FIXEngineName = 1600;
    const int FIXEngineVersion = 1601;
    const int FIXEngineVendor = 1602;
    const int ApplicationSystemName = 1603;
    const int ApplicationSystemVersion = 1604;
    const int ApplicationSystemVendor = 1605;
    const int NumOfSimpleInstruments = 1606;
    const int SecurityRejectReason = 1607;
    const int InitialDisplayQty = 1608;
    const int ThrottleStatus = 1609;
    const int NoThrottles = 1610;
    const int ThrottleAction = 1611;
    const int ThrottleType = 1612;
    const int ThrottleNoMsgs = 1613;
    const int ThrottleTimeInterval = 1614;
    const int ThrottleTimeUnit = 1615;
    const int NoThrottleMsgType = 1618;
    const int ThrottleMsgType = 1619;
    const int ThrottleInst = 1685;
    const int ThrottleCountIndicator = 1686;
    const int AccountSummaryReportID = 1699;
    const int NoSettlementAmounts = 1700;
    const int SettlementAmount = 1701;
    const int SettlementAmountCurrency = 1702;
    const int NoCollateralAmounts = 1703;
    const int CurrentCollateralAmount = 1704;
    const int CollateralCurrency = 1705;
    const int CollateralType = 1706;
    const int NoPayCollects = 1707;
    const int PayAmount = 1710;
    const int CollectAmount = 1711;
    const int PayCollectType = 1708;
    const int PayCollectCurrency = 1709;
    const int PayCollectMarketSegmentID = 1712;
    const int PayCollectMarketID = 1713;
    const int MarginAmountMarketSegmentID = 1714;
    const int MarginAmountMarketID = 1715;
    const int FirmGroupID = 1728;
    const int FirmMnemonic = 1729;
    const int AllocGroupID = 1730;
    const int AvgPxGroupID = 1731;
    const int FirmAllocText = 1732;
    const int EncodedFirmAllocTextLen = 1733;
    const int EncodedFirmAllocText = 1734;
    const int AllocationRollupInstruction = 1735;
    const int AllocGroupQuantity = 1736;
    const int AllocGroupRemainingQuantity = 1737;
    const int AllocReversalStatus = 1738;
    const int ObligationType = 1739;
    const int TradePriceNegotiationMethod = 1740;
    const int UpfrontPriceType = 1741;
    const int UpfrontPrice = 1742;
    const int LastUpfrontPrice = 1743;
    const int ShortSaleRestriction = 1687;
    const int ShortSaleExemptionReason = 1688;
    const int LegShortSaleExemptionReason = 1689;
    const int SideShortSaleExemptionReason = 1690;
    const int UnitOfMeasureCurrency = 1716;
    const int PriceUnitOfMeasureCurrency = 1717;
    const int UnderlyingUnitOfMeasureCurrency = 1718;
    const int UnderlyingPriceUnitOfMeasureCurrency = 1719;
    const int LegUnitOfMeasureCurrency = 1720;
    const int LegPriceUnitOfMeasureCurrency = 1721;
    const int DerivativeUnitOfMeasureCurrency = 1722;
    const int DerivativePriceUnitOfMeasureCurrency = 1723;
    const int ApplLevelRecoveryIndicator = 1744;
    const int BidMDEntryID = 1745;
    const int OfferMDEntryID = 1746;
    const int BidQuoteID = 1747;
    const int OfferQuoteID = 1748;
    const int TotalBidSize = 1749;
    const int TotalOfferSize = 1750;
    const int SecondaryQuoteID = 1751;
    const int CustodialLotID = 1752;
    const int VersusPurchaseDate = 1753;
    const int VersusPurchasePrice = 1754;
    const int CurrentCostBasis = 1755;
    const int LegCustodialLotID = 1756;
    const int LegVersusPurchaseDate = 1757;
    const int LegVersusPurchasePrice = 1758;
    const int LegCurrentCostBasis = 1759;
    const int RiskLimitRequestType = 1760;
    const int RiskLimitRequestResult = 1761;
    const int RiskLimitRequestStatus = 1762;
    const int RiskLimitStatus = 1763;
    const int RiskLimitResult = 1764;
    const int RiskLimitUtilizationPercent = 1765;
    const int RiskLimitUtilizationAmount = 1766;
    const int RiskLimitAction = 1767;
    const int RiskWarningLevelAmount = 1768;
    const int RiskWarningLevelAction = 1769;
    const int EntitlementRequestID = 1770;
    const int EntitlementReportID = 1771;
    const int NoPartyEntitlements = 1772;
    const int NoEntitlements = 1773;
    const int EntitlementIndicator = 1774;
    const int EntitlementType = 1775;
    const int EntitlementID = 1776;
    const int NoEntitlementAttrib = 1777;
    const int EntitlementAttribType = 1778;
    const int EntitlementAttribDatatype = 1779;
    const int EntitlementAttribValue = 1780;
    const int EntitlementAttribCurrency = 1781;
    const int EntitlementStartDate = 1782;
    const int EntitlementEndDate = 1783;
    const int EntitlementPlatform = 1784;
    const int TradSesControl = 1785;
    const int TradeVolType = 1786;
    const int RefTickTableID = 1787;
    const int LegID = 1788;
    const int NoTargetMarketSegments = 1789;
    const int TargetMarketSegmentID = 1790;
    const int NoAffectedMarketSegments = 1791;
    const int AffectedMarketSegmentID = 1792;
    const int NoNotAffectedMarketSegments = 1793;
    const int NotAffectedMarketSegmentID = 1794;
    const int NoOrderEvents = 1795;
    const int OrderEventType = 1796;
    const int OrderEventExecID = 1797;
    const int OrderEventReason = 1798;
    const int OrderEventPx = 1799;
    const int OrderEventQty = 1800;
    const int OrderEventLiquidityIndicator = 1801;
    const int OrderEventText = 1802;
    const int AuctionType = 1803;
    const int AuctionAllocationPct = 1804;
    const int AuctionInstruction = 1805;
    const int RefClOrdID = 1806;
    const int LockType = 1807;
    const int LockedQty = 1808;
    const int SecondaryLockedQty = 1809;
    const int ReleaseInstruction = 1810;
    const int ReleaseQty = 1811;
    const int NoDisclosureInstructions = 1812;
    const int DisclosureType = 1813;
    const int DisclosureInstruction = 1814;
    const int TradingCapacity = 1815;
    const int ClearingAccountType = 1816;
    const int LegClearingAccountType = 1817;
    const int TargetPartyRoleQualifier = 1818;
    const int RelatedHighPrice = 1819;
    const int RelatedLowPrice = 1820;
    const int RelatedPriceSource = 1821;
    const int MinQtyMethod = 1822;
    const int Triggered = 1823;
    const int AffectedOrigClOrdID = 1824;
    const int NotAffSecondaryOrderID = 1825;
    const int NoCrossLegs = 1829;
    const int EventTimePeriod = 1826;
    const int EventTimeUnit = 1827;
    const int LastQtyVariance = 1828;
    const int OrderOrigination = 1724;
    const int OriginatingDeptID = 1725;
    const int ReceivingDeptID = 1726;
    const int InformationBarrierID = 1727;
    const int SettlPriceIncrement = 1830;
    const int SettlPriceSecondaryIncrement = 1831;
    const int ClearedIndicator = 1832;
    const int ContractRefPosType = 1833;
    const int PositionCapacity = 1834;
    const int PosQtyUnitOfMeasureCurrency = 1835;
    const int PosQtyUnitOfMeasure = 1836;
    const int UnderlyingContractPriceRefMonth = 1837;
    const int NoTradePriceConditions = 1838;
    const int TradePriceCondition = 1839;
    const int TradeAllocStatus = 1840;
    const int NoTradeQtys = 1841;
    const int TradeQtyType = 1842;
    const int TradeQty = 1843;
    const int NoTradeAllocAmts = 1844;
    const int TradeAllocAmtType = 1845;
    const int TradeAllocAmt = 1846;
    const int TradeAllocCurrency = 1847;
    const int TradeAllocGroupInstruction = 1848;
    const int OffsetInstruction = 1849;
    const int TradeAllocAmtReason = 1850;
    const int StrategyLinkID = 1851;
    const int SideAvgPx = 1852;
    const int SideAvgPxIndicator = 1853;
    const int SideAvgPxGroupID = 1854;
    const int NoRelatedTrades = 1855;
    const int RelatedTradeID = 1856;
    const int RelatedTradeIDSource = 1857;
    const int RelatedTradeDate = 1858;
    const int RelatedTradeMarketID = 1859;
    const int RelatedTradeQuantity = 1860;
    const int NoRelatedPositions = 1861;
    const int RelatedPositionID = 1862;
    const int RelatedPositionIDSource = 1863;
    const int RelatedPositionDate = 1864;
    const int OfferID = 1867;
    const int NoValueChecks = 1868;
    const int ValueCheckType = 1869;
    const int ValueCheckAction = 1870;
    const int LegSecurityXMLLen = 1871;
    const int LegSecurityXML = 1872;
    const int LegSecurityXMLSchema = 1873;
    const int UnderlyingSecurityXMLLen = 1874;
    const int UnderlyingSecurityXML = 1875;
    const int UnderlyingSecurityXMLSchema = 1876;
    const int PartyDetailRequestResult = 1877;
    const int PartyDetailRequestStatus = 1878;
    const int PartyDetailDefinitionStatus = 1879;
    const int PartyDetailDefinitionResult = 1880;
    const int EntitlementRequestResult = 1881;
    const int EntitlementRequestStatus = 1882;
    const int EntitlementStatus = 1883;
    const int EntitlementResult = 1884;
    const int EntitlementRefID = 1885;
    const int SettlPriceUnitOfMeasure = 1886;
    const int SettlPriceUnitOfMeasureCurrency = 1887;
    const int TradeMatchTimestamp = 1888;
    const int NoInstrmtMatchSides = 1889;
    const int NoTrdMatchSides = 1890;
    const int TrdMatchSubID = 1891;
    const int NoLegExecs = 1892;
    const int LegExecID = 1893;
    const int LegTradeID = 1894;
    const int LegTradeReportID = 1895;
    const int TradeMatchAckStatus = 1896;
    const int TradeMatchRejectReason = 1897;
    const int SideMarketSegmentID = 1898;
    const int SideVenueType = 1899;
    const int SideExecRefID = 1900;
    const int LegExecRefID = 1901;
    const int HaircutIndicator = 1902;
    const int NumOfCompetitors = 1913;
    const int ResponseTime = 1914;
    const int QuoteDisplayTime = 1915;
    const int ExposureDurationUnit = 1916;
    const int CoverPrice = 1917;
    const int NoClearingAccountTypes = 1918;
    const int NoPriceMovements = 1919;
    const int NoPriceMovementValues = 1920;
    const int PriceMovementValue = 1921;
    const int PriceMovementPoint = 1922;
    const int PriceMovementType = 1923;
    const int EncodedEventTextLen = 1578;
    const int EncodedEventText = 1579;
    const int RegulatoryTradeID = 1903;
    const int RegulatoryTradeIDEvent = 1904;
    const int RegulatoryTradeIDSource = 1905;
    const int RegulatoryTradeIDType = 1906;
    const int NoRegulatoryTradeIDs = 1907;
    const int NoAllocRegulatoryTradeIDs = 1908;
    const int AllocRegulatoryTradeID = 1909;
    const int AllocRegulatoryTradeIDSource = 1910;
    const int AllocRegulatoryTradeIDEvent = 1911;
    const int AllocRegulatoryTradeIDType = 1912;
    const int ClearingIntention = 1924;
    const int TradeClearingInstruction = 1925;
    const int BackloadedTradeIndicator = 1926;
    const int ConfirmationMethod = 1927;
    const int MandatoryClearingIndicator = 1928;
    const int MixedSwapIndicator = 1929;
    const int OffMarketPriceIndicator = 1930;
    const int VerificationMethod = 1931;
    const int ClearingRequirementException = 1932;
    const int IRSDirection = 1933;
    const int RegulatoryReportType = 1934;
    const int VoluntaryRegulatoryReport = 1935;
    const int TradeCollateralization = 1936;
    const int TradeContinuation = 1937;
    const int AssetClass = 1938;
    const int AssetSubClass = 1939;
    const int AssetType = 1940;
    const int SwapClass = 1941;
    const int NthToDefault = 1942;
    const int MthToDefault = 1943;
    const int SettledEntityMatrixSource = 1944;
    const int SettledEntityMatrixPublicationDate = 1945;
    const int CouponType = 1946;
    const int TotalIssuedAmount = 1947;
    const int CouponFrequencyPeriod = 1948;
    const int CouponFrequencyUnit = 1949;
    const int CouponDayCount = 1950;
    const int ConvertibleBondEquityID = 1951;
    const int ConvertibleBondEquityIDSource = 1952;
    const int ContractPriceRefMonth = 1953;
    const int LienSeniority = 1954;
    const int LoanFacility = 1955;
    const int ReferenceEntityType = 1956;
    const int IndexSeries = 1957;
    const int IndexAnnexVersion = 1958;
    const int IndexAnnexDate = 1959;
    const int IndexAnnexSource = 1960;
    const int AgreementVersion = 1961;
    const int MasterConfirmationDesc = 1962;
    const int MasterConfirmationDate = 1963;
    const int MasterConfirmationAnnexDesc = 1964;
    const int MasterConfirmationAnnexDate = 1965;
    const int BrokerConfirmationDesc = 1966;
    const int CreditSupportAgreementDesc = 1967;
    const int CreditSupportAgreementDate = 1968;
    const int CreditSupportAgreementID = 1969;
    const int GoverningLaw = 1970;
    const int NoSideRegulatoryTradeIDs = 1971;
    const int SideRegulatoryTradeID = 1972;
    const int SideRegulatoryTradeIDSource = 1973;
    const int SideRegulatoryTradeIDEvent = 1974;
    const int SideRegulatoryTradeIDType = 1975;
    const int NoSecondaryAssetClasses = 1976;
    const int SecondaryAssetClass = 1977;
    const int SecondaryAssetSubClass = 1978;
    const int SecondaryAssetType = 1979;
    const int BlockTrdAllocIndicator = 1980;
    const int NoUnderlyingEvents = 1981;
    const int UnderlyingEventType = 1982;
    const int UnderlyingEventDate = 1983;
    const int UnderlyingEventTime = 1984;
    const int UnderlyingEventTimeUnit = 1985;
    const int UnderlyingEventTimePeriod = 1986;
    const int UnderlyingEventPx = 1987;
    const int UnderlyingConstituentWeight = 1988;
    const int UnderlyingCouponType = 1989;
    const int UnderlyingTotalIssuedAmount = 1990;
    const int UnderlyingCouponFrequencyPeriod = 1991;
    const int UnderlyingCouponFrequencyUnit = 1992;
    const int UnderlyingCouponDayCount = 1993;
    const int UnderlyingObligationID = 1994;
    const int UnderlyingObligationIDSource = 1995;
    const int UnderlyingEquityID = 1996;
    const int UnderlyingEquityIDSource = 1997;
    const int UnderlyingLienSeniority = 1998;
    const int UnderlyingLoanFacility = 1999;
    const int UnderlyingReferenceEntityType = 2000;
    const int UnderlyingProtectionTermXIDRef = 41314;
    const int UnderlyingSettlTermXIDRef = 41315;
    const int UnderlyingIndexSeries = 2003;
    const int UnderlyingIndexAnnexVersion = 2004;
    const int UnderlyingIndexAnnexDate = 2005;
    const int UnderlyingIndexAnnexSource = 2006;
    const int UnderlyingProductComplex = 2007;
    const int UnderlyingSecurityGroup = 2008;
    const int UnderlyingSettleOnOpenFlag = 2009;
    const int UnderlyingAssignmentMethod = 2010;
    const int UnderlyingSecurityStatus = 2011;
    const int UnderlyingObligationType = 2012;
    const int UnderlyingAssetClass = 2013;
    const int UnderlyingAssetSubClass = 2014;
    const int UnderlyingAssetType = 2015;
    const int UnderlyingSwapClass = 2016;
    const int UnderlyingNthToDefault = 2017;
    const int UnderlyingMthToDefault = 2018;
    const int UnderlyingSettledEntityMatrixSource = 2019;
    const int UnderlyingSettledEntityMatrixPublicationDate = 2020;
    const int UnderlyingStrikeMultiplier = 2021;
    const int UnderlyingStrikeValue = 2022;
    const int UnderlyingStrikePriceDeterminationMethod = 2023;
    const int UnderlyingStrikePriceBoundaryMethod = 2024;
    const int UnderlyingStrikePriceBoundaryPrecision = 2025;
    const int UnderlyingMinPriceIncrement = 2026;
    const int UnderlyingMinPriceIncrementAmount = 2027;
    const int UnderlyingOptPayoutType = 2028;
    const int UnderlyingOptPayoutAmount = 2029;
    const int UnderlyingPriceQuoteMethod = 2030;
    const int UnderlyingValuationMethod = 2031;
    const int UnderlyingListMethod = 2032;
    const int UnderlyingCapPrice = 2033;
    const int UnderlyingFloorPrice = 2034;
    const int UnderlyingFlexibleIndicator = 2035;
    const int UnderlyingFlexProductEligibilityIndicator = 2036;
    const int UnderlyingPositionLimit = 2037;
    const int UnderlyingNTPositionLimit = 2038;
    const int UnderlyingPool = 2039;
    const int UnderlyingContractSettlMonth = 2040;
    const int UnderlyingDatedDate = 2041;
    const int UnderlyingInterestAccrualDate = 2042;
    const int UnderlyingShortSaleRestriction = 2043;
    const int UnderlyingRefTickTableID = 2044;
    const int NoUnderlyingComplexEvents = 2045;
    const int UnderlyingComplexEventType = 2046;
    const int UnderlyingComplexOptPayoutAmount = 2047;
    const int UnderlyingComplexEventPrice = 2048;
    const int UnderlyingComplexEventPriceBoundaryMethod = 2049;
    const int UnderlyingComplexEventPriceBoundaryPrecision = 2050;
    const int UnderlyingComplexEventPriceTimeType = 2051;
    const int UnderlyingComplexEventCondition = 2052;
    const int NoUnderlyingComplexEventDates = 2053;
    const int UnderlyingComplexEventStartDate = 2054;
    const int UnderlyingComplexEventEndDate = 2055;
    const int NoUnderlyingComplexEventTimes = 2056;
    const int UnderlyingComplexEventStartTime = 2057;
    const int UnderlyingComplexEventEndTime = 2058;
    const int NoLegEvents = 2059;
    const int LegEventType = 2060;
    const int LegEventDate = 2061;
    const int LegEventTime = 2062;
    const int LegEventTimeUnit = 2063;
    const int LegEventTimePeriod = 2064;
    const int LegEventPx = 2065;
    const int LegEventText = 2066;
    const int LegAssetClass = 2067;
    const int LegAssetSubClass = 2068;
    const int LegAssetType = 2069;
    const int LegSwapClass = 2070;
    const int UnderlyingEventText = 2071;
    const int EncodedUnderlyingEventTextLen = 2072;
    const int EncodedUnderlyingEventText = 2073;
    const int EncodedLegEventTextLen = 2074;
    const int EncodedLegEventText = 2075;
    const int NoLegSecondaryAssetClasses = 2076;
    const int LegSecondaryAssetClass = 2077;
    const int LegSecondaryAssetSubClass = 2078;
    const int LegSecondaryAssetType = 2079;
    const int NoUnderlyingSecondaryAssetClasses = 2080;
    const int UnderlyingSecondaryAssetClass = 2081;
    const int UnderlyingSecondaryAssetSubClass = 2082;
    const int UnderlyingSecondaryAssetType = 2083;
    const int NoAdditionalTermBondRefs = 40000;
    const int AdditionalTermBondSecurityID = 40001;
    const int AdditionalTermBondSecurityIDSource = 40002;
    const int AdditionalTermBondDesc = 40003;
    const int EncodedAdditionalTermBondDescLen = 40004;
    const int EncodedAdditionalTermBondDesc = 40005;
    const int AdditionalTermBondCurrency = 40006;
    const int AdditionalTermBondIssuer = 40007;
    const int EncodedAdditionalTermBondIssuerLen = 40008;
    const int EncodedAdditionalTermBondIssuer = 40009;
    const int AdditionalTermBondSeniority = 40010;
    const int AdditionalTermBondCouponType = 40011;
    const int AdditionalTermBondCouponRate = 40012;
    const int AdditionalTermBondMaturityDate = 40013;
    const int AdditionalTermBondParValue = 40014;
    const int AdditionalTermBondCurrentTotalIssuedAmount = 40015;
    const int AdditionalTermBondCouponFrequencyPeriod = 40016;
    const int AdditionalTermBondCouponFrequencyUnit = 40017;
    const int AdditionalTermBondDayCount = 40018;
    const int NoAdditionalTerms = 40019;
    const int AdditionalTermConditionPrecedentBondIndicator = 40020;
    const int AdditionalTermDiscrepancyClauseIndicator = 40021;
    const int NoCashSettlTerms = 40022;
    const int CashSettlCurrency = 40023;
    const int CashSettlValuationFirstBusinessDayOffset = 40024;
    const int CashSettlValuationSubsequentBusinessDaysOffset = 40916;
    const int CashSettlNumOfValuationDates = 40917;
    const int CashSettlValuationTime = 40025;
    const int CashSettlBusinessCenter = 40026;
    const int CashSettlQuoteMethod = 40027;
    const int CashSettlQuoteAmount = 40028;
    const int CashSettlQuoteCurrency = 40029;
    const int CashSettlMinimumQuoteAmount = 40030;
    const int CashSettlMinimumQuoteCurrency = 40031;
    const int CashSettlDealer = 40032;
    const int CashSettlBusinessDays = 40033;
    const int CashSettlAmount = 40034;
    const int CashSettlRecoveryFactor = 40035;
    const int CashSettlFixedTermIndicator = 40036;
    const int CashSettlAccruedInterestIndicator = 40037;
    const int CashSettlValuationMethod = 40038;
    const int CashSettlTermXID = 40039;
    const int NoContractualDefinitions = 40040;
    const int ContractualDefinition = 40041;
    const int NoContractualMatrices = 40042;
    const int ContractualMatrixSource = 40043;
    const int ContractualMatrixDate = 40044;
    const int ContractualMatrixTerm = 40045;
    const int NoFinancingTermSupplements = 40046;
    const int FinancingTermSupplementDesc = 40047;
    const int FinancingTermSupplementDate = 40048;
    const int NoStreams = 40049;
    const int StreamType = 40050;
    const int StreamDesc = 40051;
    const int StreamPaySide = 40052;
    const int StreamReceiveSide = 40053;
    const int StreamNotional = 40054;
    const int StreamCurrency = 40055;
    const int StreamText = 40056;
    const int UnderlyingStreamEffectiveDateUnadjusted = 40057;
    const int UnderlyingStreamEffectiveDateBusinessDayConvention = 40058;
    const int UnderlyingStreamEffectiveDateBusinessCenter = 40059;
    const int UnderlyingStreamEffectiveDateRelativeTo = 40060;
    const int UnderlyingStreamEffectiveDateOffsetPeriod = 40061;
    const int UnderlyingStreamEffectiveDateOffsetUnit = 40062;
    const int UnderlyingStreamEffectiveDateOffsetDayType = 40063;
    const int UnderlyingStreamEffectiveDateAdjusted = 40064;
    const int StreamTerminationDateUnadjusted = 40065;
    const int StreamTerminationDateBusinessDayConvention = 40066;
    const int StreamTerminationDateBusinessCenter = 40067;
    const int StreamTerminationDateRelativeTo = 40068;
    const int StreamTerminationDateOffsetPeriod = 40069;
    const int StreamTerminationDateOffsetUnit = 40070;
    const int StreamTerminationDateOffsetDayType = 40071;
    const int StreamTerminationDateAdjusted = 40072;
    const int StreamCalculationPeriodBusinessDayConvention = 40073;
    const int StreamCalculationPeriodBusinessCenter = 40074;
    const int StreamFirstPeriodStartDateUnadjusted = 40075;
    const int StreamFirstPeriodStartDateBusinessDayConvention = 40076;
    const int StreamFirstPeriodStartDateBusinessCenter = 40077;
    const int StreamFirstPeriodStartDateAdjusted = 40078;
    const int StreamFirstRegularPeriodStartDateUnadjusted = 40079;
    const int StreamFirstCompoundingPeriodEndDateUnadjusted = 40080;
    const int StreamLastRegularPeriodEndDateUnadjusted = 40081;
    const int StreamCalculationFrequencyPeriod = 40082;
    const int StreamCalculationFrequencyUnit = 40083;
    const int StreamCalculationRollConvention = 40084;
    const int NoSettlRateFallbacks = 40085;
    const int SettlRatePostponementMaximumDays = 40086;
    const int LegPaymentStreamNonDeliverableSettlRateSource = 40087;
    const int SettlRatePostponementSurvey = 40088;
    const int SettlRatePostponementCalculationAgent = 40089;
    const int NoProvisions = 40090;
    const int ProvisionType = 40091;
    const int ProvisionDateUnadjusted = 40092;
    const int ProvisionDateBusinessDayConvention = 40093;
    const int ProvisionDateBusinessCenter = 40094;
    const int ProvisionDateAdjusted = 40095;
    const int ProvisionDateTenorPeriod = 40096;
    const int ProvisionDateTenorUnit = 40097;
    const int ProvisionCalculationAgent = 40098;
    const int ProvisionOptionSinglePartyBuyerSide = 40099;
    const int ProvisionOptionSinglePartySellerSide = 40100;
    const int ProvisionOptionExerciseStyle = 40101;
    const int ProvisionOptionExerciseMultipleNotional = 40102;
    const int ProvisionOptionExerciseMinimumNotional = 40103;
    const int ProvisionOptionExerciseMaximumNotional = 40104;
    const int ProvisionOptionMinimumNumber = 40105;
    const int ProvisionOptionMaximumNumber = 40106;
    const int ProvisionOptionExerciseConfirmation = 40107;
    const int ProvisionCashSettlMethod = 40108;
    const int ProvisionCashSettlCurrency = 40109;
    const int ProvisionCashSettlCurrency2 = 40110;
    const int ProvisionCashSettlQuoteType = 40111;
    const int ProvisionCashSettlQuoteSource = 40112;
    const int ProvisionText = 40113;
    const int ProvisionCashSettlValueTime = 40114;
    const int ProvisionCashSettlValueTimeBusinessCenter = 40115;
    const int ProvisionCashSettlValueDateBusinessDayConvention = 40116;
    const int ProvisionCashSettlValueDateBusinessCenter = 40117;
    const int ProvisionCashSettlValueDateRelativeTo = 40118;
    const int ProvisionCashSettlValueDateOffsetPeriod = 40119;
    const int ProvisionCashSettlValueDateOffsetUnit = 40120;
    const int ProvisionCashSettlValueDateOffsetDayType = 40121;
    const int ProvisionCashSettlValueDateAdjusted = 40122;
    const int ProvisionOptionExerciseBusinessDayConvention = 40123;
    const int ProvisionOptionExerciseBusinessCenter = 40124;
    const int ProvisionOptionExerciseEarliestDateOffsetPeriod = 40125;
    const int ProvisionOptionExerciseEarliestDateOffsetUnit = 40126;
    const int ProvisionOptionExerciseFrequencyPeriod = 40127;
    const int ProvisionOptionExerciseFrequencyUnit = 40128;
    const int ProvisionOptionExerciseStartDateUnadjusted = 40129;
    const int ProvisionOptionExerciseStartDateRelativeTo = 40130;
    const int ProvisionOptionExerciseStartDateOffsetPeriod = 40131;
    const int ProvisionOptionExerciseStartDateOffsetUnit = 40132;
    const int ProvisionOptionExerciseStartDateOffsetDayType = 40133;
    const int ProvisionOptionExerciseStartDateAdjusted = 40134;
    const int ProvisionOptionExercisePeriodSkip = 40135;
    const int ProvisionOptionExerciseBoundsFirstDateUnadjusted = 40136;
    const int ProvisionOptionExerciseBoundsLastDateUnadjusted = 40137;
    const int ProvisionOptionExerciseEarliestTime = 40138;
    const int ProvisionOptionExerciseEarliestTimeBusinessCenter = 40139;
    const int ProvisionOptionExerciseLatestTime = 40140;
    const int ProvisionOptionExerciseLatestTimeBusinessCenter = 40141;
    const int NoProvisionOptionExerciseFixedDates = 40142;
    const int ProvisionOptionExerciseFixedDate = 40143;
    const int ProvisionOptionExerciseFixedDateType = 40144;
    const int ProvisionOptionExpirationDateUnadjusted = 40145;
    const int ProvisionOptionExpirationDateBusinessDayConvention = 40146;
    const int ProvisionOptionExpirationDateBusinessCenter = 40147;
    const int ProvisionOptionExpirationDateRelativeTo = 40148;
    const int ProvisionOptionExpirationDateOffsetPeriod = 40149;
    const int ProvisionOptionExpirationDateOffsetUnit = 40150;
    const int ProvisionOptionExpirationDateOffsetDayType = 40151;
    const int ProvisionOptionExpirationDateAdjusted = 40152;
    const int ProvisionOptionExpirationTime = 40153;
    const int ProvisionOptionExpirationTimeBusinessCenter = 40154;
    const int ProvisionOptionRelevantUnderlyingDateUnadjusted = 40155;
    const int ProvisionOptionRelevantUnderlyingDateBusinessDayConvention = 40156;
    const int ProvisionOptionRelevantUnderlyingDateBusinessCenter = 40157;
    const int ProvisionOptionRelevantUnderlyingDateRelativeTo = 40158;
    const int ProvisionOptionRelevantUnderlyingDateOffsetPeriod = 40159;
    const int ProvisionOptionRelevantUnderlyingDateOffsetUnit = 40160;
    const int ProvisionOptionRelevantUnderlyingDateOffsetDayType = 40161;
    const int ProvisionOptionRelevantUnderlyingDateAdjusted = 40162;
    const int ProvisionCashSettlPaymentDateBusinessDayConvention = 40163;
    const int ProvisionCashSettlPaymentDateBusinessCenter = 40164;
    const int ProvisionCashSettlPaymentDateRelativeTo = 40165;
    const int ProvisionCashSettlPaymentDateOffsetPeriod = 40166;
    const int ProvisionCashSettlPaymentDateOffsetUnit = 40167;
    const int ProvisionCashSettlPaymentDateOffsetDayType = 40168;
    const int ProvisionCashSettlPaymentDateRangeFirst = 40169;
    const int ProvisionCashSettlPaymentDateRangeLast = 40170;
    const int NoProvisionCashSettlPaymentDates = 40171;
    const int ProvisionCashSettlPaymentDate = 40172;
    const int ProvisionCashSettlPaymentDateType = 40173;
    const int NoProvisionPartyIDs = 40174;
    const int ProvisionPartyID = 40175;
    const int ProvisionPartyIDSource = 40176;
    const int ProvisionPartyRole = 40177;
    const int NoProvisionPartySubIDs = 40178;
    const int ProvisionPartySubID = 40179;
    const int ProvisionPartySubIDType = 40180;
    const int NoProtectionTerms = 40181;
    const int ProtectionTermNotional = 40182;
    const int ProtectionTermCurrency = 40183;
    const int ProtectionTermSellerNotifies = 40184;
    const int ProtectionTermBuyerNotifies = 40185;
    const int ProtectionTermEventBusinessCenter = 40186;
    const int ProtectionTermStandardSources = 40187;
    const int ProtectionTermEventMinimumSources = 40188;
    const int ProtectionTermEventNewsSource = 40189;
    const int ProtectionTermXID = 40190;
    const int NoProtectionTermEvents = 40191;
    const int ProtectionTermEventType = 40192;
    const int ProtectionTermEventValue = 40193;
    const int ProtectionTermEventCurrency = 40194;
    const int ProtectionTermEventPeriod = 40195;
    const int ProtectionTermEventUnit = 40196;
    const int ProtectionTermEventDayType = 40197;
    const int ProtectionTermEventRateSource = 40198;
    const int NoProtectionTermEventQualifiers = 40199;
    const int ProtectionTermEventQualifier = 40200;
    const int NoProtectionTermObligations = 40201;
    const int ProtectionTermObligationType = 40202;
    const int ProtectionTermObligationValue = 40203;
    const int NoPhysicalSettlTerms = 40204;
    const int PhysicalSettlCurrency = 40205;
    const int PhysicalSettlBusinessDays = 40206;
    const int PhysicalSettlMaximumBusinessDays = 40207;
    const int PhysicalSettlTermXID = 40208;
    const int NoPhysicalSettlDeliverableObligations = 40209;
    const int PhysicalSettlDeliverableObligationType = 40210;
    const int PhysicalSettlDeliverableObligationValue = 40211;
    const int NoPayments = 40212;
    const int PaymentType = 40213;
    const int PaymentPaySide = 40214;
    const int PaymentReceiveSide = 40215;
    const int PaymentCurrency = 40216;
    const int PaymentAmount = 40217;
    const int PaymentPrice = 40218;
    const int PaymentDateUnadjusted = 40219;
    const int PaymentBusinessDayConvention = 40220;
    const int PaymentBusinessCenter = 40221;
    const int PaymentDateAdjusted = 40222;
    const int PaymentDiscountFactor = 40224;
    const int PaymentPresentValueAmount = 40225;
    const int PaymentPresentValueCurrency = 40226;
    const int PaymentSettlStyle = 40227;
    const int LegPaymentStreamNonDeliverableSettlReferencePage = 40228;
    const int PaymentText = 40229;
    const int NoPaymentSettls = 40230;
    const int PaymentSettlAmount = 40231;
    const int PaymentSettlCurrency = 40232;
    const int NoPaymentSettlPartyIDs = 40233;
    const int PaymentSettlPartyID = 40234;
    const int PaymentSettlPartyIDSource = 40235;
    const int PaymentSettlPartyRole = 40236;
    const int PaymentSettlPartyRoleQualifier = 40237;
    const int NoPaymentSettlPartySubIDs = 40238;
    const int PaymentSettlPartySubID = 40239;
    const int PaymentSettlPartySubIDType = 40240;
    const int NoLegStreams = 40241;
    const int LegStreamType = 40242;
    const int LegStreamDesc = 40243;
    const int LegStreamPaySide = 40244;
    const int LegStreamReceiveSide = 40245;
    const int LegStreamNotional = 40246;
    const int LegStreamCurrency = 40247;
    const int LegStreamText = 40248;
    const int LegStreamEffectiveDateUnadjusted = 40249;
    const int LegStreamEffectiveDateBusinessDayConvention = 40250;
    const int LegStreamEffectiveDateBusinessCenter = 40251;
    const int LegStreamEffectiveDateRelativeTo = 40252;
    const int LegStreamEffectiveDateOffsetPeriod = 40253;
    const int LegStreamEffectiveDateOffsetUnit = 40254;
    const int LegStreamEffectiveDateOffsetDayType = 40255;
    const int LegStreamEffectiveDateAdjusted = 40256;
    const int LegStreamTerminationDateUnadjusted = 40257;
    const int LegStreamTerminationDateBusinessDayConvention = 40258;
    const int LegStreamTerminationDateBusinessCenter = 40259;
    const int LegStreamTerminationDateRelativeTo = 40260;
    const int LegStreamTerminationDateOffsetPeriod = 40261;
    const int LegStreamTerminationDateOffsetUnit = 40262;
    const int LegStreamTerminationDateOffsetDayType = 40263;
    const int LegStreamTerminationDateAdjusted = 40264;
    const int LegStreamCalculationPeriodBusinessDayConvention = 40265;
    const int LegStreamCalculationPeriodBusinessCenter = 40266;
    const int LegStreamFirstPeriodStartDateUnadjusted = 40267;
    const int LegStreamFirstPeriodStartDateBusinessDayConvention = 40268;
    const int LegStreamFirstPeriodStartDateBusinessCenter = 40269;
    const int LegStreamFirstPeriodStartDateAdjusted = 40270;
    const int LegStreamFirstRegularPeriodStartDateUnadjusted = 40271;
    const int LegStreamFirstCompoundingPeriodEndDateUnadjusted = 40272;
    const int LegStreamLastRegularPeriodEndDateUnadjusted = 40273;
    const int LegStreamCalculationFrequencyPeriod = 40274;
    const int LegStreamCalculationFrequencyUnit = 40275;
    const int LegStreamCalculationRollConvention = 40276;
    const int NoCashSettlDealers = 40277;
    const int NoBusinessCenters = 40278;
    const int LegPaymentStreamType = 40279;
    const int LegPaymentStreamMarketRate = 40280;
    const int LegPaymentStreamDelayIndicator = 40281;
    const int LegPaymentStreamSettlCurrency = 40282;
    const int LegPaymentStreamDayCount = 40283;
    const int LegPaymentStreamAccrualDays = 40284;
    const int LegPaymentStreamDiscountType = 40285;
    const int LegPaymentStreamDiscountRate = 40286;
    const int LegPaymentStreamDiscountRateDayCount = 40287;
    const int LegPaymentStreamCompoundingMethod = 40288;
    const int LegPaymentStreamInitialPrincipalExchangeIndicator = 40289;
    const int LegPaymentStreamInterimPrincipalExchangeIndicator = 40290;
    const int LegPaymentStreamFinalPrincipalExchangeIndicator = 40291;
    const int LegPaymentStreamPaymentDateBusinessDayConvention = 40292;
    const int LegPaymentStreamPaymentDateBusinessCenter = 40293;
    const int LegPaymentStreamPaymentFrequencyPeriod = 40294;
    const int LegPaymentStreamPaymentFrequencyUnit = 40295;
    const int LegPaymentStreamPaymentRollConvention = 40296;
    const int LegPaymentStreamFirstPaymentDateUnadjusted = 40297;
    const int LegPaymentStreamLastRegularPaymentDateUnadjusted = 40298;
    const int LegPaymentStreamPaymentDateRelativeTo = 40299;
    const int LegPaymentStreamPaymentDateOffsetPeriod = 40300;
    const int LegPaymentStreamPaymentDateOffsetUnit = 40301;
    const int LegPaymentStreamPaymentDateOffsetDayType = 40302;
    const int LegPaymentStreamResetDateRelativeTo = 40303;
    const int LegPaymentStreamResetDateBusinessDayConvention = 40304;
    const int LegPaymentStreamResetDateBusinessCenter = 40305;
    const int LegPaymentStreamResetFrequencyPeriod = 40306;
    const int LegPaymentStreamResetFrequencyUnit = 40307;
    const int LegPaymentStreamResetWeeklyRollConvention = 40308;
    const int LegPaymentStreamInitialFixingDateRelativeTo = 40309;
    const int LegPaymentStreamInitialFixingDateBusinessDayConvention = 40310;
    const int LegPaymentStreamInitialFixingDateBusinessCenter = 40311;
    const int LegPaymentStreamInitialFixingDateOffsetPeriod = 40312;
    const int LegPaymentStreamInitialFixingDateOffsetUnit = 40313;
    const int LegPaymentStreamInitialFixingDateOffsetDayType = 40314;
    const int LegPaymentStreamInitialFixingDateAdjusted = 40315;
    const int LegPaymentStreamFixingDateRelativeTo = 40316;
    const int LegPaymentStreamFixingDateBusinessDayConvention = 40317;
    const int LegPaymentStreamFixingDateBusinessCenter = 40318;
    const int LegPaymentStreamFixingDateOffsetPeriod = 40319;
    const int LegPaymentStreamFixingDateOffsetUnit = 40320;
    const int LegPaymentStreamFixingDateOffsetDayType = 40321;
    const int LegPaymentStreamFixingDateAdjusted = 40322;
    const int LegPaymentStreamRateCutoffDateOffsetPeriod = 40323;
    const int LegPaymentStreamRateCutoffDateOffsetUnit = 40324;
    const int LegPaymentStreamRateCutoffDateOffsetDayType = 40325;
    const int LegPaymentStreamRate = 40326;
    const int LegPaymentStreamFixedAmount = 40327;
    const int LegPaymentStreamRateOrAmountCurrency = 40328;
    const int LegPaymentStreamFutureValueNotional = 40329;
    const int LegPaymentStreamFutureValueDateAdjusted = 40330;
    const int LegPaymentStreamRateIndex = 40331;
    const int LegPaymentStreamRateIndexSource = 40332;
    const int LegPaymentStreamRateIndexCurveUnit = 40333;
    const int LegPaymentStreamRateIndexCurvePeriod = 40334;
    const int LegPaymentStreamRateMultiplier = 40335;
    const int LegPaymentStreamRateSpread = 40336;
    const int LegPaymentStreamRateSpreadPositionType = 40337;
    const int LegPaymentStreamRateTreatment = 40338;
    const int LegPaymentStreamCapRate = 40339;
    const int LegPaymentStreamCapRateBuySide = 40340;
    const int LegPaymentStreamCapRateSellSide = 40341;
    const int LegPaymentStreamFloorRate = 40342;
    const int LegPaymentStreamFloorRateBuySide = 40343;
    const int LegPaymentStreamFloorRateSellSide = 40344;
    const int LegPaymentStreamInitialRate = 40345;
    const int LegPaymentStreamFinalRateRoundingDirection = 40346;
    const int LegPaymentStreamFinalRatePrecision = 40347;
    const int LegPaymentStreamAveragingMethod = 40348;
    const int LegPaymentStreamNegativeRateTreatment = 40349;
    const int LegPaymentStreamInflationLagPeriod = 40350;
    const int LegPaymentStreamInflationLagUnit = 40351;
    const int LegPaymentStreamInflationLagDayType = 40352;
    const int LegPaymentStreamInflationInterpolationMethod = 40353;
    const int LegPaymentStreamInflationIndexSource = 40354;
    const int LegPaymentStreamInflationPublicationSource = 40355;
    const int LegPaymentStreamInflationInitialIndexLevel = 40356;
    const int LegPaymentStreamInflationFallbackBondApplicable = 40357;
    const int LegPaymentStreamFRADiscounting = 40358;
    const int LegPaymentStreamNonDeliverableRefCurrency = 40359;
    const int LegPaymentStreamNonDeliverableFixingDatesBusinessDayConvention = 40360;
    const int LegPaymentStreamNonDeliverableFixingDatesBusinessCenter = 40361;
    const int LegPaymentStreamNonDeliverableFixingDatesRelativeTo = 40362;
    const int LegPaymentStreamNonDeliverableFixingDatesOffsetPeriod = 40363;
    const int LegPaymentStreamNonDeliverableFixingDatesOffsetUnit = 40364;
    const int LegPaymentStreamNonDeliverableFixingDatesOffsetDayType = 40365;
    const int LegSettlRateFallbackRateSource = 40366;
    const int NoLegNonDeliverableFixingDates = 40367;
    const int LegNonDeliverableFixingDate = 40368;
    const int LegNonDeliverableFixingDateType = 40369;
    const int LegSettlRateFallbackReferencePage = 40370;
    const int PaymentStreamNonDeliverableSettlRateSource = 40371;
    const int PaymentStreamNonDeliverableSettlReferencePage = 40372;
    const int SettlRateFallbackRateSource = 40373;
    const int NoLegPaymentSchedules = 40374;
    const int LegPaymentScheduleType = 40375;
    const int LegPaymentScheduleStubType = 40376;
    const int LegPaymentScheduleStartDateUnadjusted = 40377;
    const int LegPaymentScheduleEndDateUnadjusted = 40378;
    const int LegPaymentSchedulePaySide = 40379;
    const int LegPaymentScheduleReceiveSide = 40380;
    const int LegPaymentScheduleNotional = 40381;
    const int LegPaymentScheduleCurrency = 40382;
    const int LegPaymentScheduleRate = 40383;
    const int LegPaymentScheduleRateMultiplier = 40384;
    const int LegPaymentScheduleRateSpread = 40385;
    const int LegPaymentScheduleRateSpreadPositionType = 40386;
    const int LegPaymentScheduleRateTreatment = 40387;
    const int LegPaymentScheduleFixedAmount = 40388;
    const int LegPaymentScheduleFixedCurrency = 40389;
    const int LegPaymentScheduleStepFrequencyPeriod = 40390;
    const int LegPaymentScheduleStepFrequencyUnit = 40391;
    const int LegPaymentScheduleStepOffsetValue = 40392;
    const int LegPaymentScheduleStepRate = 40393;
    const int LegPaymentScheduleStepOffsetRate = 40394;
    const int LegPaymentScheduleStepRelativeTo = 40395;
    const int LegPaymentScheduleFixingDateUnadjusted = 40396;
    const int LegPaymentScheduleWeight = 40397;
    const int LegPaymentScheduleFixingDateRelativeTo = 40398;
    const int LegPaymentScheduleFixingDateBusinessDayConvention = 40399;
    const int LegPaymentScheduleFixingDateBusinessCenter = 40400;
    const int LegPaymentScheduleFixingDateOffsetPeriod = 40401;
    const int LegPaymentScheduleFixingDateOffsetUnit = 40402;
    const int LegPaymentScheduleFixingDateOffsetDayType = 40403;
    const int LegPaymentScheduleFixingDateAdjusted = 40404;
    const int LegPaymentScheduleFixingTime = 40405;
    const int LegPaymentScheduleFixingTimeBusinessCenter = 40406;
    const int LegPaymentScheduleInterimExchangePaymentDateRelativeTo = 40407;
    const int LegPaymentScheduleInterimExchangeDatesBusinessDayConvention = 40408;
    const int LegPaymentScheduleInterimExchangeDatesBusinessCenter = 40409;
    const int LegPaymentScheduleInterimExchangeDatesOffsetPeriod = 40410;
    const int LegPaymentScheduleInterimExchangeDatesOffsetUnit = 40411;
    const int LegPaymentScheduleInterimExchangeDatesOffsetDayType = 40412;
    const int LegPaymentScheduleInterimExchangeDateAdjusted = 40413;
    const int NoLegPaymentScheduleRateSources = 40414;
    const int LegPaymentScheduleRateSource = 40415;
    const int LegPaymentScheduleRateSourceType = 40416;
    const int LegPaymentScheduleReferencePage = 40417;
    const int NoLegPaymentStubs = 40418;
    const int LegPaymentStubType = 40419;
    const int LegPaymentStubLength = 40420;
    const int LegPaymentStubRate = 40421;
    const int LegPaymentStubFixedAmount = 40422;
    const int LegPaymentStubFixedCurrency = 40423;
    const int LegPaymentStubIndex = 40424;
    const int LegPaymentStubIndexSource = 40425;
    const int LegPaymentStubIndexCurvePeriod = 40426;
    const int LegPaymentStubIndexCurveUnit = 40427;
    const int LegPaymentStubIndexRateMultiplier = 40428;
    const int LegPaymentStubIndexRateSpread = 40429;
    const int LegPaymentStubIndexRateSpreadPositionType = 40430;
    const int LegPaymentStubIndexRateTreatment = 40431;
    const int LegPaymentStubIndexCapRate = 40432;
    const int LegPaymentStubIndexCapRateBuySide = 40433;
    const int LegPaymentStubIndexCapRateSellSide = 40434;
    const int LegPaymentStubIndexFloorRate = 40435;
    const int LegPaymentStubIndexFloorRateBuySide = 40436;
    const int LegPaymentStubIndexFloorRateSellSide = 40437;
    const int LegPaymentStubIndex2 = 40438;
    const int LegPaymentStubIndex2Source = 40439;
    const int LegPaymentStubIndex2CurvePeriod = 40440;
    const int LegPaymentStubIndex2CurveUnit = 40441;
    const int LegPaymentStubIndex2RateMultiplier = 40442;
    const int LegPaymentStubIndex2RateSpread = 40443;
    const int LegPaymentStubIndex2RateSpreadPositionType = 40444;
    const int LegPaymentStubIndex2RateTreatment = 40445;
    const int LegPaymentStubIndex2CapRate = 40446;
    const int LegPaymentStubIndex2FloorRate = 40447;
    const int NoLegProvisions = 40448;
    const int LegProvisionType = 40449;
    const int LegProvisionDateUnadjusted = 40450;
    const int LegProvisionDateBusinessDayConvention = 40451;
    const int LegProvisionDateBusinessCenter = 40452;
    const int LegProvisionDateAdjusted = 40453;
    const int LegProvisionDateTenorPeriod = 40454;
    const int LegProvisionDateTenorUnit = 40455;
    const int LegProvisionCalculationAgent = 40456;
    const int LegProvisionOptionSinglePartyBuyerSide = 40457;
    const int LegProvisionOptionSinglePartySellerSide = 40458;
    const int LegProvisionOptionExerciseStyle = 40459;
    const int LegProvisionOptionExerciseMultipleNotional = 40460;
    const int LegProvisionOptionExerciseMinimumNotional = 40461;
    const int LegProvisionOptionExerciseMaximumNotional = 40462;
    const int LegProvisionOptionMinimumNumber = 40463;
    const int LegProvisionOptionMaximumNumber = 40464;
    const int LegProvisionOptionExerciseConfirmation = 40465;
    const int LegProvisionCashSettlMethod = 40466;
    const int LegProvisionCashSettlCurrency = 40467;
    const int LegProvisionCashSettlCurrency2 = 40468;
    const int LegProvisionCashSettlQuoteType = 40469;
    const int LegProvisionCashSettlQuoteSource = 40470;
    const int BusinessCenter = 40471;
    const int LegProvisionText = 40472;
    const int NoLegProvisionCashSettlPaymentDates = 40473;
    const int LegProvisionCashSettlPaymentDate = 40474;
    const int LegProvisionCashSettlPaymentDateType = 40475;
    const int LegProvisionOptionExerciseBusinessDayConvention = 40476;
    const int LegProvisionOptionExerciseBusinessCenter = 40477;
    const int LegProvisionOptionExerciseEarliestDateOffsetPeriod = 40478;
    const int LegProvisionOptionExerciseEarliestDateOffsetUnit = 40479;
    const int LegProvisionOptionExerciseFrequencyPeriod = 40480;
    const int LegProvisionOptionExerciseFrequencyUnit = 40481;
    const int LegProvisionOptionExerciseStartDateUnadjusted = 40482;
    const int LegProvisionOptionExerciseStartDateRelativeTo = 40483;
    const int LegProvisionOptionExerciseStartDateOffsetPeriod = 40484;
    const int LegProvisionOptionExerciseStartDateOffsetUnit = 40485;
    const int LegProvisionOptionExerciseStartDateOffsetDayType = 40486;
    const int LegProvisionOptionExerciseStartDateAdjusted = 40487;
    const int LegProvisionOptionExercisePeriodSkip = 40488;
    const int LegProvisionOptionExerciseBoundsFirstDateUnadjusted = 40489;
    const int LegProvisionOptionExerciseBoundsLastDateUnadjusted = 40490;
    const int LegProvisionOptionExerciseEarliestTime = 40491;
    const int LegProvisionOptionExerciseEarliestTimeBusinessCenter = 40492;
    const int LegProvisionOptionExerciseLatestTime = 40493;
    const int LegProvisionOptionExerciseLatestTimeBusinessCenter = 40494;
    const int NoLegProvisionOptionExerciseFixedDates = 40495;
    const int LegProvisionOptionExerciseFixedDate = 40496;
    const int LegProvisionOptionExerciseFixedDateType = 40497;
    const int LegProvisionOptionExpirationDateUnadjusted = 40498;
    const int LegProvisionOptionExpirationDateBusinessDayConvention = 40499;
    const int LegProvisionOptionExpirationDateBusinessCenter = 40500;
    const int LegProvisionOptionExpirationDateRelativeTo = 40501;
    const int LegProvisionOptionExpirationDateOffsetPeriod = 40502;
    const int LegProvisionOptionExpirationDateOffsetUnit = 40503;
    const int LegProvisionOptionExpirationDateOffsetDayType = 40504;
    const int LegProvisionOptionExpirationDateAdjusted = 40505;
    const int LegProvisionOptionExpirationTime = 40506;
    const int LegProvisionOptionExpirationTimeBusinessCenter = 40507;
    const int LegProvisionOptionRelevantUnderlyingDateUnadjusted = 40508;
    const int LegProvisionOptionRelevantUnderlyingDateBusinessDayConvention = 40509;
    const int LegProvisionOptionRelevantUnderlyingDateBusinessCenter = 40510;
    const int LegProvisionOptionRelevantUnderlyingDateRelativeTo = 40511;
    const int LegProvisionOptionRelevantUnderlyingDateOffsetPeriod = 40512;
    const int LegProvisionOptionRelevantUnderlyingDateOffsetUnit = 40513;
    const int LegProvisionOptionRelevantUnderlyingDateOffsetDayType = 40514;
    const int LegProvisionOptionRelevantUnderlyingDateAdjusted = 40515;
    const int LegProvisionCashSettlPaymentDateBusinessDayConvention = 40516;
    const int LegProvisionCashSettlPaymentDateBusinessCenter = 40517;
    const int LegProvisionCashSettlPaymentDateRelativeTo = 40518;
    const int LegProvisionCashSettlPaymentDateOffsetPeriod = 40519;
    const int LegProvisionCashSettlPaymentDateOffsetUnit = 40520;
    const int LegProvisionCashSettlPaymentDateOffsetDayType = 40521;
    const int LegProvisionCashSettlPaymentDateRangeFirst = 40522;
    const int LegProvisionCashSettlPaymentDateRangeLast = 40523;
    const int LegProvisionCashSettlValueTime = 40524;
    const int LegProvisionCashSettlValueTimeBusinessCenter = 40525;
    const int LegProvisionCashSettlValueDateBusinessDayConvention = 40526;
    const int LegProvisionCashSettlValueDateBusinessCenter = 40527;
    const int LegProvisionCashSettlValueDateRelativeTo = 40528;
    const int LegProvisionCashSettlValueDateOffsetPeriod = 40529;
    const int LegProvisionCashSettlValueDateOffsetUnit = 40530;
    const int LegProvisionCashSettlValueDateOffsetDayType = 40531;
    const int LegProvisionCashSettlValueDateAdjusted = 40532;
    const int NoLegProvisionPartyIDs = 40533;
    const int LegProvisionPartyID = 40534;
    const int LegProvisionPartyIDSource = 40535;
    const int LegProvisionPartyRole = 40536;
    const int NoLegProvisionPartySubIDs = 40537;
    const int LegProvisionPartySubID = 40538;
    const int LegProvisionPartySubIDType = 40539;
    const int NoUnderlyingStreams = 40540;
    const int UnderlyingStreamType = 40541;
    const int UnderlyingStreamDesc = 40542;
    const int UnderlyingStreamPaySide = 40543;
    const int UnderlyingStreamReceiveSide = 40544;
    const int UnderlyingStreamNotional = 40545;
    const int UnderlyingStreamCurrency = 40546;
    const int UnderlyingStreamText = 40547;
    const int UnderlyingStreamTerminationDateUnadjusted = 40548;
    const int UnderlyingStreamTerminationDateBusinessDayConvention = 40549;
    const int UnderlyingStreamTerminationDateBusinessCenter = 40550;
    const int UnderlyingStreamTerminationDateRelativeTo = 40551;
    const int UnderlyingStreamTerminationDateOffsetPeriod = 40552;
    const int UnderlyingStreamTerminationDateOffsetUnit = 40553;
    const int UnderlyingStreamTerminationDateOffsetDayType = 40554;
    const int UnderlyingStreamTerminationDateAdjusted = 40555;
    const int UnderlyingStreamCalculationPeriodBusinessDayConvention = 40556;
    const int UnderlyingStreamCalculationPeriodBusinessCenter = 40557;
    const int UnderlyingStreamFirstPeriodStartDateUnadjusted = 40558;
    const int UnderlyingStreamFirstPeriodStartDateBusinessDayConvention = 40559;
    const int UnderlyingStreamFirstPeriodStartDateBusinessCenter = 40560;
    const int UnderlyingStreamFirstPeriodStartDateAdjusted = 40561;
    const int UnderlyingStreamFirstRegularPeriodStartDateUnadjusted = 40562;
    const int UnderlyingStreamFirstCompoundingPeriodEndDateUnadjusted = 40563;
    const int UnderlyingStreamLastRegularPeriodEndDateUnadjusted = 40564;
    const int UnderlyingStreamCalculationFrequencyPeriod = 40565;
    const int UnderlyingStreamCalculationFrequencyUnit = 40566;
    const int UnderlyingStreamCalculationRollConvention = 40567;
    const int UnderlyingPaymentStreamType = 40568;
    const int UnderlyingPaymentStreamMarketRate = 40569;
    const int UnderlyingPaymentStreamDelayIndicator = 40570;
    const int UnderlyingPaymentStreamSettlCurrency = 40571;
    const int UnderlyingPaymentStreamDayCount = 40572;
    const int UnderlyingPaymentStreamAccrualDays = 40573;
    const int UnderlyingPaymentStreamDiscountType = 40574;
    const int UnderlyingPaymentStreamDiscountRate = 40575;
    const int UnderlyingPaymentStreamDiscountRateDayCount = 40576;
    const int UnderlyingPaymentStreamCompoundingMethod = 40577;
    const int UnderlyingPaymentStreamInitialPrincipalExchangeIndicator = 40578;
    const int UnderlyingPaymentStreamInterimPrincipalExchangeIndicator = 40579;
    const int UnderlyingPaymentStreamFinalPrincipalExchangeIndicator = 40580;
    const int UnderlyingPaymentStreamPaymentDateBusinessDayConvention = 40581;
    const int UnderlyingPaymentStreamPaymentDateBusinessCenter = 40582;
    const int UnderlyingPaymentStreamPaymentFrequencyPeriod = 40583;
    const int UnderlyingPaymentStreamPaymentFrequencyUnit = 40584;
    const int UnderlyingPaymentStreamPaymentRollConvention = 40585;
    const int UnderlyingPaymentStreamFirstPaymentDateUnadjusted = 40586;
    const int UnderlyingPaymentStreamLastRegularPaymentDateUnadjusted = 40587;
    const int UnderlyingPaymentStreamPaymentDateRelativeTo = 40588;
    const int UnderlyingPaymentStreamPaymentDateOffsetPeriod = 40589;
    const int UnderlyingPaymentStreamPaymentDateOffsetUnit = 40590;
    const int UnderlyingPaymentStreamPaymentDateOffsetDayType = 40591;
    const int UnderlyingPaymentStreamResetDateRelativeTo = 40592;
    const int UnderlyingPaymentStreamResetDateBusinessDayConvention = 40593;
    const int UnderlyingPaymentStreamResetDateBusinessCenter = 40594;
    const int UnderlyingPaymentStreamResetFrequencyPeriod = 40595;
    const int UnderlyingPaymentStreamResetFrequencyUnit = 40596;
    const int UnderlyingPaymentStreamResetWeeklyRollConvention = 40597;
    const int UnderlyingPaymentStreamInitialFixingDateRelativeTo = 40598;
    const int UnderlyingPaymentStreamInitialFixingDateBusinessDayConvention = 40599;
    const int UnderlyingPaymentStreamInitialFixingDateBusinessCenter = 40600;
    const int UnderlyingPaymentStreamInitialFixingDateOffsetPeriod = 40601;
    const int UnderlyingPaymentStreamInitialFixingDateOffsetUnit = 40602;
    const int UnderlyingPaymentStreamInitialFixingDateOffsetDayType = 40603;
    const int UnderlyingPaymentStreamInitialFixingDateAdjusted = 40604;
    const int UnderlyingPaymentStreamFixingDateRelativeTo = 40605;
    const int UnderlyingPaymentStreamFixingDateBusinessDayConvention = 40606;
    const int UnderlyingPaymentStreamFixingDateBusinessCenter = 40607;
    const int UnderlyingPaymentStreamFixingDateOffsetPeriod = 40608;
    const int UnderlyingPaymentStreamFixingDateOffsetUnit = 40609;
    const int UnderlyingPaymentStreamFixingDateOffsetDayType = 40610;
    const int UnderlyingPaymentStreamFixingDateAdjusted = 40611;
    const int UnderlyingPaymentStreamRateCutoffDateOffsetPeriod = 40612;
    const int UnderlyingPaymentStreamRateCutoffDateOffsetUnit = 40613;
    const int UnderlyingPaymentStreamRateCutoffDateOffsetDayType = 40614;
    const int UnderlyingPaymentStreamRate = 40615;
    const int UnderlyingPaymentStreamFixedAmount = 40616;
    const int UnderlyingPaymentStreamRateOrAmountCurrency = 40617;
    const int UnderlyingPaymentStreamFutureValueNotional = 40618;
    const int UnderlyingPaymentStreamFutureValueDateAdjusted = 40619;
    const int UnderlyingPaymentStreamRateIndex = 40620;
    const int UnderlyingPaymentStreamRateIndexSource = 40621;
    const int UnderlyingPaymentStreamRateIndexCurveUnit = 40622;
    const int UnderlyingPaymentStreamRateIndexCurvePeriod = 40623;
    const int UnderlyingPaymentStreamRateMultiplier = 40624;
    const int UnderlyingPaymentStreamRateSpread = 40625;
    const int UnderlyingPaymentStreamRateSpreadPositionType = 40626;
    const int UnderlyingPaymentStreamRateTreatment = 40627;
    const int UnderlyingPaymentStreamCapRate = 40628;
    const int UnderlyingPaymentStreamCapRateBuySide = 40629;
    const int UnderlyingPaymentStreamCapRateSellSide = 40630;
    const int UnderlyingPaymentStreamFloorRate = 40631;
    const int UnderlyingPaymentStreamFloorRateBuySide = 40632;
    const int UnderlyingPaymentStreamFloorRateSellSide = 40633;
    const int UnderlyingPaymentStreamInitialRate = 40634;
    const int UnderlyingPaymentStreamFinalRateRoundingDirection = 40635;
    const int UnderlyingPaymentStreamFinalRatePrecision = 40636;
    const int UnderlyingPaymentStreamAveragingMethod = 40637;
    const int UnderlyingPaymentStreamNegativeRateTreatment = 40638;
    const int UnderlyingPaymentStreamInflationLagPeriod = 40639;
    const int UnderlyingPaymentStreamInflationLagUnit = 40640;
    const int UnderlyingPaymentStreamInflationLagDayType = 40641;
    const int UnderlyingPaymentStreamInflationInterpolationMethod = 40642;
    const int UnderlyingPaymentStreamInflationIndexSource = 40643;
    const int UnderlyingPaymentStreamInflationPublicationSource = 40644;
    const int UnderlyingPaymentStreamInflationInitialIndexLevel = 40645;
    const int UnderlyingPaymentStreamInflationFallbackBondApplicable = 40646;
    const int UnderlyingPaymentStreamFRADiscounting = 40647;
    const int UnderlyingPaymentStreamNonDeliverableRefCurrency = 40648;
    const int UnderlyingPaymentStreamNonDeliverableFixingDatesBizDayConvention = 40649;
    const int UnderlyingPaymentStreamNonDeliverableFixingDatesBusinessCenter = 40650;
    const int UnderlyingPaymentStreamNonDeliverableFixingDatesRelativeTo = 40651;
    const int UnderlyingPaymentStreamNonDeliverableFixingDatesOffsetPeriod = 40652;
    const int UnderlyingPaymentStreamNonDeliverableFixingDatesOffsetUnit = 40653;
    const int UnderlyingPaymentStreamNonDeliverableFixingDatesOffsetDayType = 40654;
    const int SettlRateFallbackReferencePage = 40655;
    const int NoUnderlyingNonDeliverableFixingDates = 40656;
    const int UnderlyingNonDeliverableFixingDate = 40657;
    const int UnderlyingNonDeliverableFixingDateType = 40658;
    const int NoUnderlyingSettlRateFallbacks = 40659;
    const int UnderlyingSettlRatePostponementMaximumDays = 40660;
    const int UnderlyingPaymentStreamNonDeliverableSettlRateSource = 40661;
    const int UnderlyingSettlRatePostponementSurvey = 40662;
    const int UnderlyingSettlRatePostponementCalculationAgent = 40663;
    const int NoUnderlyingPaymentSchedules = 40664;
    const int UnderlyingPaymentScheduleType = 40665;
    const int UnderlyingPaymentScheduleStubType = 40666;
    const int UnderlyingPaymentScheduleStartDateUnadjusted = 40667;
    const int UnderlyingPaymentScheduleEndDateUnadjusted = 40668;
    const int UnderlyingPaymentSchedulePaySide = 40669;
    const int UnderlyingPaymentScheduleReceiveSide = 40670;
    const int UnderlyingPaymentScheduleNotional = 40671;
    const int UnderlyingPaymentScheduleCurrency = 40672;
    const int UnderlyingPaymentScheduleRate = 40673;
    const int UnderlyingPaymentScheduleRateMultiplier = 40674;
    const int UnderlyingPaymentScheduleRateSpread = 40675;
    const int UnderlyingPaymentScheduleRateSpreadPositionType = 40676;
    const int UnderlyingPaymentScheduleRateTreatment = 40677;
    const int UnderlyingPaymentScheduleFixedAmount = 40678;
    const int UnderlyingPaymentScheduleFixedCurrency = 40679;
    const int UnderlyingPaymentScheduleStepFrequencyPeriod = 40680;
    const int UnderlyingPaymentScheduleStepFrequencyUnit = 40681;
    const int UnderlyingPaymentScheduleStepOffsetValue = 40682;
    const int UnderlyingPaymentScheduleStepRate = 40683;
    const int UnderlyingPaymentScheduleStepOffsetRate = 40684;
    const int UnderlyingPaymentScheduleStepRelativeTo = 40685;
    const int UnderlyingPaymentScheduleFixingDateUnadjusted = 40686;
    const int UnderlyingPaymentScheduleWeight = 40687;
    const int UnderlyingPaymentScheduleFixingDateRelativeTo = 40688;
    const int UnderlyingPaymentScheduleFixingDateBusinessDayCnvtn = 40689;
    const int UnderlyingPaymentScheduleFixingDateBusinessCenter = 40690;
    const int UnderlyingPaymentScheduleFixingDateOffsetPeriod = 40691;
    const int UnderlyingPaymentScheduleFixingDateOffsetUnit = 40692;
    const int UnderlyingPaymentScheduleFixingDateOffsetDayType = 40693;
    const int UnderlyingPaymentScheduleFixingDateAdjusted = 40694;
    const int UnderlyingPaymentScheduleFixingTime = 40695;
    const int UnderlyingPaymentScheduleFixingTimeBusinessCenter = 40696;
    const int UnderlyingPaymentScheduleInterimExchangePaymentDateRelativeTo = 40697;
    const int UnderlyingPaymentScheduleInterimExchangeDatesBizDayConvention = 40698;
    const int UnderlyingPaymentScheduleInterimExchangeDatesBusinessCenter = 40699;
    const int UnderlyingPaymentScheduleInterimExchangeDatesOffsetPeriod = 40700;
    const int UnderlyingPaymentScheduleInterimExchangeDatesOffsetUnit = 40701;
    const int UnderlyingPaymentScheduleInterimExchangeDatesOffsetDayType = 40702;
    const int UnderlyingPaymentScheduleInterimExchangeDateAdjusted = 40703;
    const int NoUnderlyingPaymentScheduleRateSources = 40704;
    const int UnderlyingPaymentScheduleRateSource = 40705;
    const int UnderlyingPaymentScheduleRateSourceType = 40706;
    const int UnderlyingPaymentScheduleReferencePage = 40707;
    const int NoUnderlyingPaymentStubs = 40708;
    const int UnderlyingPaymentStubType = 40709;
    const int UnderlyingPaymentStubLength = 40710;
    const int UnderlyingPaymentStubRate = 40711;
    const int UnderlyingPaymentStubFixedAmount = 40712;
    const int UnderlyingPaymentStubFixedCurrency = 40713;
    const int UnderlyingPaymentStubIndex = 40714;
    const int UnderlyingPaymentStubIndexSource = 40715;
    const int UnderlyingPaymentStubIndexCurvePeriod = 40716;
    const int UnderlyingPaymentStubIndexCurveUnit = 40717;
    const int UnderlyingPaymentStubIndexRateMultiplier = 40718;
    const int UnderlyingPaymentStubIndexRateSpread = 40719;
    const int UnderlyingPaymentStubIndexRateSpreadPositionType = 40720;
    const int UnderlyingPaymentStubIndexRateTreatment = 40721;
    const int UnderlyingPaymentStubIndexCapRate = 40722;
    const int UnderlyingPaymentStubIndexCapRateBuySide = 40723;
    const int UnderlyingPaymentStubIndexCapRateSellSide = 40724;
    const int UnderlyingPaymentStubIndexFloorRate = 40725;
    const int UnderlyingPaymentStubIndexFloorRateBuySide = 40726;
    const int UnderlyingPaymentStubIndexFloorRateSellSide = 40727;
    const int UnderlyingPaymentStubIndex2 = 40728;
    const int UnderlyingPaymentStubIndex2Source = 40729;
    const int UnderlyingPaymentStubIndex2CurvePeriod = 40730;
    const int UnderlyingPaymentStubIndex2CurveUnit = 40731;
    const int UnderlyingPaymentStubIndex2RateMultiplier = 40732;
    const int UnderlyingPaymentStubIndex2RateSpread = 40733;
    const int UnderlyingPaymentStubIndex2RateSpreadPositionType = 40734;
    const int UnderlyingPaymentStubIndex2RateTreatment = 40735;
    const int UnderlyingPaymentStubIndex2CapRate = 40736;
    const int UnderlyingPaymentStubIndex2FloorRate = 40737;
    const int PaymentStreamType = 40738;
    const int PaymentStreamMarketRate = 40739;
    const int PaymentStreamDelayIndicator = 40740;
    const int PaymentStreamSettlCurrency = 40741;
    const int PaymentStreamDayCount = 40742;
    const int PaymentStreamAccrualDays = 40743;
    const int PaymentStreamDiscountType = 40744;
    const int PaymentStreamDiscountRate = 40745;
    const int PaymentStreamDiscountRateDayCount = 40746;
    const int PaymentStreamCompoundingMethod = 40747;
    const int PaymentStreamInitialPrincipalExchangeIndicator = 40748;
    const int PaymentStreamInterimPrincipalExchangeIndicator = 40749;
    const int PaymentStreamFinalPrincipalExchangeIndicator = 40750;
    const int PaymentStreamPaymentDateBusinessDayConvention = 40751;
    const int PaymentStreamPaymentDateBusinessCenter = 40752;
    const int PaymentStreamPaymentFrequencyPeriod = 40753;
    const int PaymentStreamPaymentFrequencyUnit = 40754;
    const int PaymentStreamPaymentRollConvention = 40755;
    const int PaymentStreamFirstPaymentDateUnadjusted = 40756;
    const int PaymentStreamLastRegularPaymentDateUnadjusted = 40757;
    const int PaymentStreamPaymentDateRelativeTo = 40758;
    const int PaymentStreamPaymentDateOffsetPeriod = 40759;
    const int PaymentStreamPaymentDateOffsetUnit = 40760;
    const int PaymentStreamResetDateRelativeTo = 40761;
    const int PaymentStreamResetDateBusinessDayConvention = 40762;
    const int PaymentStreamResetDateBusinessCenter = 40763;
    const int PaymentStreamResetFrequencyPeriod = 40764;
    const int PaymentStreamResetFrequencyUnit = 40765;
    const int PaymentStreamResetWeeklyRollConvention = 40766;
    const int PaymentStreamInitialFixingDateRelativeTo = 40767;
    const int PaymentStreamInitialFixingDateBusinessDayConvention = 40768;
    const int PaymentStreamInitialFixingDateBusinessCenter = 40769;
    const int PaymentStreamInitialFixingDateOffsetPeriod = 40770;
    const int PaymentStreamInitialFixingDateOffsetUnit = 40771;
    const int PaymentStreamInitialFixingDateOffsetDayType = 40772;
    const int PaymentStreamInitialFixingDateAdjusted = 40773;
    const int PaymentStreamFixingDateRelativeTo = 40774;
    const int PaymentStreamFixingDateBusinessDayConvention = 40775;
    const int PaymentStreamFixingDateBusinessCenter = 40776;
    const int PaymentStreamFixingDateOffsetPeriod = 40777;
    const int PaymentStreamFixingDateOffsetUnit = 40778;
    const int PaymentStreamFixingDateOffsetDayType = 40779;
    const int PaymentStreamFixingDateAdjusted = 40780;
    const int PaymentStreamRateCutoffDateOffsetPeriod = 40781;
    const int PaymentStreamRateCutoffDateOffsetUnit = 40782;
    const int PaymentStreamRateCutoffDateOffsetDayType = 40783;
    const int PaymentStreamRate = 40784;
    const int PaymentStreamFixedAmount = 40785;
    const int PaymentStreamRateOrAmountCurrency = 40786;
    const int PaymentStreamFutureValueNotional = 40787;
    const int PaymentStreamFutureValueDateAdjusted = 40788;
    const int PaymentStreamRateIndex = 40789;
    const int PaymentStreamRateIndexSource = 40790;
    const int PaymentStreamRateIndexCurveUnit = 40791;
    const int PaymentStreamRateIndexCurvePeriod = 40792;
    const int PaymentStreamRateMultiplier = 40793;
    const int PaymentStreamRateSpread = 40794;
    const int PaymentStreamRateSpreadPositionType = 40795;
    const int PaymentStreamRateTreatment = 40796;
    const int PaymentStreamCapRate = 40797;
    const int PaymentStreamCapRateBuySide = 40798;
    const int PaymentStreamCapRateSellSide = 40799;
    const int PaymentStreamFloorRate = 40800;
    const int PaymentStreamFloorRateBuySide = 40801;
    const int PaymentStreamFloorRateSellSide = 40802;
    const int PaymentStreamInitialRate = 40803;
    const int PaymentStreamFinalRateRoundingDirection = 40804;
    const int PaymentStreamFinalRatePrecision = 40805;
    const int PaymentStreamAveragingMethod = 40806;
    const int PaymentStreamNegativeRateTreatment = 40807;
    const int PaymentStreamInflationLagPeriod = 40808;
    const int PaymentStreamInflationLagUnit = 40809;
    const int PaymentStreamInflationLagDayType = 40810;
    const int PaymentStreamInflationInterpolationMethod = 40811;
    const int PaymentStreamInflationIndexSource = 40812;
    const int PaymentStreamInflationPublicationSource = 40813;
    const int PaymentStreamInflationInitialIndexLevel = 40814;
    const int PaymentStreamInflationFallbackBondApplicable = 40815;
    const int PaymentStreamFRADiscounting = 40816;
    const int PaymentStreamNonDeliverableRefCurrency = 40817;
    const int PaymentStreamNonDeliverableFixingDatesBusinessDayConvention = 40818;
    const int PaymentStreamNonDeliverableFixingDatesBusinessCenter = 40819;
    const int PaymentStreamNonDeliverableFixingDatesRelativeTo = 40820;
    const int PaymentStreamNonDeliverableFixingDatesOffsetPeriod = 40821;
    const int PaymentStreamNonDeliverableFixingDatesOffsetUnit = 40822;
    const int PaymentStreamNonDeliverableFixingDatesOffsetDayType = 40823;
    const int UnderlyingPaymentStreamNonDeliverableSettlReferencePage = 40824;
    const int NoNonDeliverableFixingDates = 40825;
    const int NonDeliverableFixingDate = 40826;
    const int NonDeliverableFixingDateType = 40827;
    const int NoPaymentSchedules = 40828;
    const int PaymentScheduleType = 40829;
    const int PaymentScheduleStubType = 40830;
    const int PaymentScheduleStartDateUnadjusted = 40831;
    const int PaymentScheduleEndDateUnadjusted = 40832;
    const int PaymentSchedulePaySide = 40833;
    const int PaymentScheduleReceiveSide = 40834;
    const int PaymentScheduleNotional = 40835;
    const int PaymentScheduleCurrency = 40836;
    const int PaymentScheduleRate = 40837;
    const int PaymentScheduleRateMultiplier = 40838;
    const int PaymentScheduleRateSpread = 40839;
    const int PaymentScheduleRateSpreadPositionType = 40840;
    const int PaymentScheduleRateTreatment = 40841;
    const int PaymentScheduleFixedAmount = 40842;
    const int PaymentScheduleFixedCurrency = 40843;
    const int PaymentScheduleStepFrequencyPeriod = 40844;
    const int PaymentScheduleStepFrequencyUnit = 40845;
    const int PaymentScheduleStepOffsetValue = 40846;
    const int PaymentScheduleStepRate = 40847;
    const int PaymentScheduleStepOffsetRate = 40848;
    const int PaymentScheduleStepRelativeTo = 40849;
    const int PaymentScheduleFixingDateUnadjusted = 40850;
    const int PaymentScheduleWeight = 40851;
    const int PaymentScheduleFixingDateRelativeTo = 40852;
    const int PaymentScheduleFixingDateBusinessDayConvention = 40853;
    const int PaymentScheduleFixingDateBusinessCenter = 40854;
    const int PaymentScheduleFixingDateOffsetPeriod = 40855;
    const int PaymentScheduleFixingDateOffsetUnit = 40856;
    const int PaymentScheduleFixingDateOffsetDayType = 40857;
    const int PaymentScheduleFixingDateAdjusted = 40858;
    const int PaymentScheduleFixingTime = 40859;
    const int PaymentScheduleFixingTimeBusinessCenter = 40860;
    const int PaymentScheduleInterimExchangePaymentDateRelativeTo = 40861;
    const int PaymentScheduleInterimExchangeDatesBusinessDayConvention = 40862;
    const int PaymentScheduleInterimExchangeDatesBusinessCenter = 40863;
    const int PaymentScheduleInterimExchangeDatesOffsetPeriod = 40864;
    const int PaymentScheduleInterimExchangeDatesOffsetUnit = 40865;
    const int PaymentScheduleInterimExchangeDatesOffsetDayType = 40866;
    const int PaymentScheduleInterimExchangeDateAdjusted = 40867;
    const int NoPaymentScheduleRateSources = 40868;
    const int PaymentScheduleRateSource = 40869;
    const int PaymentScheduleRateSourceType = 40870;
    const int PaymentScheduleReferencePage = 40871;
    const int NoPaymentStubs = 40872;
    const int PaymentStubType = 40873;
    const int PaymentStubLength = 40874;
    const int PaymentStubRate = 40875;
    const int PaymentStubFixedAmount = 40876;
    const int PaymentStubFixedCurrency = 40877;
    const int PaymentStubIndex = 40878;
    const int PaymentStubIndexSource = 40879;
    const int PaymentStubIndexCurvePeriod = 40880;
    const int PaymentStubIndexCurveUnit = 40881;
    const int PaymentStubIndexRateMultiplier = 40882;
    const int PaymentStubIndexRateSpread = 40883;
    const int PaymentStubIndexRateSpreadPositionType = 40884;
    const int PaymentStubIndexRateTreatment = 40885;
    const int PaymentStubIndexCapRate = 40886;
    const int PaymentStubIndexCapRateBuySide = 40887;
    const int PaymentStubIndexCapRateSellSide = 40888;
    const int PaymentStubIndexFloorRate = 40889;
    const int PaymentStubIndexFloorRateBuySide = 40890;
    const int PaymentStubIndexFloorRateSellSide = 40891;
    const int PaymentStubIndex2 = 40892;
    const int PaymentStubIndex2Source = 40893;
    const int PaymentStubIndex2CurvePeriod = 40894;
    const int PaymentStubIndex2CurveUnit = 40895;
    const int PaymentStubIndex2RateMultiplier = 40896;
    const int PaymentStubIndex2RateSpread = 40897;
    const int PaymentStubIndex2RateSpreadPositionType = 40898;
    const int PaymentStubIndex2RateTreatment = 40899;
    const int PaymentStubIndex2CapRate = 40900;
    const int PaymentStubIndex2FloorRate = 40901;
    const int NoLegSettlRateFallbacks = 40902;
    const int LegSettlRatePostponementMaximumDays = 40903;
    const int UnderlyingSettlRateFallbackRateSource = 40904;
    const int LegSettlRatePostponementSurvey = 40905;
    const int LegSettlRatePostponementCalculationAgent = 40906;
    const int StreamEffectiveDateUnadjusted = 40907;
    const int StreamEffectiveDateBusinessDayConvention = 40908;
    const int StreamEffectiveDateBusinessCenter = 40909;
    const int StreamEffectiveDateRelativeTo = 40910;
    const int StreamEffectiveDateOffsetPeriod = 40911;
    const int StreamEffectiveDateOffsetUnit = 40912;
    const int StreamEffectiveDateOffsetDayType = 40913;
    const int StreamEffectiveDateAdjusted = 40914;
    const int UnderlyingSettlRateFallbackReferencePage = 40915;
    const int PaymentPriceType = 40919;
    const int PaymentStreamPaymentDateOffsetDayType = 40920;
    const int BusinessDayConvention = 40921;
    const int DateRollConvention = 40922;
    const int NoLegBusinessCenters = 40923;
    const int LegBusinessCenter = 40924;
    const int LegBusinessDayConvention = 40925;
    const int LegDateRollConvention = 40926;
    const int NoLegPaymentScheduleFixingDateBusinessCenters = 40927;
    const int NoLegPaymentScheduleInterimExchangeDateBusinessCenters = 40928;
    const int NoLegPaymentStreamNonDeliverableFixingDateBusinessCenters = 40929;
    const int NoLegPaymentStreamPaymentDateBusinessCenters = 40930;
    const int NoLegPaymentStreamResetDateBusinessCenters = 40931;
    const int NoLegPaymentStreamInitialFixingDateBusinessCenters = 40932;
    const int NoLegPaymentStreamFixingDateBusinessCenters = 40933;
    const int NoLegProvisionCashSettlPaymentDateBusinessCenters = 40934;
    const int NoLegProvisionCashSettlValueDateBusinessCenters = 40935;
    const int NoLegProvisionOptionExerciseBusinessCenters = 40936;
    const int NoLegProvisionOptionExpirationDateBusinessCenters = 40937;
    const int NoLegProvisionOptionRelevantUnderlyingDateBusinessCenters = 40938;
    const int NoLegProvisionDateBusinessCenters = 40939;
    const int NoLegStreamCalculationPeriodBusinessCenters = 40940;
    const int NoLegStreamFirstPeriodStartDateBusinessCenters = 40941;
    const int NoLegStreamEffectiveDateBusinessCenters = 40942;
    const int NoLegStreamTerminationDateBusinessCenters = 40943;
    const int NoPaymentBusinessCenters = 40944;
    const int NoPaymentScheduleInterimExchangeDateBusinessCenters = 40945;
    const int NoPaymentStreamNonDeliverableFixingDatesBusinessCenters = 40946;
    const int NoPaymentStreamPaymentDateBusinessCenters = 40947;
    const int NoPaymentStreamResetDateBusinessCenters = 40948;
    const int NoPaymentStreamInitialFixingDateBusinessCenters = 40949;
    const int NoPaymentStreamFixingDateBusinessCenters = 40950;
    const int NoProtectionTermEventNewsSources = 40951;
    const int NoProvisionCashSettlPaymentDateBusinessCenters = 40952;
    const int NoProvisionCashSettlValueDateBusinessCenters = 40953;
    const int NoProvisionOptionExerciseBusinessCenters = 40954;
    const int NoProvisionOptionExpirationDateBusinessCenters = 40955;
    const int NoProvisionOptionRelevantUnderlyingDateBusinessCenters = 40956;
    const int NoProvisionDateBusinessCenters = 40957;
    const int NoStreamCalculationPeriodBusinessCenters = 40958;
    const int NoStreamFirstPeriodStartDateBusinessCenters = 40959;
    const int NoStreamEffectiveDateBusinessCenters = 40960;
    const int NoStreamTerminationDateBusinessCenters = 40961;
    const int NoUnderlyingBusinessCenters = 40962;
    const int UnderlyingBusinessCenter = 40963;
    const int UnderlyingBusinessDayConvention = 40964;
    const int UnderlyingDateRollConvention = 40965;
    const int NoUnderlyingPaymentScheduleFixingDateBusinessCenters = 40966;
    const int NoUnderlyingPaymentScheduleInterimExchangeDateBusinessCenters = 40967;
    const int NoUnderlyingPaymentStreamNonDeliverableFixingDatesBizCenters = 40968;
    const int NoUnderlyingPaymentStreamPaymentDateBusinessCenters = 40969;
    const int NoUnderlyingPaymentStreamResetDateBusinessCenters = 40970;
    const int NoUnderlyingPaymentStreamInitialFixingDateBusinessCenters = 40971;
    const int NoUnderlyingPaymentStreamFixingDateBusinessCenters = 40972;
    const int NoUnderlyingStreamCalculationPeriodBusinessCenters = 40973;
    const int NoUnderlyingStreamFirstPeriodStartDateBusinessCenters = 40974;
    const int NoUnderlyingStreamEffectiveDateBusinessCenters = 40975;
    const int NoUnderlyingStreamTerminationDateBusinessCenters = 40976;
    const int NoPaymentScheduleFixingDateBusinessCenters = 40977;
    const int EncodedLegStreamTextLen = 40978;
    const int EncodedLegStreamText = 40979;
    const int EncodedLegProvisionTextLen = 40980;
    const int EncodedLegProvisionText = 40981;
    const int EncodedStreamTextLen = 40982;
    const int EncodedStreamText = 40983;
    const int EncodedPaymentTextLen = 40984;
    const int EncodedPaymentText = 40985;
    const int EncodedProvisionTextLen = 40986;
    const int EncodedProvisionText = 40987;
    const int EncodedUnderlyingStreamTextLen = 40988;
    const int EncodedUnderlyingStreamText = 40989;
    const int ProvisionCashSettlQuoteReferencePage = 41406;
    const int LegProvisionCashSettlQuoteReferencePage = 41407;
    const int EventMonthYear = 2340;
    const int LegEventMonthYear = 2341;
    const int UnderlyingEventMonthYear = 2342;
    const int PreviousClearingBusinessDate = 2084;
    const int ValuationDate = 2085;
    const int ValuationTime = 2086;
    const int ValuationBusinessCenter = 2087;
    const int MarginAmtFXRate = 2088;
    const int MarginAmtFXRateCalc = 2089;
    const int CollateralFXRate = 2090;
    const int CollateralFXRateCalc = 2091;
    const int CollateralAmountMarketSegmentID = 2092;
    const int CollateralAmountMarketID = 2093;
    const int PayCollectFXRate = 2094;
    const int PayCollectFXRateCalc = 2095;
    const int PosAmtStreamDesc = 2096;
    const int PositionFXRate = 2097;
    const int PositionFXRateCalc = 2098;
    const int PosAmtMarketSegmentID = 2099;
    const int PosAmtMarketID = 2100;
    const int TerminatedIndicator = 2101;
    const int ShortMarkingExemptIndicator = 2102;
    const int RelatedRegulatoryTradeIDSource = 2103;
    const int NoAttachments = 2104;
    const int AttachmentName = 2105;
    const int AttachmentMediaType = 2106;
    const int AttachmentClassification = 2107;
    const int AttachmentExternalURL = 2108;
    const int AttachmentEncodingType = 2109;
    const int UnencodedAttachmentLen = 2110;
    const int EncodedAttachmentLen = 2111;
    const int EncodedAttachment = 2112;
    const int NoAttachmentKeywords = 2113;
    const int AttachmentKeyword = 2114;
    const int NegotiationMethod = 2115;
    const int NextAuctionTime = 2116;
    const int NoAssetAttributes = 2304;
    const int AssetAttributeType = 2305;
    const int AssetAttributeValue = 2306;
    const int AssetAttributeLimit = 2307;
    const int CommRate = 1233;
    const int CommUnitOfMeasure = 1238;
    const int NoComplexEventAveragingObservations = 40994;
    const int ComplexEventAveragingObservationNumber = 40995;
    const int ComplexEventAveragingWeight = 40996;
    const int NoComplexEventCreditEvents = 40997;
    const int ComplexEventCreditEventType = 40998;
    const int ComplexEventCreditEventValue = 40999;
    const int ComplexEventCreditEventCurrency = 41000;
    const int ComplexEventCreditEventPeriod = 41001;
    const int ComplexEventCreditEventUnit = 41002;
    const int ComplexEventCreditEventDayType = 41003;
    const int ComplexEventCreditEventRateSource = 41004;
    const int NoComplexEventCreditEventQualifiers = 41005;
    const int ComplexEventCreditEventQualifier = 41006;
    const int NoComplexEventPeriodDateTimes = 41007;
    const int ComplexEventPeriodDate = 41008;
    const int ComplexEventPeriodTime = 41009;
    const int NoComplexEventPeriods = 41010;
    const int ComplexEventPeriodType = 41011;
    const int ComplexEventBusinessCenter = 41012;
    const int NoComplexEventRateSources = 41013;
    const int ComplexEventRateSource = 41014;
    const int ComplexEventRateSourceType = 41015;
    const int ComplexEventReferencePage = 41016;
    const int ComplexEventReferencePageHeading = 41017;
    const int NoComplexEventDateBusinessCenters = 41018;
    const int ComplexEventDateBusinessCenter = 41019;
    const int ComplexEventDateUnadjusted = 41020;
    const int ComplexEventDateRelativeTo = 41021;
    const int ComplexEventDateOffsetPeriod = 41022;
    const int ComplexEventDateOffsetUnit = 41023;
    const int ComplexEventDateOffsetDayType = 41024;
    const int ComplexEventDateBusinessDayConvention = 41025;
    const int ComplexEventDateAdjusted = 41026;
    const int ComplexEventFixingTime = 41027;
    const int ComplexEventFixingTimeBusinessCenter = 41028;
    const int NoComplexEventCreditEventSources = 41029;
    const int ComplexEventCreditEventSource = 41030;
    const int ComplexOptPayoutPaySide = 2117;
    const int ComplexOptPayoutReceiveSide = 2118;
    const int ComplexOptPayoutUnderlier = 2119;
    const int ComplexOptPayoutPercentage = 2120;
    const int ComplexOptPayoutTime = 2121;
    const int ComplexOptPayoutCurrency = 2122;
    const int ComplexEventPricePercentage = 2123;
    const int ComplexEventCurrencyOne = 2124;
    const int ComplexEventCurrencyTwo = 2125;
    const int ComplexEventQuoteBasis = 2126;
    const int ComplexEventFixedFXRate = 2127;
    const int ComplexEventDeterminationMethod = 2128;
    const int ComplexEventCalculationAgent = 2129;
    const int ComplexEventStrikePrice = 2130;
    const int ComplexEventStrikeFactor = 2131;
    const int ComplexEventStrikeNumberOfOptions = 2132;
    const int ComplexEventCreditEventsXIDRef = 2133;
    const int ComplexEventCreditEventNotifyingParty = 2134;
    const int ComplexEventCreditEventBusinessCenter = 2135;
    const int ComplexEventCreditEventStandardSources = 2136;
    const int ComplexEventCreditEventMinimumSources = 2137;
    const int ComplexEventXID = 2138;
    const int ComplexEventXIDRef = 2139;
    const int NoComplexEventSchedules = 41031;
    const int ComplexEventScheduleStartDate = 41032;
    const int ComplexEventScheduleEndDate = 41033;
    const int ComplexEventScheduleFrequencyPeriod = 41034;
    const int ComplexEventScheduleFrequencyUnit = 41035;
    const int ComplexEventScheduleRollConvention = 41036;
    const int NoDeliverySchedules = 41037;
    const int DeliveryScheduleType = 41038;
    const int DeliveryScheduleXID = 41039;
    const int DeliveryScheduleNotional = 41040;
    const int DeliveryScheduleNotionalUnitOfMeasure = 41041;
    const int DeliveryScheduleNotionalCommodityFrequency = 41042;
    const int DeliveryScheduleNegativeTolerance = 41043;
    const int DeliverySchedulePositiveTolerance = 41044;
    const int DeliveryScheduleToleranceUnitOfMeasure = 41045;
    const int DeliveryScheduleToleranceType = 41046;
    const int DeliveryScheduleSettlCountry = 41047;
    const int DeliveryScheduleSettlTimeZone = 41048;
    const int DeliveryScheduleSettlFlowType = 41049;
    const int DeliveryScheduleSettlHolidaysProcessingInstruction = 41050;
    const int NoDeliveryScheduleSettlDays = 41051;
    const int DeliveryScheduleSettlDay = 41052;
    const int DeliveryScheduleSettlTotalHours = 41053;
    const int NoDeliveryScheduleSettlTimes = 41054;
    const int DeliveryScheduleSettlStart = 41055;
    const int DeliveryScheduleSettlEnd = 41056;
    const int DeliveryScheduleSettlTimeType = 41057;
    const int DeliveryStreamType = 41058;
    const int DeliveryStreamPipeline = 41059;
    const int DeliveryStreamEntryPoint = 41060;
    const int DeliveryStreamWithdrawalPoint = 41061;
    const int DeliveryStreamDeliveryPoint = 41062;
    const int DeliveryStreamDeliveryRestriction = 41063;
    const int DeliveryStreamDeliveryContingency = 41064;
    const int DeliveryStreamDeliveryContingentPartySide = 41065;
    const int DeliveryStreamDeliverAtSourceIndicator = 41066;
    const int DeliveryStreamRiskApportionment = 41067;
    const int DeliveryStreamRiskApportionmentSource = 41218;
    const int DeliveryStreamTitleTransferLocation = 41068;
    const int DeliveryStreamTitleTransferCondition = 41069;
    const int DeliveryStreamImporterOfRecord = 41070;
    const int DeliveryStreamNegativeTolerance = 41071;
    const int DeliveryStreamPositiveTolerance = 41072;
    const int DeliveryStreamToleranceUnitOfMeasure = 41073;
    const int DeliveryStreamToleranceType = 41074;
    const int DeliveryStreamToleranceOptionSide = 41075;
    const int DeliveryStreamTotalPositiveTolerance = 41076;
    const int DeliveryStreamTotalNegativeTolerance = 41077;
    const int DeliveryStreamNotionalConversionFactor = 41078;
    const int DeliveryStreamTransportEquipment = 41079;
    const int DeliveryStreamElectingPartySide = 41080;
    const int NoDeliveryStreamCycles = 41081;
    const int DeliveryStreamCycleDesc = 41082;
    const int EncodedDeliveryStreamCycleDescLen = 41083;
    const int EncodedDeliveryStreamCycleDesc = 41084;
    const int NoDeliveryStreamCommoditySources = 41085;
    const int DeliveryStreamCommoditySource = 41086;
    const int DocumentationText = 1513;
    const int EncodedDocumentationTextLen = 1525;
    const int EncodedDocumentationText = 1527;
    const int SwapSubClass = 1575;
    const int SettlRateIndex = 1577;
    const int SettlRateIndexLocation = 1580;
    const int OptionExpirationDesc = 1581;
    const int EncodedOptionExpirationDescLen = 1678;
    const int EncodedOptionExpirationDesc = 1697;
    const int StrikeUnitOfMeasure = 1698;
    const int StrikeIndex = 1866;
    const int StrikeIndexSpread = 2001;
    const int ValuationSource = 2002;
    const int ValuationReferenceModel = 2140;
    const int StrategyType = 2141;
    const int CommonPricingIndicator = 2142;
    const int SettlDisruptionProvision = 2143;
    const int InstrumentRoundingDirection = 2144;
    const int InstrumentRoundingPrecision = 2145;
    const int LegSettleOnOpenFlag = 2146;
    const int LegInstrmtAssignmentMethod = 2147;
    const int LegSecurityStatus = 2148;
    const int LegRestructuringType = 2149;
    const int LegSeniority = 2150;
    const int LegNotionalPercentageOutstanding = 2151;
    const int LegOriginalNotionalPercentageOutstanding = 2152;
    const int LegAttachmentPoint = 2153;
    const int LegDetachmentPoint = 2154;
    const int LegObligationType = 2155;
    const int LegSwapSubClass = 2156;
    const int LegNthToDefault = 2157;
    const int LegMthToDefault = 2158;
    const int LegSettledEntityMatrixSource = 2159;
    const int LegSettledEntityMatrixPublicationDate = 2160;
    const int LegCouponType = 2161;
    const int LegTotalIssuedAmount = 2162;
    const int LegCouponFrequencyPeriod = 2163;
    const int LegCouponFrequencyUnit = 2164;
    const int LegCouponDayCount = 2165;
    const int LegConvertibleBondEquityID = 2166;
    const int LegConvertibleBondEquityIDSource = 2167;
    const int LegContractPriceRefMonth = 2168;
    const int LegLienSeniority = 2169;
    const int LegLoanFacility = 2170;
    const int LegReferenceEntityType = 2171;
    const int LegIndexSeries = 2172;
    const int LegIndexAnnexVersion = 2173;
    const int LegIndexAnnexDate = 2174;
    const int LegIndexAnnexSource = 2175;
    const int LegSettlRateIndex = 2176;
    const int LegSettlRateIndexLocation = 2177;
    const int LegOptionExpirationDesc = 2178;
    const int EncodedLegOptionExpirationDescLen = 2179;
    const int EncodedLegOptionExpirationDesc = 2180;
    const int LegStrikeMultiplier = 2181;
    const int LegStrikeValue = 2182;
    const int LegStrikeUnitOfMeasure = 2183;
    const int LegStrikeIndex = 2184;
    const int LegStrikeIndexSpread = 2185;
    const int LegStrikePriceDeterminationMethod = 2186;
    const int LegStrikePriceBoundaryMethod = 2187;
    const int LegStrikePriceBoundaryPrecision = 2188;
    const int LegUnderlyingPriceDeterminationMethod = 2189;
    const int LegMinPriceIncrement = 2190;
    const int LegMinPriceIncrementAmount = 2191;
    const int LegSettlMethod = 2192;
    const int LegOptPayoutType = 2193;
    const int LegOptPayoutAmount = 2194;
    const int LegPriceQuoteMethod = 2195;
    const int LegValuationMethod = 2196;
    const int LegValuationSource = 2197;
    const int LegValuationReferenceModel = 2198;
    const int LegListMethod = 2199;
    const int LegCapPrice = 2200;
    const int LegFloorPrice = 2201;
    const int LegFlexibleIndicator = 2202;
    const int LegFlexProductEligibilityIndicator = 2203;
    const int LegPositionLimit = 2205;
    const int LegNTPositionLimit = 2206;
    const int LegCPProgram = 2207;
    const int LegCPRegType = 2208;
    const int LegShortSaleRestriction = 2209;
    const int LegStrategyType = 2211;
    const int LegCommonPricingIndicator = 2212;
    const int LegSettlDisruptionProvision = 2213;
    const int LegInstrumentRoundingDirection = 2214;
    const int LegInstrumentRoundingPrecision = 2215;
    const int MarketDisruptionProvision = 41087;
    const int MarketDisruptionFallbackProvision = 41088;
    const int MarketDisruptionMaximumDays = 41089;
    const int MarketDisruptionMaterialityPercentage = 41090;
    const int MarketDisruptionMinimumFuturesContracts = 41091;
    const int NoMarketDisruptionEvents = 41092;
    const int MarketDisruptionEvent = 41093;
    const int NoMarketDisruptionFallbacks = 41094;
    const int MarketDisruptionFallbackType = 41095;
    const int NoMarketDisruptionFallbackReferencePrices = 41096;
    const int MarketDisruptionFallbackUnderlierType = 41097;
    const int MarketDisruptionFallbackUnderlierSecurityID = 41098;
    const int MarketDisruptionFallbackUnderlierSecurityIDSource = 41099;
    const int MarketDisruptionFallbackUnderlierSecurityDesc = 41100;
    const int EncodedMarketDisruptionFallbackUnderlierSecurityDescLen = 41101;
    const int EncodedMarketDisruptionFallbackUnderlierSecurityDesc = 41102;
    const int MarketDisruptionFallbackOpenUnits = 41103;
    const int MarketDisruptionFallbackBasketCurrency = 41104;
    const int MarketDisruptionFallbackBasketDivisor = 41105;
    const int MiscFeeRate = 2216;
    const int MiscFeeAmountDue = 2217;
    const int ExerciseDesc = 41106;
    const int EncodedExerciseDescLen = 41107;
    const int EncodedExerciseDesc = 41108;
    const int AutomaticExerciseIndicator = 41109;
    const int AutomaticExerciseThresholdRate = 41110;
    const int ExerciseConfirmationMethod = 41111;
    const int ManualNoticeBusinessCenter = 41112;
    const int FallbackExerciseIndicator = 41113;
    const int LimitedRightToConfirmIndicator = 41114;
    const int ExerciseSplitTicketIndicator = 41115;
    const int NoOptionExerciseBusinessCenters = 41116;
    const int OptionExerciseBusinessCenter = 41117;
    const int OptionExerciseBusinessDayConvention = 41118;
    const int OptionExerciseEarliestDateOffsetDayType = 41119;
    const int OptionExerciseEarliestDateOffsetPeriod = 41120;
    const int OptionExerciseEarliestDateOffsetUnit = 41121;
    const int OptionExerciseFrequencyPeriod = 41122;
    const int OptionExerciseFrequencyUnit = 41123;
    const int OptionExerciseStartDateUnadjusted = 41124;
    const int OptionExerciseStartDateRelativeTo = 41125;
    const int OptionExerciseStartDateOffsetPeriod = 41126;
    const int OptionExerciseStartDateOffsetUnit = 41127;
    const int OptionExerciseStartDateOffsetDayType = 41128;
    const int OptionExerciseStartDateAdjusted = 41129;
    const int OptionExerciseSkip = 41130;
    const int OptionExerciseNominationDeadline = 41131;
    const int OptionExerciseFirstDateUnadjusted = 41132;
    const int OptionExerciseLastDateUnadjusted = 41133;
    const int OptionExerciseEarliestTime = 41134;
    const int OptionExerciseLatestTime = 41135;
    const int OptionExerciseTimeBusinessCenter = 41136;
    const int NoOptionExerciseDates = 41137;
    const int OptionExerciseDate = 41138;
    const int OptionExerciseDateType = 41139;
    const int NoOptionExerciseExpirationDateBusinessCenters = 41140;
    const int OptionExerciseExpirationDateBusinessCenter = 41141;
    const int OptionExerciseExpirationDateBusinessDayConvention = 41142;
    const int OptionExerciseExpirationDateRelativeTo = 41143;
    const int OptionExerciseExpirationDateOffsetPeriod = 41144;
    const int OptionExerciseExpirationDateOffsetUnit = 41145;
    const int OptionExerciseExpirationFrequencyPeriod = 41146;
    const int OptionExerciseExpirationFrequencyUnit = 41147;
    const int OptionExerciseExpirationRollConvention = 41148;
    const int OptionExerciseExpirationDateOffsetDayType = 41149;
    const int OptionExerciseExpirationTime = 41150;
    const int OptionExerciseExpirationTimeBusinessCenter = 41151;
    const int NoOptionExerciseExpirationDates = 41152;
    const int OptionExerciseExpirationDate = 41153;
    const int OptionExerciseExpirationDateType = 41154;
    const int PaymentUnitOfMeasure = 41155;
    const int PaymentDateRelativeTo = 41156;
    const int PaymentDateOffsetPeriod = 41157;
    const int PaymentDateOffsetUnit = 41158;
    const int PaymentDateOffsetDayType = 41159;
    const int PaymentForwardStartType = 41160;
    const int NoPaymentScheduleFixingDays = 41161;
    const int PaymentScheduleFixingDayOfWeek = 41162;
    const int PaymentScheduleFixingDayNumber = 41163;
    const int PaymentScheduleXID = 41164;
    const int PaymentScheduleXIDRef = 41165;
    const int PaymentScheduleRateCurrency = 41166;
    const int PaymentScheduleRateUnitOfMeasure = 41167;
    const int PaymentScheduleRateConversionFactor = 41168;
    const int PaymentScheduleRateSpreadType = 41169;
    const int PaymentScheduleSettlPeriodPrice = 41170;
    const int PaymentScheduleSettlPeriodPriceCurrency = 41171;
    const int PaymentScheduleSettlPeriodPriceUnitOfMeasure = 41172;
    const int PaymentScheduleStepUnitOfMeasure = 41173;
    const int PaymentScheduleFixingDayDistribution = 41174;
    const int PaymentScheduleFixingDayCount = 41175;
    const int PaymentScheduleFixingLagPeriod = 41176;
    const int PaymentScheduleFixingLagUnit = 41177;
    const int PaymentScheduleFixingFirstObservationDateOffsetPeriod = 41178;
    const int PaymentScheduleFixingFirstObservationDateOffsetUnit = 41179;
    const int PaymentStreamFlatRateIndicator = 41180;
    const int PaymentStreamFlatRateAmount = 41181;
    const int PaymentStreamFlatRateCurrency = 41182;
    const int PaymentStreamMaximumPaymentAmount = 41183;
    const int PaymentStreamMaximumPaymentCurrency = 41184;
    const int PaymentStreamMaximumTransactionAmount = 41185;
    const int PaymentStreamMaximumTransactionCurrency = 41186;
    const int PaymentStreamFixedAmountUnitOfMeasure = 41187;
    const int PaymentStreamTotalFixedAmount = 41188;
    const int PaymentStreamWorldScaleRate = 41189;
    const int PaymentStreamContractPrice = 41190;
    const int PaymentStreamContractPriceCurrency = 41191;
    const int NoPaymentStreamPricingBusinessCenters = 41192;
    const int PaymentStreamPricingBusinessCenter = 41193;
    const int PaymentStreamRateIndex2CurvePeriod = 41194;
    const int PaymentStreamRateIndex2CurveUnit = 41195;
    const int PaymentStreamRateIndexLocation = 41196;
    const int PaymentStreamRateIndexLevel = 41197;
    const int PaymentStreamRateIndexUnitOfMeasure = 41198;
    const int PaymentStreamSettlLevel = 41199;
    const int PaymentStreamReferenceLevel = 41200;
    const int PaymentStreamReferenceLevelUnitOfMeasure = 41201;
    const int PaymentStreamReferenceLevelEqualsZeroIndicator = 41202;
    const int PaymentStreamRateSpreadCurrency = 41203;
    const int PaymentStreamRateSpreadUnitOfMeasure = 41204;
    const int PaymentStreamRateConversionFactor = 41205;
    const int PaymentStreamRateSpreadType = 41206;
    const int PaymentStreamLastResetRate = 41207;
    const int PaymentStreamFinalRate = 41208;
    const int PaymentStreamCalculationLagPeriod = 41209;
    const int PaymentStreamCalculationLagUnit = 41210;
    const int PaymentStreamFirstObservationDateOffsetPeriod = 41211;
    const int PaymentStreamFirstObservationDateOffsetUnit = 41212;
    const int PaymentStreamPricingDayType = 41213;
    const int PaymentStreamPricingDayDistribution = 41214;
    const int PaymentStreamPricingDayCount = 41215;
    const int PaymentStreamPricingBusinessCalendar = 41216;
    const int PaymentStreamPricingBusinessDayConvention = 41217;
    const int NoPaymentStreamPaymentDates = 41220;
    const int PaymentStreamPaymentDate = 41221;
    const int PaymentStreamPaymentDateType = 41222;
    const int PaymentStreamMasterAgreementPaymentDatesIndicator = 41223;
    const int NoPaymentStreamPricingDates = 41224;
    const int PaymentStreamPricingDate = 41225;
    const int PaymentStreamPricingDateType = 41226;
    const int NoPaymentStreamPricingDays = 41227;
    const int PaymentStreamPricingDayOfWeek = 41228;
    const int PaymentStreamPricingDayNumber = 41229;
    const int NoPricingDateBusinessCenters = 41230;
    const int PricingDateBusinessCenter = 41231;
    const int PricingDateUnadjusted = 41232;
    const int PricingDateBusinessDayConvention = 41233;
    const int PricingDateAdjusted = 41234;
    const int PricingTime = 41235;
    const int PricingTimeBusinessCenter = 41236;
    const int NoStreamAssetAttributes = 41237;
    const int StreamAssetAttributeType = 41238;
    const int StreamAssetAttributeValue = 41239;
    const int StreamAssetAttributeLimit = 41240;
    const int NoStreamCalculationPeriodDates = 41241;
    const int StreamCalculationPeriodDate = 41242;
    const int StreamCalculationPeriodDateType = 41243;
    const int StreamCalculationPeriodDatesXID = 41244;
    const int StreamCalculationPeriodDatesXIDRef = 41245;
    const int StreamCalculationBalanceOfFirstPeriod = 41246;
    const int StreamCalculationCorrectionPeriod = 41247;
    const int StreamCalculationCorrectionUnit = 41248;
    const int NoStreamCommoditySettlBusinessCenters = 41249;
    const int StreamCommoditySettlBusinessCenter = 41250;
    const int StreamCommodityBase = 41251;
    const int StreamCommodityType = 41252;
    const int StreamCommoditySecurityID = 41253;
    const int StreamCommoditySecurityIDSource = 41254;
    const int StreamCommodityDesc = 41255;
    const int EncodedStreamCommodityDescLen = 41256;
    const int EncodedStreamCommodityDesc = 41257;
    const int StreamCommodityUnitOfMeasure = 41258;
    const int StreamCommodityCurrency = 41259;
    const int StreamCommodityExchange = 41260;
    const int StreamCommodityRateSource = 41261;
    const int StreamCommodityRateReferencePage = 41262;
    const int StreamCommodityRateReferencePageHeading = 41263;
    const int StreamDataProvider = 41264;
    const int StreamCommodityPricingType = 41265;
    const int StreamCommodityNearbySettlDayPeriod = 41266;
    const int StreamCommodityNearbySettlDayUnit = 41267;
    const int StreamCommoditySettlDateUnadjusted = 41268;
    const int StreamCommoditySettlDateBusinessDayConvention = 41269;
    const int StreamCommoditySettlDateAdjusted = 41270;
    const int StreamCommoditySettlMonth = 41271;
    const int StreamCommoditySettlDateRollPeriod = 41272;
    const int StreamCommoditySettlDateRollUnit = 41273;
    const int StreamCommoditySettlDayType = 41274;
    const int StreamCommodityXID = 41275;
    const int StreamCommodityXIDRef = 41276;
    const int NoStreamCommodityAltIDs = 41277;
    const int StreamCommodityAltID = 41278;
    const int StreamCommodityAltIDSource = 41279;
    const int NoStreamCommodityDataSources = 41280;
    const int StreamCommodityDataSourceID = 41281;
    const int StreamCommodityDataSourceIDType = 41282;
    const int NoStreamCommoditySettlDays = 41283;
    const int StreamCommoditySettlDay = 41284;
    const int StreamCommoditySettlTotalHours = 41285;
    const int NoStreamCommoditySettlTimes = 41286;
    const int StreamCommoditySettlStart = 41287;
    const int StreamCommoditySettlEnd = 41288;
    const int StreamCommoditySettlTimeType = 41588;
    const int NoStreamCommoditySettlPeriods = 41289;
    const int StreamCommoditySettlCountry = 41290;
    const int StreamCommoditySettlTimeZone = 41291;
    const int StreamCommoditySettlFlowType = 41292;
    const int StreamCommoditySettlPeriodNotional = 41293;
    const int StreamCommoditySettlPeriodNotionalUnitOfMeasure = 41294;
    const int StreamCommoditySettlPeriodFrequencyPeriod = 41295;
    const int StreamCommoditySettlPeriodFrequencyUnit = 41296;
    const int StreamCommoditySettlPeriodPrice = 41297;
    const int StreamCommoditySettlPeriodPriceUnitOfMeasure = 41298;
    const int StreamCommoditySettlPeriodPriceCurrency = 41299;
    const int StreamCommoditySettlHolidaysProcessingInstruction = 41300;
    const int StreamCommoditySettlPeriodXID = 41301;
    const int StreamCommoditySettlPeriodXIDRef = 41302;
    const int StreamXID = 41303;
    const int StreamNotionalXIDRef = 41305;
    const int StreamNotionalFrequencyPeriod = 41306;
    const int StreamNotionalFrequencyUnit = 41307;
    const int StreamNotionalCommodityFrequency = 41308;
    const int StreamNotionalUnitOfMeasure = 41309;
    const int StreamTotalNotional = 41310;
    const int StreamTotalNotionalUnitOfMeasure = 41311;
    const int NoMandatoryClearingJurisdictions = 41312;
    const int MandatoryClearingJurisdiction = 41313;
    const int LastQtyChanged = 2301;
    const int TradeVersion = 2302;
    const int HistoricalReportIndicator = 2303;
    const int NoLegAdditionalTermBondRefs = 41316;
    const int LegAdditionalTermBondSecurityID = 41317;
    const int LegAdditionalTermBondSecurityIDSource = 41318;
    const int LegAdditionalTermBondDesc = 41319;
    const int EncodedLegAdditionalTermBondDescLen = 41320;
    const int EncodedLegAdditionalTermBondDesc = 41321;
    const int LegAdditionalTermBondCurrency = 41322;
    const int LegAdditionalTermBondIssuer = 41323;
    const int EncodedLegAdditionalTermBondIssuerLen = 41324;
    const int EncodedLegAdditionalTermBondIssuer = 41325;
    const int LegAdditionalTermBondSeniority = 41326;
    const int LegAdditionalTermBondCouponType = 41327;
    const int LegAdditionalTermBondCouponRate = 41328;
    const int LegAdditionalTermBondMaturityDate = 41329;
    const int LegAdditionalTermBondParValue = 41330;
    const int LegAdditionalTermBondCurrentTotalIssuedAmount = 41331;
    const int LegAdditionalTermBondCouponFrequencyPeriod = 41332;
    const int LegAdditionalTermBondCouponFrequencyUnit = 41333;
    const int LegAdditionalTermBondDayCount = 41334;
    const int NoLegAdditionalTerms = 41335;
    const int LegAdditionalTermConditionPrecedentBondIndicator = 41336;
    const int LegAdditionalTermDiscrepancyClauseIndicator = 41337;
    const int NoLegAssetAttributes = 2308;
    const int LegAssetAttributeType = 2309;
    const int LegAssetAttributeValue = 2310;
    const int LegAssetAttributeLimit = 2311;
    const int NoLegCashSettlDealers = 41342;
    const int LegCashSettlDealer = 41343;
    const int NoLegCashSettlTerms = 41344;
    const int LegCashSettlCurrency = 41345;
    const int LegCasSettlValuationFirstBusinessDayOffset = 41346;
    const int LegCashSettlValuationSubsequentBusinessDaysOffset = 41347;
    const int LegCashSettlNumOfValuationDates = 41348;
    const int LegCashSettlValuationTime = 41349;
    const int LegCashSettlBusinessCenter = 41350;
    const int LegCashSettlQuoteMethod = 41351;
    const int LegCashSettlQuoteAmount = 41352;
    const int LegCashSettlQuoteCurrency = 41353;
    const int LegCashSettlMinimumQuoteAmount = 41354;
    const int LegCashSettlMinimumQuoteCurrency = 41355;
    const int LegCashSettlBusinessDays = 41356;
    const int LegCashSettlAmount = 41357;
    const int LegCashSettlRecoveryFactor = 41358;
    const int LegCashSettlFixedTermIndicator = 41359;
    const int LegCashSettlAccruedInterestIndicator = 41360;
    const int LegCashSettlValuationMethod = 41361;
    const int LegCashSettlTermXID = 41362;
    const int NoLegComplexEventAveragingObservations = 41363;
    const int LegComplexEventAveragingObservationNumber = 41364;
    const int LegComplexEventAveragingWeight = 41365;
    const int NoLegComplexEventCreditEvents = 41366;
    const int LegComplexEventCreditEventType = 41367;
    const int LegComplexEventCreditEventValue = 41368;
    const int LegComplexEventCreditEventCurrency = 41369;
    const int LegComplexEventCreditEventPeriod = 41370;
    const int LegComplexEventCreditEventUnit = 41371;
    const int LegComplexEventCreditEventDayType = 41372;
    const int LegComplexEventCreditEventRateSource = 41373;
    const int NoLegComplexEventCreditEventQualifiers = 41374;
    const int LegComplexEventCreditEventQualifier = 41375;
    const int NoLegComplexEventPeriodDateTimes = 41376;
    const int LegComplexEventPeriodDate = 41377;
    const int LegComplexEventPeriodTime = 41378;
    const int NoLegComplexEventPeriods = 41379;
    const int LegComplexEventPeriodType = 41380;
    const int LegComplexEventBusinessCenter = 41381;
    const int NoLegComplexEventRateSources = 41382;
    const int LegComplexEventRateSource = 41383;
    const int LegComplexEventRateSourceType = 41384;
    const int LegComplexEventReferencePage = 41385;
    const int LegComplexEvenReferencePageHeading = 41386;
    const int NoLegComplexEventDateBusinessCenters = 41387;
    const int LegComplexEventDateBusinessCenter = 41388;
    const int LegComplexEventDateUnadjusted = 41389;
    const int LegComplexEventDateRelativeTo = 41390;
    const int LegComplexEventDateOffsetPeriod = 41391;
    const int LegComplexEventDateOffsetUnit = 41392;
    const int LegComplexEventDateOffsetDayType = 41393;
    const int LegComplexEventDateBusinessDayConvention = 41394;
    const int LegComplexEventDateAdjusted = 41395;
    const int LegComplexEventFixingTime = 41396;
    const int LegComplexEventFixingTimeBusinessCenter = 41397;
    const int NoLegComplexEventCreditEventSources = 41398;
    const int LegComplexEventCreditEventSource = 41399;
    const int NoLegComplexEvents = 2218;
    const int LegComplexEventType = 2219;
    const int LegComplexOptPayoutPaySide = 2220;
    const int LegComplexOptPayoutReceiveSide = 2221;
    const int LegComplexOptPayoutUnderlier = 2222;
    const int LegComplexOptPayoutAmount = 2223;
    const int LegComplexOptPayoutPercentage = 2224;
    const int LegComplexOptPayoutTime = 2225;
    const int LegComplexOptPayoutCurrency = 2226;
    const int LegComplexEventPrice = 2227;
    const int LegComplexEventPricePercentage = 2228;
    const int LegComplexEventPriceBoundaryMethod = 2229;
    const int LegComplexEventPriceBoundaryPrecision = 2230;
    const int LegComplexEventPriceTimeType = 2231;
    const int LegComplexEventCondition = 2232;
    const int LegComplexEventCurrencyOne = 2233;
    const int LegComplexEventCurrencyTwo = 2234;
    const int LegComplexEventQuoteBasis = 2235;
    const int LegComplexEventFixedFXRate = 2236;
    const int LegComplexEventDeterminationMethod = 2237;
    const int LegComplexEventCalculationAgent = 2238;
    const int LegComplexEventStrikePrice = 2239;
    const int LegComplexEventStrikeFactor = 2240;
    const int LegComplexEventStrikeNumberOfOptions = 2241;
    const int LegComplexEventCreditEventsXIDRef = 2242;
    const int LegComplexEventCreditEventNotifyingParty = 2243;
    const int LegComplexEventCreditEventBusinessCenter = 2244;
    const int LegComplexEventCreditEventStandardSources = 2245;
    const int LegComplexEventCreditEventMinimumSources = 2246;
    const int LegComplexEventXID = 2248;
    const int LegComplexEventXIDRef = 2249;
    const int NoLegComplexEventDates = 2250;
    const int LegComplexEventStartDate = 2251;
    const int LegComplexEventEndDate = 2252;
    const int NoLegComplexEventTimes = 2253;
    const int LegComplexEventStartTime = 2204;
    const int LegComplexEventEndTime = 2247;
    const int NoLegComplexEventSchedules = 41400;
    const int LegComplexEventScheduleStartDate = 41401;
    const int LegComplexEventScheduleEndDate = 41402;
    const int LegComplexEventScheduleFrequencyPeriod = 41403;
    const int LegComplexEventScheduleFrequencyUnit = 41404;
    const int LegComplexEventScheduleRollConvention = 41405;
    const int NoLegDeliverySchedules = 41408;
    const int LegDeliveryScheduleType = 41409;
    const int LegDeliveryScheduleXID = 41410;
    const int LegDeliveryScheduleNotional = 41411;
    const int LegDeliveryScheduleNotionalUnitOfMeasure = 41412;
    const int LegDeliveryScheduleNotionalCommodityFrequency = 41413;
    const int LegDeliveryScheduleNegativeTolerance = 41414;
    const int LegDeliverySchedulePositiveTolerance = 41415;
    const int LegDeliveryScheduleToleranceUnitOfMeasure = 41416;
    const int LegDeliveryScheduleToleranceType = 41417;
    const int LegDeliveryScheduleSettlCountry = 41418;
    const int LegDeliveryScheduleSettlTimeZone = 41419;
    const int LegDeliveryScheduleSettlFlowType = 41420;
    const int LegDeliveryScheduleSettlHolidaysProcessingInstruction = 41421;
    const int NoLegDeliveryScheduleSettlDays = 41422;
    const int LegDeliveryScheduleSettlDay = 41423;
    const int LegDeliveryScheduleSettlTotalHours = 41424;
    const int NoLegDeliveryScheduleSettlTimes = 41425;
    const int LegDeliveryScheduleSettlStart = 41426;
    const int LegDeliveryScheduleSettlEnd = 41427;
    const int LegDeliveryScheduleSettlTimeType = 41428;
    const int LegDeliveryStreamType = 41429;
    const int LegDeliveryStreamPipeline = 41430;
    const int LegDeliveryStreamEntryPoint = 41431;
    const int LegDeliveryStreamWithdrawalPoint = 41432;
    const int LegDeliveryStreamDeliveryPoint = 41433;
    const int LegDeliveryStreamDeliveryRestriction = 41434;
    const int LegDeliveryStreamDeliveryContingency = 41435;
    const int LegDeliveryStreamDeliveryContingentPartySide = 41436;
    const int LegDeliveryStreamDeliverAtSourceIndicator = 41437;
    const int LegDeliveryStreamRiskApportionment = 41438;
    const int LegDeliveryStreamRiskApportionmentSource = 41219;
    const int LegDeliveryStreamTitleTransferLocation = 41439;
    const int LegDeliveryStreamTitleTransferCondition = 41440;
    const int LegDeliveryStreamImporterOfRecord = 41441;
    const int LegDeliveryStreamNegativeTolerance = 41442;
    const int LegDeliveryStreamPositiveTolerance = 41443;
    const int LegDeliveryStreamToleranceUnitOfMeasure = 41444;
    const int LegDeliveryStreamToleranceType = 41445;
    const int LegDeliveryStreamToleranceOptionSide = 41446;
    const int LegDeliveryStreamTotalPositiveTolerance = 41447;
    const int LegDeliveryStreamTotalNegativeTolerance = 41448;
    const int LegDeliveryStreamNotionalConversionFactor = 41449;
    const int LegDeliveryStreamTransportEquipment = 41450;
    const int LegDeliveryStreamElectingPartySide = 41451;
    const int NoLegStreamAssetAttributes = 41452;
    const int LegStreamAssetAttributeType = 41453;
    const int LegStreamAssetAttributeValue = 41454;
    const int LegStreamAssetAttributeLimit = 41455;
    const int NoLegDeliveryStreamCycles = 41456;
    const int LegDeliveryStreamCycleDesc = 41457;
    const int EncodedLegDeliveryStreamCycleDescLen = 41458;
    const int EncodedLegDeliveryStreamCycleDesc = 41459;
    const int NoLegDeliveryStreamCommoditySources = 41460;
    const int LegDeliveryStreamCommoditySource = 41461;
    const int NoLegInstrumentParties = 2254;
    const int LegInstrumentPartyID = 2255;
    const int LegInstrumentPartyIDSource = 2256;
    const int LegInstrumentPartyRole = 2257;
    const int NoLegInstrumentPartySubIDs = 2258;
    const int LegInstrumentPartySubID = 2259;
    const int LegInstrumentPartySubIDType = 2260;
    const int LegMarketDisruptionProvision = 41462;
    const int LegMarketDisruptionFallbackProvision = 41463;
    const int LegMarketDisruptionMaximumDays = 41464;
    const int LegMarketDisruptionMaterialityPercentage = 41465;
    const int LegMarketDisruptionMinimumFuturesContracts = 41466;
    const int NoLegMarketDisruptionEvents = 41467;
    const int LegMarketDisruptionEvent = 41468;
    const int NoLegMarketDisruptionFallbacks = 41469;
    const int LegMarketDisruptionFallbackType = 41470;
    const int NoLegMarketDisruptionFallbackReferencePrices = 41471;
    const int LegMarketDisruptionFallbackUnderlierType = 41472;
    const int LegMarketDisruptionFallbackUnderlierSecurityID = 41473;
    const int LegMarketDisruptionFallbackUnderlierSecurityIDSource = 41474;
    const int LegMarketDisruptionFallbackUnderlierSecurityDesc = 41475;
    const int EncodedLegMarketDisruptionFallbackUnderlierSecurityDescLen = 41476;
    const int EncodedLegMarketDisruptionFallbackUnderlierSecurityDesc = 41477;
    const int LegMarketDisruptionFallbackOpenUnits = 41478;
    const int LegMarketDisruptionFallbackBasketCurrency = 41479;
    const int LegMarketDisruptionFallbackBasketDivisor = 41480;
    const int LegExerciseDesc = 41481;
    const int EncodedLegExerciseDescLen = 41482;
    const int EncodedLegExerciseDesc = 41483;
    const int LegAutomaticExerciseIndicator = 41484;
    const int LegAutomaticExerciseThresholdRate = 41485;
    const int LegExerciseConfirmationMethod = 41486;
    const int LegManualNoticeBusinessCenter = 41487;
    const int LegFallbackExerciseIndicator = 41488;
    const int LegLimitRightToConfirmIndicator = 41489;
    const int LegExerciseSplitTicketIndicator = 41490;
    const int NoLegOptionExerciseBusinessCenters = 41491;
    const int LegOptionExerciseBusinessCenter = 41492;
    const int LegOptionExerciseBusinessDayConvention = 41493;
    const int LegOptionExerciseEarliestDateOffsetDayType = 41494;
    const int LegOptionExerciseEarliestDateOffsetPeriod = 41495;
    const int LegOptionExerciseEarliestDateOffsetUnit = 41496;
    const int LegOptionExerciseFrequencyPeriod = 41497;
    const int LegOptionExerciseFrequencyUnit = 41498;
    const int LegOptionExerciseStartDateUnadjusted = 41499;
    const int LegOptionExerciseStartDateRelativeTo = 41500;
    const int LegOptionExerciseStartDateOffsetPeriod = 41501;
    const int LegOptionExerciseStartDateOffsetUnit = 41502;
    const int LegOptionExerciseStartDateOffsetDayType = 41503;
    const int LegOptionExerciseStartDateAdjusted = 41504;
    const int LegOptionExerciseSkip = 41505;
    const int LegOptionExerciseNominationDeadline = 41506;
    const int LegOptionExerciseFirstDateUnadjusted = 41507;
    const int LegOptionExerciseLastDateUnadjusted = 41508;
    const int LegOptionExerciseEarliestTime = 41509;
    const int LegOptionExerciseLatestTime = 41510;
    const int LegOptionExerciseTimeBusinessCenter = 41511;
    const int NoLegOptionExerciseDates = 41512;
    const int LegOptionExerciseDate = 41513;
    const int LegOptionExerciseDateType = 41514;
    const int NoLegOptionExerciseExpirationDateBusinessCenters = 41515;
    const int LegOptionExerciseExpirationDateBusinessCenter = 41516;
    const int LegOptionExerciseExpirationDateBusinessDayConvention = 41517;
    const int LegOptionExerciseExpirationDateRelativeTo = 41518;
    const int LegOptionExerciseExpirationDateOffsetPeriod = 41519;
    const int LegOptionExerciseExpirationDateOffsetUnit = 41520;
    const int LegOptionExerciseExpirationFrequencyPeriod = 41521;
    const int LegOptionExerciseExpirationFrequencyUnit = 41522;
    const int LegOptionExerciseExpirationRollConvention = 41523;
    const int LegOptionExerciseExpirationDateOffsetDayType = 41524;
    const int LegOptionExerciseExpirationTime = 41525;
    const int LegOptionExerciseExpirationTimeBusinessCenter = 41526;
    const int NoLegOptionExerciseExpirationDates = 41527;
    const int LegOptionExerciseExpirationDate = 41528;
    const int LegOptionExerciseExpirationDateType = 41529;
    const int NoLegPaymentScheduleFixingDays = 41530;
    const int LegPaymentScheduleFixingDayOfWeek = 41531;
    const int LegPaymentScheduleFixingDayNumber = 41532;
    const int LegPaymentScheduleXID = 41533;
    const int LegPaymentScheduleXIDRef = 41534;
    const int LegPaymentScheduleRateCurrency = 41535;
    const int LegPaymentScheduleRateUnitOfMeasure = 41536;
    const int LegPaymentScheduleRateConversionFactor = 41537;
    const int LegPaymentScheduleRateSpreadType = 41538;
    const int LegPaymentScheduleSettlPeriodPrice = 41539;
    const int LegPaymentScheduleSettlPeriodPriceCurrency = 41540;
    const int LegPaymentScheduleSettlPeriodPriceUnitOfMeasure = 41541;
    const int LegPaymentScheduleStepUnitOfMeasure = 41542;
    const int LegPaymentScheduleFixingDayDistribution = 41543;
    const int LegPaymentScheduleFixingDayCount = 41544;
    const int LegPaymentScheduleFixingLagPeriod = 41545;
    const int LegPaymentScheduleFixingLagUnit = 41546;
    const int LegPaymentScheduleFixingFirstObservationDateOffsetPeriod = 41547;
    const int LegPaymentScheduleFixingFirstObservationDateOffsetUnit = 41548;
    const int LegPaymentStreamFlatRateIndicator = 41549;
    const int LegPaymentStreamFlatRateAmount = 41550;
    const int LegPaymentStreamFlatRateCurrency = 41551;
    const int LegStreamMaximumPaymentAmount = 41552;
    const int LegStreamMaximumPaymentCurrency = 41553;
    const int LegStreamMaximumTransactionAmount = 41554;
    const int LegStreamMaximumTransactionCurrency = 41555;
    const int LegPaymentStreamFixedAmountUnitOfMeasure = 41556;
    const int LegPaymentStreamTotalFixedAmount = 41557;
    const int LegPaymentStreamWorldScaleRate = 41558;
    const int LegPaymentStreamContractPrice = 41559;
    const int LegPaymentStreamContractPriceCurrency = 41560;
    const int NoLegPaymentStreamPricingBusinessCenters = 41561;
    const int LegPaymentStreamPricingBusinessCenter = 41562;
    const int LegPaymentStreamRateIndex2CurveUnit = 41563;
    const int LegPaymentStreamRateIndex2CurvePeriod = 41564;
    const int LegPaymentStreamRateIndexLocation = 41565;
    const int LegPaymentStreamRateIndexLevel = 41566;
    const int LegPaymentStreamRateIndexUnitOfMeasure = 41567;
    const int LegPaymentStreamSettlLevel = 41568;
    const int LegPaymentStreamReferenceLevel = 41569;
    const int LegPaymentStreamReferenceLevelUnitOfMeasure = 41570;
    const int LegPaymentStreamReferenceLevelEqualsZeroIndicator = 41571;
    const int LegPaymentStreamRateSpreadCurrency = 41572;
    const int LegPaymentStreamRateSpreadUnitOfMeasure = 41573;
    const int LegPaymentStreamRateConversionFactor = 41574;
    const int LegPaymentStreamRateSpreadType = 41575;
    const int LegPaymentStreamLastResetRate = 41576;
    const int LegPaymentStreamFinalRate = 41577;
    const int LegPaymentStreamCalculationLagPeriod = 41578;
    const int LegPaymentStreamCalculationLagUnit = 41579;
    const int LegPaymentStreamFirstObservationDateOffsetPeriod = 41580;
    const int LegPaymentStreamFirstObservationDateOffsetUnit = 41581;
    const int LegPaymentStreamPricingDayType = 41582;
    const int LegPaymentStreamPricingDayDistribution = 41583;
    const int LegPaymentStreamPricingDayCount = 41584;
    const int LegPaymentStreamPricingBusinessCalendar = 41585;
    const int LegPaymentStreamPricingBusinessDayConvention = 41586;
    const int NoLegPaymentStreamPaymentDates = 41589;
    const int LegPaymentStreamPaymentDate = 41590;
    const int LegPaymentStreamPaymentDateType = 41591;
    const int LegPaymentStreamMasterAgreementPaymentDatesIndicator = 41592;
    const int NoLegPaymentStreamPricingDates = 41593;
    const int LegPaymentStreamPricingDate = 41594;
    const int LegPaymentStreamPricingDateType = 41595;
    const int NoLegPaymentStreamPricingDays = 41596;
    const int LegPaymentStreamPricingDayOfWeek = 41597;
    const int LegPaymentStreamPricingDayNumber = 41598;
    const int NoLegPhysicalSettlTerms = 41599;
    const int LegPhysicalSettlTermXID = 41600;
    const int LegPhysicalSettlCurency = 41601;
    const int LegPhysicalSettlBusinessDays = 41602;
    const int LegPhysicalSettlMaximumBusinessDays = 41603;
    const int NoLegPhysicalSettlDeliverableObligations = 41604;
    const int LegPhysicalSettlDeliverableObligationType = 41605;
    const int LegPhysicalSettlDeliverableObligationValue = 41606;
    const int NoLegPricingDateBusinessCenters = 41607;
    const int LegPricingDateBusinessCenter = 41608;
    const int LegPricingDateUnadjusted = 41609;
    const int LegPricingDateBusinessDayConvention = 41610;
    const int LegPricingDateAdjusted = 41611;
    const int LegPricingTime = 41612;
    const int LegPricingTimeBusinessCenter = 41613;
    const int NoLegProtectionTermEventNewsSources = 41614;
    const int LegProtectionTermEventNewsSource = 41615;
    const int NoLegProtectionTerms = 41616;
    const int LegProtectionTermXID = 41617;
    const int LegProtectionTermNotional = 41618;
    const int LegProtectionTermCurrency = 41619;
    const int LegProtectionTermSellerNotifies = 41620;
    const int LegProtectionTermBuyerNotifies = 41621;
    const int LegProtectionTermEventBusinessCenter = 41622;
    const int LegProtectionTermStandardSources = 41623;
    const int LegProtectionTermEventMinimumSources = 41624;
    const int NoLegProtectionTermEvents = 41625;
    const int LegProtectionTermEventType = 41626;
    const int LegProtectionTermEventValue = 41627;
    const int LegProtectionTermEventCurrency = 41628;
    const int LegProtectionTermEventPeriod = 41629;
    const int LegProtectionTermEventUnit = 41630;
    const int LegProtectionTermEventDayType = 41631;
    const int LegProtectionTermEventRateSource = 41632;
    const int NoLegProtectionTermEventQualifiers = 41633;
    const int LegProtectionTermEventQualifier = 41634;
    const int NoLegProtectionTermObligations = 41635;
    const int LegProtectionTermObligationType = 41636;
    const int LegProtectionTermObligationValue = 41637;
    const int NoLegStreamCalculationPeriodDates = 41638;
    const int LegStreamCalculationPeriodDate = 41639;
    const int LegStreamCalculationPeriodDateType = 41640;
    const int LegStreamCalculationPeriodDatesXID = 41641;
    const int LegStreamCalculationPeriodDatesXIDRef = 41642;
    const int LegStreamCalculationBalanceOfFirstPeriod = 41643;
    const int LegStreamCalculationCorrectionPeriod = 41644;
    const int LegStreamCalculationCorrectionUnit = 41645;
    const int NoLegStreamCommoditySettlBusinessCenters = 41646;
    const int LegStreamCommoditySettlBusinessCenter = 41647;
    const int LegStreamCommodityBase = 41648;
    const int LegStreamCommodityType = 41649;
    const int LegStreamCommoditySecurityID = 41650;
    const int LegStreamCommoditySecurityIDSource = 41651;
    const int LegStreamCommodityDesc = 41652;
    const int EncodedLegStreamCommodityDescLen = 41653;
    const int EncodedLegStreamCommodityDesc = 41654;
    const int LegStreamCommodityUnitOfMeasure = 41655;
    const int LegStreamCommodityCurrency = 41656;
    const int LegStreamCommodityExchange = 41657;
    const int LegStreamCommodityRateSource = 41658;
    const int LegStreamCommodityRateReferencePage = 41659;
    const int LegStreamCommodityRateReferencePageHeading = 41660;
    const int LegStreamDataProvider = 41661;
    const int LegStreamCommodityPricingType = 41662;
    const int LegStreamCommodityNearbySettlDayPeriod = 41663;
    const int LegStreamCommodityNearbySettlDayUnit = 41664;
    const int LegStreamCommoditySettlDateUnadjusted = 41665;
    const int LegStreamCommoditySettlDateBusinessDayConvention = 41666;
    const int LegStreamCommoditySettlDateAdjusted = 41667;
    const int LegStreamCommoditySettlMonth = 41668;
    const int LegStreamCommoditySettlDateRollPeriod = 41669;
    const int LegStreamCommoditySettlDateRollUnit = 41670;
    const int LegStreamCommoditySettlDayType = 41671;
    const int LegStreamCommodityXID = 41672;
    const int LegStreamCommodityXIDRef = 41673;
    const int NoLegStreamCommodityAltIDs = 41674;
    const int LegStreamCommodityAltID = 41675;
    const int LegStreamCommodityAltIDSource = 41676;
    const int NoLegStreamCommodityDataSources = 41677;
    const int LegStreamCommodityDataSourceID = 41678;
    const int LegStreamCommodityDataSourceIDType = 41679;
    const int NoLegStreamCommoditySettlDays = 41680;
    const int LegStreamCommoditySettlDay = 41681;
    const int LegStreamCommoditySettlTotalHours = 41682;
    const int NoLegStreamCommoditySettlTimes = 41683;
    const int LegStreamCommoditySettlStart = 41684;
    const int LegStreamCommoditySettlEnd = 41685;
    const int LegStreamCommoditySettlTimeType = 41935;
    const int NoLegStreamCommoditySettlPeriods = 41686;
    const int LegStreamCommoditySettlCountry = 41687;
    const int LegStreamCommoditySettlTimeZone = 41688;
    const int LegStreamCommoditySettlFlowType = 41689;
    const int LegStreamCommoditySettlPeriodNotional = 41690;
    const int LegStreamCommoditySettlPeriodNotionalUnitOfMeasure = 41691;
    const int LegStreamCommoditySettlPeriodFrequencyPeriod = 41692;
    const int LegStreamCommoditySettlPeriodFrequencyUnit = 41693;
    const int LegStreamCommoditySettlPeriodPrice = 41694;
    const int LegStreamCommoditySettlPeriodPriceUnitOfMeasure = 41695;
    const int LegStreamCommoditySettlPeriodPriceCurrency = 41696;
    const int LegStreamCommoditySettlHolidaysProcessingInstruction = 41697;
    const int LegStreamCommoditySettlPeriodXID = 41698;
    const int LegStreamCommoditySettlPeriodXIDRef = 41699;
    const int LegStreamXID = 41700;
    const int LegStreamNotionalXIDRef = 41702;
    const int LegStreamNotionalFrequencyPeriod = 41703;
    const int LegStreamNotionalFrequencyUnit = 41704;
    const int LegStreamNotionalCommodityFrequency = 41705;
    const int LegStreamNotionalUnitOfMeasure = 41706;
    const int LegStreamTotalNotional = 41707;
    const int LegStreamTotalNotionalUnitOfMeasure = 41708;
    const int NoUnderlyingAssetAttributes = 2312;
    const int UnderlyingAssetAttributeType = 2313;
    const int UnderlyingAssetAttributeValue = 2314;
    const int UnderlyingAssetAttributeLimit = 2315;
    const int NoUnderlyingComplexEventAveragingObservations = 41713;
    const int UnderlyingComplexEventAveragingObservationNumber = 41714;
    const int UnderlyingComplexEventAveragingWeight = 41715;
    const int NoUnderlyingComplexEventCreditEvents = 41716;
    const int UnderlyingComplexEventCreditEventType = 41717;
    const int UnderlyingComplexEventCreditEventValue = 41718;
    const int UnderlyingComplexEventCreditEventCurrency = 41719;
    const int UnderlyingComplexEventCreditEventPeriod = 41720;
    const int UnderlyingComplexEventCreditEventUnit = 41721;
    const int UnderlyingComplexEventCreditEventDayType = 41722;
    const int UnderlyingComplexEventCreditEventRateSource = 41723;
    const int NoUnderlyingComplexEventCreditEventQualifiers = 41724;
    const int UnderlyingComplexEventCreditEventQualifier = 41725;
    const int NoUnderlyingComplexEventPeriodDateTimes = 41726;
    const int UnderlyingComplexEventPeriodDate = 41727;
    const int UnderlyingComplexEventPeriodTime = 41728;
    const int NoUnderlyingComplexEventPeriods = 41729;
    const int UnderlyingComplexEventPeriodType = 41730;
    const int UnderlyingComplexEventBusinessCenter = 41731;
    const int NoUnderlyingComplexEventRateSources = 41732;
    const int UnderlyingComplexEventRateSource = 41733;
    const int UnderlyingComplexEventRateSourceType = 41734;
    const int UnderlyingComplexEventReferencePage = 41735;
    const int UnderlyingComplexEventReferencePageHeading = 41736;
    const int NoUnderlyingComplexEventDateBusinessCenters = 41737;
    const int UnderlyingComplexEventDateBusinessCenter = 41738;
    const int UnderlyingComplexEventDateUnadjusted = 41739;
    const int UnderlyingComplexEventDateRelativeTo = 41740;
    const int UnderlyingComplexEventDateOffsetPeriod = 41741;
    const int UnderlyingComplexEventDateOffsetUnit = 41742;
    const int UnderlyingComplexEventDateOffsetDayType = 41743;
    const int UnderlyingComplexEventDateBusinessDayConvention = 41744;
    const int UnderlyingComplexEventDateAdjusted = 41745;
    const int UnderlyingComplexEventFixingTime = 41746;
    const int UnderlyingComplexEventFixingTimeBusinessCenter = 41747;
    const int NoUnderlyingComplexEventCreditEventSources = 41748;
    const int UnderlyingComplexEventCreditEventSource = 41749;
    const int UnderlyingComplexOptPayoutPaySide = 2261;
    const int UnderlyingComplexOptPayoutReceiveSide = 2262;
    const int UnderlyingComplexOptPayoutUnderlier = 2263;
    const int UnderlyingComplexOptPayoutPercentage = 2264;
    const int UnderlyingComplexOptPayoutTime = 2265;
    const int UnderlyingComplexOptPayoutCurrency = 2266;
    const int UnderlyingComplexEventPricePercentage = 2267;
    const int UnderlyingComplexEventCurrencyOne = 2268;
    const int UnderlyingComplexEventCurrencyTwo = 2269;
    const int UnderlyingComplexEventQuoteBasis = 2270;
    const int UnderlyingComplexEventFixedFXRate = 2271;
    const int UnderlyingComplexEventDeterminationMethod = 2272;
    const int UnderlyingComplexEventCalculationAgent = 2273;
    const int UnderlyingComplexEventStrikePrice = 2274;
    const int UnderlyingComplexEventStrikeFactor = 2275;
    const int UnderlyingComplexEventStrikeNumberOfOptions = 2276;
    const int UnderlyingComplexEventCreditEventsXIDRef = 2277;
    const int UnderlyingComplexEventCreditEventNotifyingParty = 2278;
    const int UnderlyingComplexEventCreditEventBusinessCenter = 2279;
    const int UnderlyingComplexEventCreditEventStandardSources = 2280;
    const int UnderlyingComplexEventCreditEventMinimumSources = 2281;
    const int UnderlyingComplexEventXID = 2282;
    const int UnderlyingComplexEventXIDRef = 2283;
    const int NoUnderlyingComplexEventSchedules = 41750;
    const int UnderlyingComplexEventScheduleStartDate = 41751;
    const int UnderlyingComplexEventScheduleEndDate = 41752;
    const int UnderlyingComplexEventScheduleFrequencyPeriod = 41753;
    const int UnderlyingComplexEventScheduleFrequencyUnit = 41754;
    const int UnderlyingComplexEventScheduleRollConvention = 41755;
    const int NoUnderlyingDeliverySchedules = 41756;
    const int UnderlyingDeliveryScheduleType = 41757;
    const int UnderlyingDeliveryScheduleXID = 41758;
    const int UnderlyingDeliveryScheduleNotional = 41759;
    const int UnderlyingDeliveryScheduleNotionalUnitOfMeasure = 41760;
    const int UnderlyingDeliveryScheduleNotionalCommodityFrequency = 41761;
    const int UnderlyingDeliveryScheduleNegativeTolerance = 41762;
    const int UnderlyingDeliverySchedulePositiveTolerance = 41763;
    const int UnderlyingDeliveryScheduleToleranceUnitOfMeasure = 41764;
    const int UnderlyingDeliveryScheduleToleranceType = 41765;
    const int UnderlyingDeliveryScheduleSettlCountry = 41766;
    const int UnderlyingDeliveryScheduleSettlTimeZone = 41767;
    const int UnderlyingDeliveryScheduleSettlFlowType = 41768;
    const int UnderlyingDeliveryScheduleSettlHolidaysProcessingInstruction = 41769;
    const int NoUnderlyingDeliveryScheduleSettlDays = 41770;
    const int UnderlyingDeliveryScheduleSettlDay = 41771;
    const int UnderlyingDeliveryScheduleSettlTotalHours = 41772;
    const int NoUnderlyingDeliveryScheduleSettlTimes = 41773;
    const int UnderlyingDeliveryScheduleSettlStart = 41774;
    const int UnderlyingDeliveryScheduleSettlEnd = 41775;
    const int UnderlyingDeliveryScheduleSettlTimeType = 41776;
    const int UnderlyingDeliveryStreamType = 41777;
    const int UnderlyingDeliveryStreamPipeline = 41778;
    const int UnderlyingDeliveryStreamEntryPoint = 41779;
    const int UnderlyingDeliveryStreamWithdrawalPoint = 41780;
    const int UnderlyingDeliveryStreamDeliveryPoint = 41781;
    const int UnderlyingDeliveryStreamDeliveryRestriction = 41782;
    const int UnderlyingDeliveryStreamDeliveryContingency = 41783;
    const int UnderlyingDeliveryStreamDeliveryContingentPartySide = 41784;
    const int UnderlyingDeliveryStreamDeliverAtSourceIndicator = 41785;
    const int UnderlyingDeliveryStreamRiskApportionment = 41786;
    const int UnderlyingDeliveryStreamRiskApportionmentSource = 41587;
    const int UnderlyingDeliveryStreamTitleTransferLocation = 41787;
    const int UnderlyingDeliveryStreamTitleTransferCondition = 41788;
    const int UnderlyingDeliveryStreamImporterOfRecord = 41789;
    const int UnderlyingDeliveryStreamNegativeTolerance = 41790;
    const int UnderlyingDeliveryStreamPositiveTolerance = 41791;
    const int UnderlyingDeliveryStreamToleranceUnitOfMeasure = 41792;
    const int UnderlyingDeliveryStreamToleranceType = 41793;
    const int UnderlyingDeliveryStreamToleranceOptionSide = 41794;
    const int UnderlyingDeliveryStreamTotalPositiveTolerance = 41795;
    const int UnderlyingDeliveryStreamTotalNegativeTolerance = 41796;
    const int UnderlyingDeliveryStreamNotionalConversionFactor = 41797;
    const int UnderlyingDeliveryStreamTransportEquipment = 41798;
    const int UnderlyingDeliveryStreamElectingPartySide = 41799;
    const int NoUnderlyingStreamAssetAttributes = 41800;
    const int UnderlyingStreamAssetAttributeType = 41801;
    const int UnderlyingStreamAssetAttributeValue = 41802;
    const int UnderlyingStreamAssetAttributeLimit = 41803;
    const int NoUnderlyingDeliveryStreamCycles = 41804;
    const int UnderlyingDeliveryStreamCycleDesc = 41805;
    const int EncodedUnderlyingDeliveryStreamCycleDescLen = 41806;
    const int EncodedUnderlyingDeliveryStreamCycleDesc = 41807;
    const int NoUnderlyingDeliveryStreamCommoditySources = 41808;
    const int UnderlyingDeliveryStreamCommoditySource = 41809;
    const int UnderlyingExerciseDesc = 41810;
    const int EncodedUnderlyingExerciseDescLen = 41811;
    const int EncodedUnderlyingExerciseDesc = 41812;
    const int UnderlyingAutomaticExerciseIndicator = 41813;
    const int UnderlyingAutomaticExerciseThresholdRate = 41814;
    const int UnderlyingExerciseConfirmationMethod = 41815;
    const int UnderlyingManualNoticeBusinessCenter = 41816;
    const int UnderlyingFallbackExerciseIndicator = 41817;
    const int UnderlyingLimitedRightToConfirmIndicator = 41818;
    const int UnderlyingExerciseSplitTicketIndicator = 41819;
    const int NoUnderlyingOptionExerciseBusinessCenters = 41820;
    const int UnderlyingOptionExerciseBusinessCenter = 41821;
    const int UnderlyingOptionExerciseBusinessDayConvention = 41822;
    const int UnderlyingOptionExerciseEarliestDateOffsetDayType = 41823;
    const int UnderlyingOptionExerciseEarliestDateOffsetPeriod = 41824;
    const int UnderlyingOptionExerciseEarliestDateOffsetUnit = 41825;
    const int UnderlyingOptionExerciseFrequencyPeriod = 41826;
    const int UnderlyingOptionExerciseFrequencyUnit = 41827;
    const int UnderlyingOptionExerciseStartDateUnadjusted = 41828;
    const int UnderlyingOptionExerciseStartDateRelativeTo = 41829;
    const int UnderlyingOptionExerciseStartDateOffsetPeriod = 41830;
    const int UnderlyingOptionExerciseStartDateOffsetUnit = 41831;
    const int UnderlyingOptionExerciseStartDateOffsetDayType = 41832;
    const int UnderlyingOptionExerciseStartDateAdjusted = 41833;
    const int UnderlyingOptionExerciseSkip = 41834;
    const int UnderlyingOptionExerciseNominationDeadline = 41835;
    const int UnderlyingOptionExerciseFirstDateUnadjusted = 41836;
    const int UnderlyingOptionExerciseLastDateUnadjusted = 41837;
    const int UnderlyingOptionExerciseEarliestTime = 41838;
    const int UnderlyingOptionExerciseLatestTime = 41839;
    const int UnderlyingOptionExerciseTimeBusinessCenter = 41840;
    const int NoUnderlyingOptionExerciseDates = 41841;
    const int UnderlyingOptionExerciseDate = 41842;
    const int UnderlyingOptionExerciseDateType = 41843;
    const int NoUnderlyingOptionExerciseExpirationDateBusinessCenters = 41844;
    const int UnderlyingOptionExerciseExpirationDateBusinessCenter = 41845;
    const int UnderlyingOptionExerciseExpirationDateBusinessDayConvention = 41846;
    const int UnderlyingOptionExerciseExpirationDateRelativeTo = 41847;
    const int UnderlyingOptionExerciseExpirationDateOffsetPeriod = 41848;
    const int UnderlyingOptionExerciseExpirationDateOffsetUnit = 41849;
    const int UnderlyingOptionExerciseExpirationFrequencyPeriod = 41850;
    const int UnderlyingOptionExerciseExpirationFrequencyUnit = 41851;
    const int UnderlyingOptionExerciseExpirationRollConvention = 41852;
    const int UnderlyingOptionExerciseExpirationDateOffsetDayType = 41853;
    const int UnderlyingOptionExerciseExpirationTime = 41854;
    const int UnderlyingOptionExerciseExpirationTimeBusinessCenter = 41855;
    const int NoUnderlyingOptionExerciseExpirationDates = 41856;
    const int UnderlyingOptionExerciseExpirationDate = 41857;
    const int UnderlyingOptionExerciseExpirationDateType = 41858;
    const int UnderlyingSettlRateIndex = 2284;
    const int UnderlyingSettlRateIndexLocation = 2285;
    const int UnderlyingOptionExpirationDesc = 2286;
    const int EncodedUnderlyingOptionExpirationDescLen = 2287;
    const int EncodedUnderlyingOptionExpirationDesc = 2288;
    const int UnderlyingSwapSubClass = 2289;
    const int UnderlyingStrikeUnitOfMeasure = 2290;
    const int UnderlyingStrikeIndex = 2291;
    const int UnderlyingStrikeIndexSpread = 2292;
    const int UnderlyingValuationSource = 2293;
    const int UnderlyingValuationReferenceModel = 2294;
    const int UnderlyingStrategyType = 2295;
    const int UnderlyingCommonPricingIndicator = 2296;
    const int UnderlyingSettlDisruptionProvision = 2297;
    const int UnderlyingInstrumentRoundingDirection = 2298;
    const int UnderlyingInstrumentRoundingPrecision = 2299;
    const int UnderlyingMarketDisruptionProvision = 41859;
    const int UnderlyingMarketDisruptionFallbackProvision = 41860;
    const int UnderlyingMarketDisruptionMaximumDays = 41861;
    const int UnderlyingMarketDisruptionMaterialityPercentage = 41862;
    const int UnderlyingMarketDisruptionMinimumFuturesContracts = 41863;
    const int NoUnderlyingMarketDisruptionEvents = 41864;
    const int UnderlyingMarketDisruptionEvent = 41865;
    const int NoUnderlyingMarketDisruptionFallbacks = 41866;
    const int UnderlyingMarketDisruptionFallbackType = 41867;
    const int NoUnderlyingMarketDisruptionFallbackReferencePrices = 41868;
    const int UnderlyingMarketDisruptionFallbackUnderlierType = 41869;
    const int UnderlyingMarketDisruptionFallbackUnderlierSecurityID = 41870;
    const int UnderlyingMarketDisruptionFallbackUnderlierSecurityIDSource = 41871;
    const int UnderlyingMarketDisruptionFallbackUnderlierSecurityDesc = 41872;
    const int EncodedUnderlyingMarketDisruptionFallbackUnderlierSecDescLen = 41873;
    const int EncodedUnderlyingMarketDisruptionFallbackUnderlierSecurityDesc = 41874;
    const int UnderlyingMarketDisruptionFallbackOpenUnits = 41875;
    const int UnderlyingMarketDisruptionFallbackBasketCurrency = 41876;
    const int UnderlyingMarketDisruptionFallbackBasketDivisor = 41877;
    const int NoUnderlyingPaymentScheduleFixingDays = 41878;
    const int UnderlyingPaymentScheduleFixingDayOfWeek = 41879;
    const int UnderlyingPaymentScheduleFixingDayNumber = 41880;
    const int UnderlyingPaymentScheduleXID = 41881;
    const int UnderlyingPaymentScheduleXIDRef = 41882;
    const int UnderlyingPaymentScheduleRateCurrency = 41883;
    const int UnderlyingPaymentScheduleRateUnitOfMeasure = 41884;
    const int UnderlyingPaymentScheduleRateConversionFactor = 41885;
    const int UnderlyingPaymentScheduleRateSpreadType = 41886;
    const int UnderlyingPaymentScheduleSettlPeriodPrice = 41887;
    const int UnderlyingPaymentScheduleSettlPeriodPriceCurrency = 41888;
    const int UnderlyingPaymentScheduleSettlPeriodPriceUnitOfMeasure = 41889;
    const int UnderlyingPaymentScheduleStepUnitOfMeasure = 41890;
    const int UnderlyingPaymentScheduleFixingDayDistribution = 41891;
    const int UnderlyingPaymentScheduleFixingDayCount = 41892;
    const int UnderlyingPaymentScheduleFixingLagPeriod = 41893;
    const int UnderlyingPaymentScheduleFixingLagUnit = 41894;
    const int UnderlyingPaymentScheduleFixingFirstObservationDateOffsetPeriod = 41895;
    const int UnderlyingPaymentScheduleFixingFirstObservationDateOffsetUnit = 41896;
    const int UnderlyingPaymentStreamFlatRateIndicator = 41897;
    const int UnderlyingPaymentStreamFlatRateAmount = 41898;
    const int UnderlyingPaymentStreamFlatRateCurrency = 41899;
    const int UnderlyingPaymentStreamMaximumPaymentAmount = 41900;
    const int UnderlyingPaymentStreamMaximumPaymentCurrency = 41901;
    const int UnderlyingPaymentStreamMaximumTransactionAmount = 41902;
    const int UnderlyingPaymentStreamMaximumTransactionCurrency = 41903;
    const int UnderlyingPaymentStreamFixedAmountUnitOfMeasure = 41904;
    const int UnderlyingPaymentStreamTotalFixedAmount = 41905;
    const int UnderlyingPaymentStreamWorldScaleRate = 41906;
    const int UnderlyingPaymentStreamContractPrice = 41907;
    const int UnderlyingPaymentStreamContractPriceCurrency = 41908;
    const int NoUnderlyingPaymentStreamPricingBusinessCenters = 41909;
    const int UnderlyingPaymentStreamPricingBusinessCenter = 41910;
    const int UnderlyingPaymentStreamRateIndex2CurveUnit = 41911;
    const int UnderlyingPaymentStreamRateIndex2CurvePeriod = 41912;
    const int UnderlyingPaymentStreamRateIndexLocation = 41913;
    const int UnderlyingPaymentStreamRateIndexLevel = 41914;
    const int UnderlyingPaymentStreamRateIndexUnitOfMeasure = 41915;
    const int UnderlyingPaymentStreamSettlLevel = 41916;
    const int UnderlyingPaymentStreamReferenceLevel = 41917;
    const int UnderlyingPaymentStreamReferenceLevelUnitOfMeasure = 41918;
    const int UnderlyingPaymentStreamReferenceLevelEqualsZeroIndicator = 41919;
    const int UnderlyingPaymentStreamRateSpreadCurrency = 41920;
    const int UnderlyingPaymentStreamRateSpreadUnitOfMeasure = 41921;
    const int UnderlyingPaymentStreamRateConversionFactor = 41922;
    const int UnderlyingPaymentStreamRateSpreadType = 41923;
    const int UnderlyingPaymentStreamLastResetRate = 41924;
    const int UnderlyingPaymentStreamFinalRate = 41925;
    const int UnderlyingPaymentStreamCalculationLagPeriod = 41926;
    const int UnderlyingPaymentStreamCalculationLagUnit = 41927;
    const int UnderlyingPaymentStreamFirstObservationDateOffsetPeriod = 41928;
    const int UnderlyingPaymentStreamFirstObservationDateOffsetUnit = 41929;
    const int UnderlyingPaymentStreamPricingDayType = 41930;
    const int UnderlyingPaymentStreamPricingDayDistribution = 41931;
    const int UnderlyingPaymentStreamPricingDayCount = 41932;
    const int UnderlyingPaymentStreamPricingBusinessCalendar = 41933;
    const int UnderlyingPaymentStreamPricingBusinessDayConvention = 41934;
    const int NoUnderlyingPaymentStreamPaymentDates = 41937;
    const int UnderlyingPaymentStreamPaymentDate = 41938;
    const int UnderlyingPaymentStreamPaymentDateType = 41939;
    const int UnderlyingPaymentStreamMasterAgreementPaymentDatesIndicator = 41940;
    const int NoUnderlyingPaymentStreamPricingDates = 41941;
    const int UnderlyingPaymentStreamPricingDate = 41942;
    const int UnderlyingPaymentStreamPricingDateType = 41943;
    const int NoUnderlyingPaymentStreamPricingDays = 41944;
    const int UnderlyingPaymentStreamPricingDayOfWeek = 41945;
    const int UnderlyingPaymentStreamPricingDayNumber = 41946;
    const int NoUnderlyingPricingDateBusinessCenters = 41947;
    const int UnderlyingPricingDateBusinessCenter = 41948;
    const int UnderlyingPricingDateUnadjusted = 41949;
    const int UnderlyingPricingDateBusinessDayConvention = 41950;
    const int UnderlyingPricingDateAdjusted = 41951;
    const int UnderlyingPricingTime = 41952;
    const int UnderlyingPricingTimeBusinessCenter = 41953;
    const int NoUnderlyingStreamCalculationPeriodDates = 41954;
    const int UnderlyingStreamCalculationPeriodDate = 41955;
    const int UnderlyingStreamCalculationPeriodDateType = 41956;
    const int UnderlyingStreamCalculationPeriodDatesXID = 41957;
    const int UnderlyingStreamCalculationPeriodDatesXIDRef = 41958;
    const int UnderlyingStreamCalculationBalanceOfFirstPeriod = 41959;
    const int UnderlyingStreamCalculationCorrectionPeriod = 41960;
    const int UnderlyingStreamCalculationCorrectionUnit = 41961;
    const int NoUnderlyingStreamCommoditySettlBusinessCenters = 41962;
    const int UnderlyingStreamCommoditySettlBusinessCenter = 41963;
    const int UnderlyingStreamCommodityBase = 41964;
    const int UnderlyingStreamCommodityType = 41965;
    const int UnderlyingStreamCommoditySecurityID = 41966;
    const int UnderlyingStreamCommoditySecurityIDSource = 41967;
    const int UnderlyingStreamCommodityDesc = 41968;
    const int EncodedUnderlyingStreamCommodityDescLen = 41969;
    const int EncodedUnderlyingStreamCommodityDesc = 41970;
    const int UnderlyingStreamCommodityUnitOfMeasure = 41971;
    const int UnderlyingStreamCommodityCurrency = 41972;
    const int UnderlyingStreamCommodityExchange = 41973;
    const int UnderlyingStreamCommodityRateSource = 41974;
    const int UnderlyingStreamCommodityRateReferencePage = 41975;
    const int UnderlyingStreamCommodityRateReferencePageHeading = 41976;
    const int UnderlyingStreamDataProvider = 41977;
    const int UnderlyingStreamCommodityPricingType = 41978;
    const int UnderlyingStreamCommodityNearbySettlDayPeriod = 41979;
    const int UnderlyingStreamCommodityNearbySettlDayUnit = 41980;
    const int UnderlyingStreamCommoditySettlDateUnadjusted = 41981;
    const int UnderlyingStreamCommoditySettlDateBusinessDayConvention = 41982;
    const int UnderlyingStreamCommoditySettlDateAdjusted = 41983;
    const int UnderlyingStreamCommoditySettlMonth = 41984;
    const int UnderlyingStreamCommoditySettlDateRollPeriod = 41985;
    const int UnderlyingStreamCommoditySettlDateRollUnit = 41986;
    const int UnderlyingStreamCommoditySettlDayType = 41987;
    const int UnderlyingStreamCommodityXID = 41988;
    const int UnderlyingStreamCommodityXIDRef = 41989;
    const int NoUnderlyingStreamCommodityAltIDs = 41990;
    const int UnderlyingStreamCommodityAltID = 41991;
    const int UnderlyingStreamCommodityAltIDSource = 41992;
    const int NoUnderlyingStreamCommodityDataSources = 41993;
    const int UnderlyingStreamCommodityDataSourceID = 41994;
    const int UnderlyingStreamCommodityDataSourceIDType = 41995;
    const int NoUnderlyingStreamCommoditySettlDays = 41996;
    const int UnderlyingStreamCommoditySettlDay = 41997;
    const int UnderlyingStreamCommoditySettlTotalHours = 41998;
    const int NoUnderlyingStreamCommoditySettlTimes = 41999;
    const int UnderlyingStreamCommoditySettlStart = 42000;
    const int UnderlyingStreamCommoditySettlEnd = 42001;
    const int UnderlyingStreamCommoditySettlTimeType = 41936;
    const int NoUnderlyingStreamCommoditySettlPeriods = 42002;
    const int UnderlyingStreamCommoditySettlCountry = 42003;
    const int UnderlyingStreamCommoditySettlTimeZone = 42004;
    const int UnderlyingStreamCommoditySettlFlowType = 42005;
    const int UnderlyingStreamCommoditySettlPeriodNotional = 42006;
    const int UnderlyingStreamCommoditySettlPeriodNotionalUnitOfMeasure = 42007;
    const int UnderlyingStreamCommoditySettlPeriodFrequencyPeriod = 42008;
    const int UnderlyingStreamCommoditySettlPeriodFrequencyUnit = 42009;
    const int UnderlyingStreamCommoditySettlPeriodPrice = 42010;
    const int UnderlyingStreamCommoditySettlPeriodPriceUnitOfMeasure = 42011;
    const int UnderlyingStreamCommoditySettlPeriodPriceCurrency = 42012;
    const int UnderlyingStreamCommoditySettlHolidaysProcessingInstruction = 42013;
    const int UnderlyingStreamCommoditySettlPeriodXID = 42014;
    const int UnderlyingStreamCommoditySettlPeriodXIDRef = 42015;
    const int UnderlyingStreamXID = 42016;
    const int UnderlyingStreamNotionalXIDRef = 42018;
    const int UnderlyingStreamNotionalFrequencyPeriod = 42019;
    const int UnderlyingStreamNotionalFrequencyUnit = 42020;
    const int UnderlyingStreamNotionalCommodityFrequency = 42021;
    const int UnderlyingStreamNotionalUnitOfMeasure = 42022;
    const int UnderlyingStreamTotalNotional = 42023;
    const int UnderlyingStreamTotalNotionalUnitOfMeasure = 42024;
    const int AllocGrossTradeAmt = 2300;
    const int RiskLimitReportStatus = 2316;
    const int RiskLimitReportRejectReason = 2317;
    const int RiskLimitCheckRequestID = 2318;
    const int RiskLimitCheckID = 2319;
    const int RiskLimitCheckTransType = 2320;
    const int RiskLimitCheckType = 2321;
    const int RiskLimitCheckRequestRefID = 2322;
    const int RiskLimitCheckRequestType = 2323;
    const int RiskLimitCheckAmount = 2324;
    const int RiskLimitCheckRequestStatus = 2325;
    const int RiskLimitCheckRequestResult = 2326;
    const int RiskLimitApprovedAmount = 2327;
    const int PartyActionRequestID = 2328;
    const int PartyActionType = 2329;
    const int ApplTestMessageIndicator = 2330;
    const int PartyActionReportID = 2331;
    const int PartyActionResponse = 2332;
    const int PartyActionRejectReason = 2333;
    const int RefRiskLimitCheckID = 2334;
    const int RefRiskLimitCheckIDType = 2335;
    const int RiskLimitVelocityPeriod = 2336;
    const int RiskLimitVelocityUnit = 2337;
    const int RequestingPartyRoleQualifier = 2338;
    const int RiskLimitCheckModelType = 2339;
    const int RiskLimitCheckStatus = 2343;
    const int SideRiskLimitCheckStatus = 2344;
    const int NoEntitlementTypes = 2345;
    const int LegMidPx = 2346;
    const int RegulatoryTransactionType = 2347;
    const int BatchID = 50000;
    const int BatchTotalMessages = 50001;
    const int BatchProcessMode = 50002;
    const int CollateralPortfolioID = 2350;
    const int DeliveryStreamDeliveryPointSource = 42192;
    const int DeliveryStreamDeliveryPointDesc = 42193;
    const int TradingUnitPeriodMultiplier = 2353;
    const int LegTradingUnitPeriodMultiplier = 2354;
    const int LegDeliveryStreamDeliveryPointDesc = 42195;
    const int LegDeliveryStreamDeliveryPointSource = 42194;
    const int LegTotalTradeQty = 2357;
    const int LegLastMultipliedQty = 2358;
    const int LegTotalGrossTradeAmt = 2359;
    const int LegTotalTradeMultipliedQty = 2360;
    const int UnderlyingDeliveryStreamDeliveryPointDesc = 42197;
    const int UnderlyingDeliveryStreamDeliveryPointSource = 42196;
    const int UnderlyingTradingUnitPeriodMultiplier = 2363;
    const int PosReportAction = 2364;
    const int SettlForwardPoints = 2365;
    const int SettlPriceFxRateCalc = 2366;
    const int TotalTradeQty = 2367;
    const int LastMultipliedQty = 2368;
    const int TotalGrossTradeAmt = 2369;
    const int TotalTradeMultipliedQty = 2370;
    const int EncodedTradeContinuationText = 2371;
    const int EncodedTradeContinuationTextLen = 2372;
    const int IntraFirmTradeIndicator = 2373;
    const int TradeContinuationText = 2374;
    const int TaxonomyType = 2375;
    const int PartyRoleQualifier = 2376;
    const int DerivativeInstrumentPartyRoleQualifier = 2377;
    const int InstrumentPartyRoleQualifier = 2378;
    const int LegInstrumentPartyRoleQualifier = 2379;
    const int LegProvisionPartyRoleQualifier = 2380;
    const int Nested2PartyRoleQualifier = 2381;
    const int Nested3PartyRoleQualifier = 2382;
    const int Nested4PartyRoleQualifier = 2383;
    const int NestedPartyRoleQualifier = 2384;
    const int ProvisionPartyRoleQualifier = 2385;
    const int RequestedPartyRoleQualifier = 2386;
    const int RootPartyRoleQualifier = 2388;
    const int SettlPartyRoleQualifier = 2389;
    const int UnderlyingInstrumentPartyRoleQualifier = 2391;
    const int AllocRefRiskLimitCheckID = 2392;
    const int AllocRefRiskLimitCheckIDType = 2393;
    const int LimitUtilizationAmt = 2394;
    const int LimitAmt = 2395;
    const int LimitRole = 2396;
    const int RegulatoryTradeIDScope = 2397;
    const int SideRegulatoryTradeIDScope = 2398;
    const int AllocRegulatoryTradeIDScope = 2399;
    const int AllocRegulatoryLegRefID = 2406;
    const int RegulatoryLegRefID = 2411;
    const int SideRegulatoryLegRefID = 2416;
    const int EffectiveBusinessDate = 2400;
    const int ListManualOrderIndicator = 2401;
    const int EntitlementSubType = 2402;
    const int QuoteModelType = 2403;
    const int ComplianceText = 2404;
    const int EncodedComplianceTextLen = 2351;
    const int EncodedComplianceText = 2352;
    const int ExecMethod = 2405;
    const int PricePrecision = 2349;
    const int TradeContingency = 2387;
    const int ComplexEventSpotRate = 2407;
    const int ComplexEventForwardPoints = 2408;
    const int LegComplexEventSpotRate = 2409;
    const int LegComplexEventForwardPoints = 2410;
    const int RateSourceReferemcePageHeading = 2412;
    const int RelatedToSecurityID = 2413;
    const int RelatedToSecurityIDSource = 2414;
    const int RelatedToStreamXIDRef = 2415;
    const int FirmTradeEventID = 2418;
    const int UnderlyingComplexEventSpotRate = 2419;
    const int UnderlyingComplexEventForwardPoints = 2420;
    const int LegMarketDisruptionValue = 40223;
    const int LegMarketDisruptionFallbackValue = 40990;
    const int MarketDisruptionValue = 40991;
    const int MarketDisruptionFallbackValue = 40992;
    const int PaymentSubType = 40993;
    const int PaymentLegRefID = 41304;
    const int UnderlyingMarketDisruptionValue = 41338;
    const int UnderlyingMarketDisruptionFallbackValue = 41339;
    const int NoUnderlyingAdditionalTermBondRefs = 41340;
    const int UnderlyingAdditionalTermBondSecurityID = 41341;
    const int UnderlyingAdditionalTermBondSecurityIDSource = 41701;
    const int UnderlyingAdditionalTermBondDesc = 41709;
    const int EncodedUnderlyingAdditionalTermBondDescLen = 41710;
    const int EncodedUnderlyingAdditionalTermBondDesc = 41711;
    const int UnderlyingAdditionalTermBondCurrency = 41712;
    const int UnderlyingAdditionalTermBondIssuer = 42017;
    const int EncodedUnderlyingAdditionalTermBondIssuerLen = 42025;
    const int EncodedUnderlyingAdditionalTermBondIssuer = 42026;
    const int UnderlyingAdditionalTermBondSeniority = 42027;
    const int UnderlyingAdditionalTermBondCouponType = 42028;
    const int UnderlyingAdditionalTermBondCouponRate = 42029;
    const int UnderlyingAdditionalTermBondMaturityDate = 42030;
    const int UnderlyingAdditionalTermBondParValue = 42031;
    const int UnderlyingAdditionalTermBondCurrentTotalIssuedAmount = 42032;
    const int UnderlyingAdditionalTermBondCouponFrequencyPeriod = 42033;
    const int UnderlyingAdditionalTermBondCouponFrequencyUnit = 42034;
    const int UnderlyingAdditionalTermBondDayCount = 42035;
    const int NoUnderlyingAdditionalTerms = 42036;
    const int UnderlyingAdditionalTermConditionPrecedentBondIndicator = 42037;
    const int UnderlyingAdditionalTermDiscrepancyClauseIndicator = 42038;
    const int NoUnderlyingCashSettlDealers = 42039;
    const int UnderlyingCashSettlDealer = 42040;
    const int NoUnderlyingCashSettlTerms = 42041;
    const int UnderlyingCashSettlCurrency = 42042;
    const int UnderlyingCashSettlValuationFirstBusinessDayOffset = 42043;
    const int UnderlyingCashSettlValuationSubsequentBusinessDaysOffset = 42044;
    const int UnderlyingCashSettlNumOfValuationDates = 42045;
    const int UnderlyingCashSettlValuationTime = 42046;
    const int UnderlyingCashSettlBusinessCenter = 42047;
    const int UnderlyingCashSettlQuoteMethod = 42048;
    const int UnderlyingCashSettlQuoteAmount = 42049;
    const int UnderlyingCashSettlQuoteCurrency = 42050;
    const int UnderlyingCashSettlMinimumQuoteAmount = 42051;
    const int UnderlyingCashSettlMinimumQuoteCurrency = 42052;
    const int UnderlyingCashSettlBusinessDays = 42053;
    const int UnderlyingCashSettlAmount = 42054;
    const int UnderlyingCashSettlRecoveryFactor = 42055;
    const int UnderlyingCashSettlFixedTermIndicator = 42056;
    const int UnderlyingCashSettlAccruedInterestIndicator = 42057;
    const int UnderlyingCashSettlValuationMethod = 42058;
    const int UnderlyingCashSettlTermXID = 42059;
    const int NoUnderlyingPhysicalSettlTerms = 42060;
    const int UnderlyingPhysicalSettlCurrency = 42061;
    const int UnderlyingPhysicalSettlBusinessDays = 42062;
    const int UnderlyingPhysicalSettlMaximumBusinessDays = 42063;
    const int UnderlyingPhysicalSettlTermXID = 42064;
    const int NoUnderlyingPhysicalSettlDeliverableObligations = 42065;
    const int UnderlyingPhysicalSettlDeliverableObligationType = 42066;
    const int UnderlyingPhysicalSettlDeliverableObligationValue = 42067;
    const int NoUnderlyingProtectionTerms = 42068;
    const int UnderlyingProtectionTermNotional = 42069;
    const int UnderlyingProtectionTermCurrency = 42070;
    const int UnderlyingProtectionTermSellerNotifies = 42071;
    const int UnderlyingProtectionTermBuyerNotifies = 42072;
    const int UnderlyingProtectionTermEventBusinessCenter = 42073;
    const int UnderlyingProtectionTermStandardSources = 42074;
    const int UnderlyingProtectionTermEventMinimumSources = 42075;
    const int UnderlyingProtectionTermXID = 42076;
    const int NoUnderlyingProtectionTermEvents = 42077;
    const int UnderlyingProtectionTermEventType = 42078;
    const int UnderlyingProtectionTermEventValue = 42079;
    const int UnderlyingProtectionTermEventCurrency = 42080;
    const int UnderlyingProtectionTermEventPeriod = 42081;
    const int UnderlyingProtectionTermEventUnit = 42082;
    const int UnderlyingProtectionTermEventDayType = 42083;
    const int UnderlyingProtectionTermEventRateSource = 42084;
    const int NoUnderlyingProtectionTermEventQualifiers = 42085;
    const int UnderlyingProtectionTermEventQualifier = 42086;
    const int NoUnderlyingProtectionTermObligations = 42087;
    const int UnderlyingProtectionTermObligationType = 42088;
    const int UnderlyingProtectionTermObligationValue = 42089;
    const int NoUnderlyingProtectionTermEventNewsSources = 42090;
    const int UnderlyingProtectionTermEventNewsSource = 42091;
    const int UnderlyingProvisionCashSettlPaymentDateBusinessDayConvention = 42092;
    const int UnderlyingProvisionCashSettlPaymentDateRelativeTo = 42093;
    const int UnderlyingProvisionCashSettlPaymentDateOffsetPeriod = 42094;
    const int UnderlyingProvisionCashSettlPaymentDateOffsetUnit = 42095;
    const int UnderlyingProvisionCashSettlPaymentDateOffsetDayType = 42096;
    const int UnderlyingProvisionCashSettlPaymentDateRangeFirst = 42097;
    const int UnderlyingProvisionCashSettlPaymentDateRangeLast = 42098;
    const int NoUnderlyingProvisionCashSettlPaymentDates = 42099;
    const int UnderlyingProvisionCashSettlPaymentDate = 42100;
    const int UnderlyingProvisionCashSettlPaymentDateType = 42101;
    const int UnderlyingProvisionCashSettlQuoteSource = 42102;
    const int UnderlyingProvisionCashSettlQuoteReferencePage = 42103;
    const int UnderlyingProvisionCashSettlValueTime = 42104;
    const int UnderlyingProvisionCashSettlValueTimeBusinessCenter = 42105;
    const int UnderlyingProvisionCashSettlValueDateBusinessDayConvention = 42106;
    const int UnderlyingProvisionCashSettlValueDateRelativeTo = 42107;
    const int UnderlyingProvisionCashSettlValueDateOffsetPeriod = 42108;
    const int UnderlyingProvisionCashSettlValueDateOffsetUnit = 42109;
    const int UnderlyingProvisionCashSettlValueDateOffsetDayType = 42110;
    const int UnderlyingProvisionCashSettlValueDateAdjusted = 42111;
    const int NoUnderlyingProvisionOptionExerciseFixedDates = 42112;
    const int UnderlyingProvisionOptionExerciseFixedDate = 42113;
    const int UnderlyingProvisionOptionExerciseFixedDateType = 42114;
    const int UnderlyingProvisionOptionExerciseBusinessDayConvention = 42115;
    const int UnderlyingProvisionOptionExerciseEarliestDateOffsetPeriod = 42116;
    const int UnderlyingProvisionOptionExerciseEarliestDateOffsetUnit = 42117;
    const int UnderlyingProvisionOptionExerciseFrequencyPeriod = 42118;
    const int UnderlyingProvisionOptionExerciseFrequencyUnit = 42119;
    const int UnderlyingProvisionOptionExerciseStartDateUnadjusted = 42120;
    const int UnderlyingProvisionOptionExerciseStartDateRelativeTo = 42121;
    const int UnderlyingProvisionOptionExerciseStartDateOffsetPeriod = 42122;
    const int UnderlyingProvisionOptionExerciseStartDateOffsetUnit = 42123;
    const int UnderlyingProvisionOptionExerciseStartDateOffsetDayType = 42124;
    const int UnderlyingProvisionOptionExerciseStartDateAdjusted = 42125;
    const int UnderlyingProvisionOptionExercisePeriodSkip = 42126;
    const int UnderlyingProvisionOptionExerciseBoundsFirstDateUnadjusted = 42127;
    const int UnderlyingProvisionOptionExerciseBoundsLastDateUnadjusted = 42128;
    const int UnderlyingProvisionOptionExerciseEarliestTime = 42129;
    const int UnderlyingProvisionOptionExerciseEarliestTimeBusinessCenter = 42130;
    const int UnderlyingProvisionOptionExerciseLatestTime = 42131;
    const int UnderlyingProvisionOptionExerciseLatestTimeBusinessCenter = 42132;
    const int UnderlyingProvisionOptionExpirationDateUnadjusted = 42133;
    const int UnderlyingProvisionOptionExpirationDateBusinessDayConvention = 42134;
    const int UnderlyingProvisionOptionExpirationDateRelativeTo = 42135;
    const int UnderlyingProvisionOptionExpirationDateOffsetPeriod = 42136;
    const int UnderlyingProvisionOptionExpirationDateOffsetUnit = 42137;
    const int UnderlyingProvisionOptionExpirationDateOffsetDayType = 42138;
    const int UnderlyingProvisionOptionExpirationDateAdjusted = 42139;
    const int UnderlyingProvisionOptionExpirationTime = 42140;
    const int UnderlyingProvisionOptionExpirationTimeBusinessCenter = 42141;
    const int UnderlyingProvisionOptionRelevantUnderlyingDateUnadjusted = 42142;
    const int UnderlyingProvisionOptionRelevantUnderlyingDateBizDayConvention = 42143;
    const int UnderlyingProvisionOptionRelevantUnderlyingDateRelativeTo = 42144;
    const int UnderlyingProvisionOptionRelevantUnderlyingDateOffsetPeriod = 42145;
    const int UnderlyingProvisionOptionRelevantUnderlyingDateOffsetUnit = 42146;
    const int UnderlyingProvisionOptionRelevantUnderlyingDateOffsetDayType = 42147;
    const int UnderlyingProvisionOptionRelevantUnderlyingDateAdjusted = 42148;
    const int NoUnderlyingProvisions = 42149;
    const int UnderlyingProvisionType = 42150;
    const int UnderlyingProvisionDateUnadjusted = 42151;
    const int UnderlyingProvisionDateBusinessDayConvention = 42152;
    const int UnderlyingProvisionDateAdjusted = 42153;
    const int UnderlyingProvisionDateTenorPeriod = 42154;
    const int UnderlyingProvisionDateTenorUnit = 42155;
    const int UnderlyingProvisionCalculationAgent = 42156;
    const int UnderlyingProvisionOptionSinglePartyBuyerSide = 42157;
    const int UnderlyingProvisionOptionSinglePartySellerSide = 42158;
    const int UnderlyingProvisionOptionExerciseStyle = 42159;
    const int UnderlyingProvisionOptionExerciseMultipleNotional = 42160;
    const int UnderlyingProvisionOptionExerciseMinimumNotional = 42161;
    const int UnderlyingProvisionOptionExerciseMaximumNotional = 42162;
    const int UnderlyingProvisionOptionMinimumNumber = 42163;
    const int UnderlyingProvisionOptionMaximumNumber = 42164;
    const int UnderlyingProvisionOptionExerciseConfirmation = 42165;
    const int UnderlyingProvisionCashSettlMethod = 42166;
    const int UnderlyingProvisionCashSettlCurrency = 42167;
    const int UnderlyingProvisionCashSettlCurrency2 = 42168;
    const int UnderlyingProvisionCashSettlQuoteType = 42169;
    const int UnderlyingProvisionText = 42170;
    const int EncodedUnderlyingProvisionTextLen = 42171;
    const int EncodedUnderlyingProvisionText = 42172;
    const int NoUnderlyingProvisionPartyIDs = 42173;
    const int UnderlyingProvisionPartyID = 42174;
    const int UnderlyingProvisionPartyIDSource = 42175;
    const int UnderlyingProvisionPartyRole = 42176;
    const int UnderlyingProvisionPartyRoleQualifier = 40918;
    const int NoUnderlyingProvisionPartySubIDs = 42177;
    const int UnderlyingProvisionPartySubID = 42178;
    const int UnderlyingProvisionPartySubIDType = 42179;
    const int NoUnderlyingProvisionCashSettlPaymentDateBusinessCenters = 42180;
    const int UnderlyingProvisionCashSettlPaymentDateBusinessCenter = 42181;
    const int NoUnderlyingProvisionCashSettlValueDateBusinessCenters = 42182;
    const int UnderlyingProvisionCashSettlValueDateBusinessCenter = 42183;
    const int NoUnderlyingProvisionOptionExerciseBusinessCenters = 42184;
    const int UnderlyingProvisionOptionExerciseBusinessCenter = 42185;
    const int NoUnderlyingProvisionOptionExpirationDateBusinessCenters = 42186;
    const int UnderlyingProvisionOptionExpirationDateBusinessCenter = 42187;
    const int NoUnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenters = 42188;
    const int UnderlyingProvisionOptionRelevantUnderlyingDateBusinessCenter = 42189;
    const int NoUnderlyingProvisionDateBusinessCenters = 42190;
    const int UnderlyingProvisionDateBusinessCenter = 42191;
    const int FillRefID = 2421;
    const int OrderRequestID = 2422;
    const int MassOrderRequestID = 2423;
    const int MassOrderReportID = 2424;
    const int MassOrderRequestStatus = 2425;
    const int MassOrderRequestResult = 2426;
    const int OrderResponseLevel = 2427;
    const int NoOrderEntries = 2428;
    const int OrderEntryAction = 2429;
    const int OrderEntryID = 2430;
    const int ExecTypeReason = 2431;
    const int TotNoOrderEntries = 2432;
    const int NoTargetPartySubIDs = 2433;
    const int TargetPartySubID = 2434;
    const int TargetPartySubIDType = 2435;
    const int TransferInstructionID = 2436;
    const int TransferID = 2437;
    const int TransferReportID = 2438;
    const int TransferTransType = 2439;
    const int TransferType = 2440;
    const int TransferScope = 2441;
    const int TransferStatus = 2442;
    const int TransferRejectReason = 2443;
    const int TransferReportType = 2444;
    const int AggressorTime = 2445;
    const int AggressorSide = 2446;
    const int FastMarketIndicator = 2447;
    const int LinkageHandlingIndicator = 2448;
    const int NumberOfBuyOrders = 2449;
    const int NumberOfSellOrders = 2450;
    const int SettlPriceDeterminationMethod = 2451;
    const int MDStatisticReqID = 2452;
    const int MDStatisticRptID = 2453;
    const int MDStatisticName = 2454;
    const int MDStatisticDesc = 2455;
    const int MDStatisticType = 2456;
    const int MDStatisticScope = 2457;
    const int MDStatisticSubScope = 2458;
    const int MDStatisticScopeType = 2459;
    const int MDStatisticFrequencyPeriod = 2460;
    const int MDStatisticFrequencyUnit = 2461;
    const int MDStatisticDelayPeriod = 2462;
    const int MDStatisticDelayUnit = 2463;
    const int MDStatisticIntervalType = 2464;
    const int MDStatisticIntervalTypeUnit = 2465;
    const int MDStatisticIntervalPeriod = 2466;
    const int MDStatisticIntervalUnit = 2467;
    const int MDStatisticStartDate = 2468;
    const int MDStatisticEndDate = 2469;
    const int MDStatisticStartTime = 2470;
    const int MDStatisticEndTime = 2471;
    const int MDStatisticRatioType = 2472;
    const int MDStatisticRequestResult = 2473;
    const int NoMDStatistics = 2474;
    const int MDStatisticID = 2475;
    const int MDStatisticTime = 2476;
    const int MDStatisticStatus = 2477;
    const int MDStatisticValue = 2478;
    const int MDStatisticValueType = 2479;
    const int MDStatisticValueUnit = 2480;
    const int EncodedMDStatisticDescLen = 2481;
    const int EncodedMDStatisticDesc = 2482;
    const int AllocRiskLimitCheckStatus = 2483;
    const int AssetGroup = 2210;
    const int LegAssetGroup = 2348;
    const int LegContractualDefinition = 42199;
    const int NoLegContractualDefinitions = 42198;
    const int LegContractualMatrixDate = 42205;
    const int LegContractualMatrixSource = 42204;
    const int LegContractualMatrixTerm = 42206;
    const int NoLegContractualMatrices = 42203;
    const int EncodedLegDocumentationText = 2493;
    const int EncodedLegDocumentationTextLen = 2494;
    const int LegAgreementCurrency = 2495;
    const int LegAgreementDate = 2496;
    const int LegAgreementDesc = 2497;
    const int LegAgreementID = 2498;
    const int LegAgreementVersion = 2499;
    const int LegBrokerConfirmationDesc = 2500;
    const int LegCreditSupportAgreementDate = 2501;
    const int LegCreditSupportAgreementDesc = 2502;
    const int LegCreditSupportAgreementID = 2503;
    const int LegDeliveryType = 2504;
    const int LegDocumentationText = 2505;
    const int LegEndDate = 2506;
    const int LegGoverningLaw = 2507;
    const int LegMarginRatio = 2508;
    const int LegMasterConfirmationAnnexDate = 2509;
    const int LegMasterConfirmationDate = 2510;
    const int LegMasterConfirmationDesc = 2511;
    const int LegMasterConfirmationAnnexDesc = 2512;
    const int LegStartDate = 2513;
    const int LegTerminationType = 2514;
    const int LegFinancingTermSupplementDate = 42202;
    const int LegFinancingTermSupplementDesc = 42201;
    const int NoLegFinancingTermSupplements = 42200;
    const int UnderlyingAssetGroup = 2491;
    const int FirmTransactionID = 2484;
    const int TransactionID = 2485;
    const int WireReference = 2486;
    const int CollRptRejectReason = 2487;
    const int CollRptStatus = 2488;
    const int PackageID = 2489;
    const int TradeNumber = 2490;
    const int AllocCalculatedCcyQty = 2515;
    const int CollateralRequestInstruction = 2516;
    const int CollateralRequestLinkID = 2517;
    const int CollateralRequestNumber = 2518;
    const int TotNumCollateralRequests = 2519;
    const int WarningText = 2520;
    const int EncodedWarningText = 2521;
    const int EncodedWarningTextLen = 2522;
    const int LegStreamCommodityDeliveryPricingRegion = 42588;
    const int StreamCommodityDeliveryPricingRegion = 42587;
    const int AffiliatedFirmsTradeIndicator = 2525;
    const int InternationalSwapIndicator = 2526;
    const int MultiAssetSwapIndicator = 2527;
    const int UnderlyingStreamCommodityDeliveryPricingRegion = 42589;
    const int NoRelativeValues = 2529;
    const int RelativeValueType = 2530;
    const int RelativeValue = 2531;
    const int RelativeValueSide = 2532;
    const int BidSpread = 2533;
    const int OfferSpread = 2534;
    const int ClearingSettlPrice = 2528;
    const int MDReportEvent = 2535;
    const int MDReportCount = 2536;
    const int TotNoMarketSegmentReports = 2537;
    const int TotNoInstrumentReports = 2538;
    const int TotNoPartyDetailReports = 2539;
    const int TotNoEntitlementReports = 2540;
    const int TotNoRiskLimitReports = 2541;
    const int MarketSegmentStatus = 2542;
    const int MarketSegmentType = 2543;
    const int MarketSegmentSubType = 2544;
    const int NoRelatedMarketSegments = 2545;
    const int RelatedMarketSegmentID = 2546;
    const int MarketSegmentRelationship = 2547;
    const int NoAuctionTypeRules = 2548;
    const int AuctionTypeProductComplex = 2549;
    const int NoPriceRangeRules = 2550;
    const int StartPriceRange = 2551;
    const int EndPriceRange = 2552;
    const int PriceRangeValue = 2553;
    const int PriceRangePercentage = 2554;
    const int PriceRangeProductComplex = 2555;
    const int PriceRangeRuleID = 2556;
    const int FastMarketPercentage = 2557;
    const int NoQuoteSizeRules = 2558;
    const int QuoteSideIndicator = 2559;
    const int NoFlexProductEligibilities = 2560;
    const int FlexProductEligibilityComplex = 2561;
    const int NumOfComplexInstruments = 2562;
    const int MarketDepthTimeInterval = 2563;
    const int MarketDepthTimeIntervalUnit = 2564;
    const int MDRecoveryTimeInterval = 2565;
    const int MDRecoveryTimeIntervalUnit = 2566;
    const int PrimaryServiceLocationID = 2567;
    const int SecondaryServiceLocationID = 2568;
    const int MatchRuleProductComplex = 2569;
    const int CustomerPriority = 2570;
    const int TickRuleProductComplex = 2571;
    const int PreviousAdjustedOpenInterest = 2572;
    const int PreviousUnadjustedOpenInterest = 2573;
    const int LowExercisePriceOptionIndicator = 2574;
    const int BlockTradeEligibilityIndicator = 2575;
    const int InstrumentPricePrecision = 2576;
    const int StrikePricePrecision = 2577;
    const int OrigStrikePrice = 2578;
    const int SettlSubMethod = 2579;
    const int NoClearingPriceParameters = 2580;
    const int BusinessDayType = 2581;
    const int ClearingPriceOffset = 2582;
    const int VegaMultiplier = 2583;
    const int AnnualTradingBusinessDays = 2584;
    const int TotalTradingBusinessDays = 2585;
    const int TradingBusinessDays = 2586;
    const int RealizedVariance = 2587;
    const int StandardVariance = 2588;
    const int RelatedClosePrice = 2589;
    const int OvernightInterestRate = 2590;
    const int AccumulatedReturnModifiedVariationMargin = 2591;
    const int CalculationMethod = 2592;
    const int NoMiscFeeSubTypes = 2633;
    const int MiscFeeSubType = 2634;
    const int MiscFeeSubTypeAmt = 2635;
    const int MiscFeeSubTypeDesc = 2636;
    const int EncodedMiscFeeSubTypeDescLen = 2637;
    const int EncodedMiscFeeSubTypeDesc = 2638;
    const int CollateralAmountType = 2632;
    const int PositionID = 2618;
    const int PaymentDesc = 43087;
    const int NoCommissions = 2639;
    const int CommissionAmount = 2640;
    const int CommissionAmountType = 2641;
    const int CommissionBasis = 2642;
    const int CommissionCurrency = 2643;
    const int CommissionUnitOfMeasure = 2644;
    const int CommissionUnitOfMeasureCurrency = 2645;
    const int CommissionRate = 2646;
    const int CommissionSharedIndicator = 2647;
    const int CommissionAmountShared = 2648;
    const int CommissionLegRefID = 2649;
    const int CommissionDesc = 2650;
    const int EncodedCommissionDescLen = 2651;
    const int EncodedCommissionDesc = 2652;
    const int NoAllocCommissions = 2653;
    const int AllocCommissionAmount = 2654;
    const int AllocCommissionAmountType = 2655;
    const int AllocCommissionBasis = 2656;
    const int AllocCommissionCurrency = 2657;
    const int AllocCommissionUnitOfMeasure = 2658;
    const int AllocCommissionUnitOfMeasureCurrency = 2659;
    const int AllocCommissionRate = 2660;
    const int AllocCommissionSharedIndicator = 2661;
    const int AllocCommissionAmountShared = 2662;
    const int AllocCommissionLegRefID = 2663;
    const int AllocCommissionDesc = 2664;
    const int EncodedAllocCommissionDescLen = 2665;
    const int EncodedAllocCommissionDesc = 2666;
    const int DeltaCrossed = 2596;
    const int CashSettlDateUnadjusted = 42207;
    const int CashSettlDateBusinessDayConvention = 42208;
    const int CashSettlDateRelativeTo = 42209;
    const int CashSettlDateOffsetPeriod = 42210;
    const int CashSettlDateOffsetUnit = 42211;
    const int CashSettlDateOffsetDayType = 42212;
    const int CashSettlDateAdjusted = 42213;
    const int NoCashSettlDateBusinessCenters = 42214;
    const int CashSettlDateBusinessCenter = 42215;
    const int CashSettlPriceSource = 42216;
    const int CashSettlPriceDefault = 42217;
    const int ComplexEventFuturesPriceValuation = 2597;
    const int ComplexEventOptionsPriceValuation = 2598;
    const int ComplexEventPVFinalPriceElectionFallback = 2599;
    const int DividendFloatingRateIndex = 42218;
    const int DividendFloatingRateIndexCurvePeriod = 42219;
    const int DividendFloatingRateIndexCurveUnit = 42220;
    const int DividendFloatingRateMultiplier = 42221;
    const int DividendFloatingRateSpread = 42222;
    const int DividendFloatingRateSpreadPositionType = 42223;
    const int DividendFloatingRateTreatment = 42224;
    const int DividendCapRate = 42225;
    const int DividendCapRateBuySide = 42226;
    const int DividendCapRateSellSide = 42227;
    const int DividendFloorRate = 42228;
    const int DividendFloorRateBuySide = 42229;
    const int DividendFloorRateSellSide = 42230;
    const int DividendInitialRate = 42231;
    const int DividendFinalRateRoundingDirection = 42232;
    const int DividendFinalRatePrecision = 42233;
    const int DividendAveragingMethod = 42234;
    const int DividendNegativeRateTreatment = 42235;
    const int NoDividendAccrualPaymentDateBusinessCenters = 42236;
    const int DividendAccrualPaymentDateBusinessCenter = 42237;
    const int DividendAccrualPaymentDateRelativeTo = 42238;
    const int DividendAccrualPaymentDateOffsetPeriod = 42239;
    const int DividendAccrualPaymentDateOffsetUnit = 42240;
    const int DividendAccrualPaymentDateOffsetDayType = 42241;
    const int DividendAccrualPaymentDateUnadjusted = 42242;
    const int DividendAccrualPaymeentDateBusinessDayConvention = 42243;
    const int DividendAccrualPaymentDateAdjusted = 42244;
    const int DividendReinvestmentIndicator = 42245;
    const int DividendEntitlementEvent = 42246;
    const int DividendAmountType = 42247;
    const int DividendUnderlierRefID = 42248;
    const int ExtraordinaryDividendPartySide = 42249;
    const int ExtraordinaryDividendAmountType = 42250;
    const int ExtraordinaryDividendCurrency = 42251;
    const int ExtraordinaryDividendDeterminationMethod = 42252;
    const int DividendAccrualFixedRate = 42253;
    const int DividendCompoundingMethod = 42254;
    const int DividendNumOfIndexUnits = 42255;
    const int DividendCashPercentage = 42256;
    const int DividendCashEquivalentPercentage = 42257;
    const int NonCashDividendTreatment = 42258;
    const int DividendComposition = 42259;
    const int SpecialDividendsIndicator = 42260;
    const int MaterialDividendsIndicator = 42261;
    const int OptionsExchangeDividendsIndicator = 42262;
    const int AdditionalDividendsIndicator = 42263;
    const int AllDividendsIndicator = 42264;
    const int DividendFXTriggerDateRelativeTo = 42265;
    const int DividendFXTriggerDateOffsetPeriod = 42266;
    const int DividendFXTriggerDateOffsetUnit = 42267;
    const int DividendFXTriggerDateOffsetDayType = 42268;
    const int DividendFXTriggerDateUnadjusted = 42269;
    const int DividendFXTriggerDateBusinessDayConvention = 42270;
    const int DividendFXTriggerDateAdjusted = 42271;
    const int NoDividendFXTriggerDateBusinessCenters = 42272;
    const int DividendFXTriggerDateBusinessCenter = 42273;
    const int NoDividendPeriods = 42274;
    const int DividendPeriodSequence = 42275;
    const int DividendPeriodStartDateUnadjusted = 42276;
    const int DividendPeriodEndDateUnadjusted = 42277;
    const int DividendPeriodUnderlierRefID = 42278;
    const int DividendPeriodStrikePrice = 42279;
    const int DividendPeriodBusinessDayConvention = 42280;
    const int DividendPeriodValuationDateUnadjusted = 42281;
    const int DividendPeriodValuationDateRelativeTo = 42282;
    const int DividendPeriodValuationDateOffsetPeriod = 42283;
    const int DividendPeriodValuationDateOffsetUnit = 42284;
    const int DividendPeriodValuationDateOffsetDayType = 42285;
    const int DividendPeriodValuationDateAdjusted = 42286;
    const int DividendPeriodPaymentDateUnadjusted = 42287;
    const int DividendPeriodPaymentDateRelativeTo = 42288;
    const int DividendPeriodPaymentDateOffsetPeriod = 42289;
    const int DividendPeriodPaymentDateOffsetUnit = 42290;
    const int DividendPeriodPaymentDateOffsetDayType = 42291;
    const int DividendPeriodPaymentDateAdjusted = 42292;
    const int DividendPeriodXID = 42293;
    const int NoDividendPeriodBusinessCenters = 42294;
    const int DividendPeriodBusinessCenter = 42295;
    const int NoExtraordinaryEvents = 42296;
    const int ExtraordinaryEventType = 42297;
    const int ExtraordinaryEventValue = 42298;
    const int StrikeIndexCurvePoint = 2600;
    const int StrikeIndexQuote = 2601;
    const int ExtraordinaryEventAdjustmentMethod = 2602;
    const int ExchangeLookAlike = 2603;
    const int LegStrikeIndexCurvePoint = 2604;
    const int LegStrikeIndexQuote = 2605;
    const int LegExtraordinaryEventAdjustmentMethod = 2606;
    const int LegExchangeLookAlike = 2607;
    const int LegCashSettlDateUnadjusted = 42299;
    const int LegCashSettlDateBusinessDayConvention = 42300;
    const int LegCashSettlDateRelativeTo = 42301;
    const int LegCashSettlDateOffsetPeriod = 42302;
    const int LegCashSettlDateOffsetUnit = 42303;
    const int LegCashSettlDateOffsetDayType = 42304;
    const int LegCashSettlDateAdjusted = 42305;
    const int NoLegCashSettlDateBusinessCenters = 42306;
    const int LegCashSettlDateBusinessCenter = 42307;
    const int LegCashSettlPriceSource = 42308;
    const int LegCashSettlPriceDefault = 42309;
    const int LegComplexEventFuturesPriceValuation = 2608;
    const int LegComplexEventOptionsPriceValuation = 2609;
    const int LegComplexEventPVFinalPriceElectionFallback = 2610;
    const int NoLegDividendAccrualPaymentDateBusinessCenters = 42310;
    const int LegDividendAccrualPaymentDateBusinessCenter = 42311;
    const int LegDividendFloatingRateIndex = 42312;
    const int LegDividendFloatingRateIndexCurvePeriod = 42313;
    const int LegDividendFloatingRateIndexCurveUnit = 42314;
    const int LegDividendFloatingRateMultiplier = 42315;
    const int LegDividendFloatingRateSpread = 42316;
    const int LegDividendFloatingRateSpreadPositionType = 42317;
    const int LegDividendFloatingRateTreatment = 42318;
    const int LegDividendCapRate = 42319;
    const int LegDividendCapRateBuySide = 42320;
    const int LegDividendCapRateSellSide = 42321;
    const int LegDividendFloorRate = 42322;
    const int LegDividendFloorRateBuySide = 42323;
    const int LegDividendFloorRateSellSide = 42324;
    const int LegDividendInitialRate = 42325;
    const int LegDividendFinalRateRoundingDirection = 42326;
    const int LegDividendFinalRatePrecision = 42327;
    const int LegDividendAveragingMethod = 42328;
    const int LegDividendNegativeRateTreatment = 42329;
    const int LegDividendAccrualPaymentDateRelativeTo = 42330;
    const int LegDividendAccrualPaymentDateOffsetPeriod = 42331;
    const int LegDividendAccrualPaymentDateOffsetUnit = 42332;
    const int LegDividendAccrualPaymentDateOffsetDayType = 42333;
    const int LegDividendAccrualPaymentDateUnadjusted = 42334;
    const int LegDividendAccrualPaymentDateBusinessDayConvention = 42335;
    const int LegDividendAccrualPaymentDateAdjusted = 42336;
    const int LegDividendReinvestmentIndicator = 42337;
    const int LegDividendEntitlementEvent = 42338;
    const int LegDividendAmountType = 42339;
    const int LegDividendUnderlierRefID = 42340;
    const int LegExtraordinaryDividendPartySide = 42341;
    const int LegExtraordinaryDividendAmountType = 42342;
    const int LegExtraordinaryDividendCurrency = 42343;
    const int LegExtraordinaryDividendDeterminationMethod = 42344;
    const int LegDividendAccrualFixedRate = 42345;
    const int LegDividendCompoundingMethod = 42346;
    const int LegDividendNumOfIndexUnits = 42347;
    const int LegDividendCashPercentage = 42348;
    const int LegDividendCashEquivalentPercentage = 42349;
    const int LegNonCashDividendTreatment = 42350;
    const int LegDividendComposition = 42351;
    const int LegSpecialDividendsIndicator = 42352;
    const int LegMaterialDividendsIndicator = 42353;
    const int LegOptionsExchangeDividendsIndicator = 42354;
    const int LegAdditionalDividendsIndicator = 42355;
    const int LegAllDividendsIndicator = 42356;
    const int LegDividendFXTriggerDateRelativeTo = 42357;
    const int LegDividendFXTriggerDateOffsetPeriod = 42358;
    const int LegDividendFXTriggerDateOffsetUnit = 42359;
    const int LegDividendFXTriggerDateOffsetDayType = 42360;
    const int LegDividendFXTriggerDateUnadjusted = 42361;
    const int LegDividendFXTriggerDateBusinessDayConvention = 42362;
    const int LegDividendFXTriggerDateAdjusted = 42363;
    const int NoLegDividendFXTriggerDateBusinessCenters = 42364;
    const int LegDividendFXTriggerDateBusinessCenter = 42365;
    const int NoLegDividendPeriods = 42366;
    const int LegDividendPeriodSequence = 42367;
    const int LegDividendPeriodStartDateUnadjusted = 42368;
    const int LegDividendPeriodEndDateUnadjusted = 42369;
    const int LegDividendPeriodUnderlierRefID = 42370;
    const int LegDividendPeriodStrikePrice = 42371;
    const int LegDividendPeriodBusinessDayConvention = 42372;
    const int LegDividendPeriodValuationDateUnadjusted = 42373;
    const int LegDividendPeriodValuationDateRelativeTo = 42374;
    const int LegDividendPeriodValuationDateOffsetPeriod = 42375;
    const int LegDividendPeriodValuationDateOffsetUnit = 42376;
    const int LegDividendPeriodValuationDateOffsetDayType = 42377;
    const int LegDividendPeriodValuationDateAdjusted = 42378;
    const int LegDividendPeriodPaymentDateUnadjusted = 42379;
    const int LegDividendPeriodPaymentDateRelativeTo = 42380;
    const int LegDividendPeriodPaymentDateOffsetPeriod = 42381;
    const int LegDividendPeriodPaymentDateOffsetUnit = 42382;
    const int LegDividendPeriodPaymentDateOffsetDayType = 42383;
    const int LegDividendPeriodPaymentDateAdjusted = 42384;
    const int LegDividendPeriodXID = 42385;
    const int NoLegDividendPeriodBusinessCenters = 42386;
    const int LegDividendPeriodBusinessCenter = 42387;
    const int NoLegExtraordinaryEvents = 42388;
    const int LegExtraordinaryEventType = 42389;
    const int LegExtraordinaryEventValue = 42390;
    const int LegSettlMethodElectingPartySide = 42391;
    const int LegMakeWholeDate = 42392;
    const int LegMakeWholeAmount = 42393;
    const int LegMakeWholeBenchmarkCurveName = 42394;
    const int LegMakeWholeBenchmarkCurvePoint = 42395;
    const int LegMakeWholeRecallSpread = 42396;
    const int LegMakeWholeBenchmarkQuote = 42397;
    const int LegMakeWholeInterpolationMethod = 42398;
    const int LegPaymentStreamCashSettlIndicator = 42399;
    const int LegPaymentStreamCompoundingXIDRef = 42400;
    const int LegPaymentStreamCompoundingSpread = 42401;
    const int LegPaymentStreamInterpolationMethod = 42402;
    const int LegPaymentStreamInterpolationPeriod = 42403;
    const int LegPaymentStreamCompoundingFixedRate = 42404;
    const int NoLegPaymentStreamCompoundingDates = 42405;
    const int LegPaymentStreamCompoundingDate = 42406;
    const int LegPaymentStreamCompoundingDateType = 42407;
    const int LegPaymentStreamCompoundingDatesBusinessDayConvention = 42408;
    const int LegPaymentStreamCompoundingDatesRelativeTo = 42409;
    const int LegPaymentStreamCompoundingDatesOffsetPeriod = 42410;
    const int LegPaymentStreamCompoundingDatesOffsetUnit = 42411;
    const int LegPaymentStreamCompoundingDatesOffsetDayType = 42412;
    const int LegPaymentStreamCompoundingPeriodSkip = 42413;
    const int LegPaymentStreamCompoundingFrequencyPeriod = 42414;
    const int LegPaymentStreamCompoundingFrequencyUnit = 42415;
    const int LegPaymentStreamCompoundingRollConvention = 42416;
    const int LegPaymentStreamBoundsFirstDateUnadjusted = 42417;
    const int LegPaymentStreamBoundsLastDateUnadjusted = 42418;
    const int NoLegPaymentStreamCompoundingDatesBusinessCenters = 42419;
    const int LegPaymentStreamCompoundingDatesBusinessCenter = 42420;
    const int LegPaymentStreamCompoundingEndDateUnadjusted = 42421;
    const int LegPaymentStreamCompoundingEndDateRelativeTo = 42422;
    const int LegPaymentStreamCompoundingEndDateOffsetPeriod = 42423;
    const int LegPaymentStreamCompoundingEndDateOffsetUnit = 42424;
    const int LegPaymentStreamCompoundingEndDateOffsetDayType = 42425;
    const int LegPaymentStreamCompoundingEndDateAdjusted = 42426;
    const int LegPaymentStreamCompoundingRateIndex = 42427;
    const int LegPaymentStreamCompoundingRateIndexCurvePeriod = 42428;
    const int LegPaymentStreamCompoundingRateIndexCurveUnit = 42429;
    const int LegPaymentStreamCompoundingRateMultiplier = 42430;
    const int LegPaymentStreamCompoundingRateSpread = 42431;
    const int LegPaymentStreamCompoundingRateSpreadPositionType = 42432;
    const int LegPaymentStreamCompoundingRateTreatment = 42433;
    const int LegPaymentStreamCompoundingCapRate = 42434;
    const int LegPaymentStreamCompoundingCapRateBuySide = 42435;
    const int LegPaymentStreamCompoundingCapRateSellSide = 42436;
    const int LegPaymentStreamCompoundingFloorRate = 42437;
    const int LegPaymentStreamCompoundingFloorRateBuySide = 42438;
    const int LegPaymentStreamCompoundingFloorRateSellSide = 42439;
    const int LegPaymentStreamCompoundingInitialRate = 42440;
    const int LegPaymentStreamCompoundingFinalRateRoundingDirection = 42441;
    const int LegPaymentStreamCompoundingFinalRatePrecision = 42442;
    const int LegPaymentStreamCompoundingAveragingMethod = 42443;
    const int LegPaymentStreamCompoundingNegativeRateTreatment = 42444;
    const int LegPaymentStreamCompoundingStartDateUnadjusted = 42445;
    const int LegPaymentStreamCompoundingStartDateRelativeTo = 42446;
    const int LegPaymentStreamCompoundingStartDateOffsetPeriod = 42447;
    const int LegPaymentStreamCompoundingStartDateOffsetUnit = 42448;
    const int LegPaymentStreamCompoundingStartDateOffsetDayType = 42449;
    const int LegPaymentStreamCompoundingStartDateAdjusted = 42450;
    const int LegPaymentStreamFormulaImageLength = 42451;
    const int LegPaymentStreamFormulaImage = 42452;
    const int LegPaymentStreamFinalPricePaymentDateUnadjusted = 42453;
    const int LegPaymentStreamFinalPricePaymentDateRelativeTo = 42454;
    const int LegPaymentStreamFinalPricePaymentDateOffsetPeriod = 42455;
    const int LegPaymentStreamFinalPricePaymentDateOffsetUnit = 42456;
    const int LegPaymentStreamFinalPricePaymentDateOffsetDayType = 42457;
    const int LegPaymentStreamFinalPricePaymentDateAdjusted = 42458;
    const int NoLegPaymentStreamFixingDates = 42459;
    const int LegPaymentStreamFixingDate = 42460;
    const int LegPaymentStreamFixingDateType = 42461;
    const int LegPaymentStreamFirstObservationDateUnadjusted = 42462;
    const int LegPaymentStreamFirstObservationDateRelativeTo = 42463;
    const int LegPaymentStreamFirstObservationDateOffsetDayType = 42464;
    const int LegPaymentStreamFirstObservationDateAdjusted = 42465;
    const int LegPaymentStreamUnderlierRefID = 42466;
    const int LegReturnRateNotionalReset = 42467;
    const int LegPaymentStreamLinkInitialLevel = 42468;
    const int LegPaymentStreamLinkClosingLevelIndicator = 42469;
    const int LegPaymentStreamLinkExpiringLevelIndicator = 42470;
    const int LegPaymentStreamLinkEstimatedTradingDays = 42471;
    const int LegPaymentStreamLinkStrikePrice = 42472;
    const int LegPaymentStreamLinkStrikePriceType = 42473;
    const int LegPaymentStreamLinkMaximumBoundary = 42474;
    const int LegPaymentStreamLinkMinimumBoundary = 42475;
    const int LegPaymentStreamLinkNumberOfDataSeries = 42476;
    const int LegPaymentStreamVarianceUnadjustedCap = 42477;
    const int LegPaymentStreamRealizedVarianceMethod = 42478;
    const int LegPaymentStreamDaysAdjustmentIndicator = 42479;
    const int LegPaymentStreamNearestExchangeContractRefID = 42480;
    const int LegPaymentStreamVegaNotionalAmount = 42481;
    const int LegPaymentStreamFormulaCurrency = 42482;
    const int LegPaymentStreamFormulaCurrencyDeterminationMethod = 42483;
    const int LegPaymentStreamFormulaReferenceAmount = 42484;
    const int NoLegPaymentStreamFormulas = 42485;
    const int LegPaymentStreamFormula = 42486;
    const int LegPaymentStreamFormulaDesc = 42487;
    const int LegPaymentStubEndDateUnadjusted = 42488;
    const int LegPaymentStubEndDateBusinessDayConvention = 42489;
    const int LegPaymentStubEndDateRelativeTo = 42490;
    const int LegPaymentStubEndDateOffsetPeriod = 42491;
    const int LegPaymentStubEndDateOffsetUnit = 42492;
    const int LegPaymentStubEndDateOffsetDayType = 42493;
    const int LegPaymentStubEndDateAdjusted = 42494;
    const int NoLegPaymentStubEndDateBusinessCenters = 42495;
    const int LegPaymentStubEndDateBusinessCenter = 42496;
    const int LegPaymentStubStartDateUnadjusted = 42497;
    const int LegPaymentStubStartDateBusinessDayConvention = 42498;
    const int LegPaymentStubStartDateRelativeTo = 42499;
    const int LegPaymentStubStartDateOffsetPeriod = 42500;
    const int LegPaymentStubStartDateOffsetUnit = 42501;
    const int LegPaymentStubStartDateOffsetDayType = 42502;
    const int LegPaymentStubStartDateAdjusted = 42503;
    const int NoLegPaymentStubStartDateBusinessCenters = 42504;
    const int LegPaymentStubStartDateBusinessCenter = 42505;
    const int LegProvisionBreakFeeElection = 42506;
    const int LegProvisionBreakFeeRate = 42507;
    const int NoLegReturnRateDates = 42508;
    const int LegReturnRateDateMode = 42509;
    const int LegReturnRateValuationDateRelativeTo = 42510;
    const int LegReturnRateValuationDateOffsetPeriod = 42511;
    const int LegReturnRateValuationDateOffsetUnit = 42512;
    const int LegReturnRateValuationDateOffsetDayType = 42513;
    const int LegReturnRateValuationStartDateUnadjusted = 42514;
    const int LegReturnRateValuationStartDateRelativeTo = 42515;
    const int LegReturnRateValuationStartDateOffsetPeriod = 42516;
    const int LegReturnRateValuationStartDateOffsetUnit = 42517;
    const int LegReturnRateValuationStartDateOffsetDayType = 42518;
    const int LegReturnRateValuationStartDateAdjusted = 42519;
    const int LegReturnRateValuationEndDateUnadjusted = 42520;
    const int LegReturnRateValuationEndDateRelativeTo = 42521;
    const int LegReturnRateValuationEndDateOffsetPeriod = 42522;
    const int LegReturnRateValuationEndDateOffsetUnit = 42523;
    const int LegReturnRateValuationEndDateOffsetDayType = 42524;
    const int LegReturnRateValuationEndDateAdjusted = 42525;
    const int LegReturnRateValuationFrequencyPeriod = 42526;
    const int LegReturnRateValuationFrequencyUnit = 42527;
    const int LegReturnRateValuationFrequencyRollConvention = 42528;
    const int LegReturnRateValuationDateBusinessDayConvention = 42529;
    const int NoLegReturnRateFXConversions = 42530;
    const int LegReturnRateFXCurrencySymbol = 42531;
    const int LegReturnRateFXRate = 42532;
    const int LegReturnRateFXRateCalc = 42533;
    const int NoLegReturnRates = 42534;
    const int LegReturnRatePriceSequence = 42535;
    const int LegReturnRateCommissionBasis = 42536;
    const int LegReturnRateCommissionAmount = 42537;
    const int LegReturnRateCommissionCurrency = 42538;
    const int LegReturnRateTotalCommissionPerTrade = 42539;
    const int LegReturnRateDeterminationMethod = 42540;
    const int LegReturnRateAmountRelativeTo = 42541;
    const int LegReturnRateQuoteMeasureType = 42542;
    const int LegReturnRateQuoteUnits = 42543;
    const int LegReturnRateQuoteMethod = 42544;
    const int LegReturnRateQuoteCurrency = 42545;
    const int LegReturnRateQuoteCurrencyType = 42546;
    const int LegReturnRateQuoteTimeType = 42547;
    const int LegReturnRateQuoteTime = 42548;
    const int LegReturnRateQuoteDate = 42549;
    const int LegReturnRateQuoteExpirationTime = 42550;
    const int LegReturnRateQuoteBusinessCenter = 42551;
    const int LegReturnRateQuoteExchange = 42552;
    const int LegReturnRateQuotePricingModel = 42553;
    const int LegReturnRateCashFlowType = 42554;
    const int LegReturnRateValuationTimeType = 42555;
    const int LegReturnRateValuationTime = 42556;
    const int LegReturnRateValuationTimeBusinessCenter = 42557;
    const int LegReturnRateValuationPriceOption = 42558;
    const int LegReturnRateFinalPriceFallback = 42559;
    const int NoLegReturnRateInformationSources = 42560;
    const int LegReturnRateInformationSource = 42561;
    const int LegReturnRateReferencePage = 42562;
    const int LegReturnRateReferencePageHeading = 42563;
    const int NoLegReturnRatePrices = 42564;
    const int LegReturnRatePriceBasis = 42565;
    const int LegReturnRatePrice = 42566;
    const int LegReturnRatePriceCurrency = 42567;
    const int LegReturnRatePriceType = 42568;
    const int NoLegReturnRateValuationDateBusinessCenters = 42569;
    const int LegReturnRateValuationDateBusinessCenter = 42570;
    const int NoLegReturnRateValuationDates = 42571;
    const int LegReturnRateValuationDate = 42572;
    const int LegReturnRateValuationDateType = 42573;
    const int LegSettlMethodElectionDateUnadjusted = 42574;
    const int LegSettlMethodElectionDateBusinessDayConvention = 42575;
    const int LegSettlMethodElectionDateRelativeTo = 42576;
    const int LegSettlMethodElectionDateOffsetPeriod = 42577;
    const int LegSettlMethodElectionDateOffsetUnit = 42578;
    const int LegSettlMethodElectionDateOffsetDayType = 42579;
    const int LegSettlMethodElectionDateAdjusted = 42580;
    const int NoLegSettlMethodElectionDateBusinessCenters = 42581;
    const int LegSettlMethodElectionDateBusinessCenter = 42582;
    const int LegStreamVersion = 42583;
    const int LegStreamVersionEffectiveDate = 42584;
    const int LegStreamNotionalDeterminationMethod = 42585;
    const int LegStreamNotionalAdjustments = 42586;
    const int SettlMethodElectingPartySide = 42590;
    const int MakeWholeDate = 42591;
    const int MakeWholeAmount = 42592;
    const int MakeWholeBenchmarkCurveName = 42593;
    const int MakeWholeBenchmarkCurvePoint = 42594;
    const int MakeWholeRecallSpread = 42595;
    const int MakeWholeBenchmarkQuote = 42596;
    const int MakeWholeInterpolationMethod = 42597;
    const int PaymentAmountRelativeTo = 42598;
    const int PaymentAmountDeterminationMethod = 42599;
    const int PaymentStreamCashSettlIndicator = 42600;
    const int PaymentStreamCompoundingXIDRef = 42601;
    const int PaymentStreamCompoundingSpread = 42602;
    const int PaymentStreamInterpolationMethod = 42603;
    const int PaymentStreamInterpolationPeriod = 42604;
    const int PaymentStreamCompoundingFixedRate = 42605;
    const int NoPaymentStreamCompoundingDates = 42606;
    const int PaymentStreamCompoundingDate = 42607;
    const int PaymentStreamCompoundingDateType = 42608;
    const int PaymentStreamCompoundingDatesBusinessDayConvention = 42609;
    const int PaymentStreamCompoundingDatesRelativeTo = 42610;
    const int PaymentStreamCompoundingDatesOffsetPeriod = 42611;
    const int PaymentStreamCompoundingDatesOffsetUnit = 42612;
    const int PaymentStreamCompoundingDatesOffsetDayType = 42613;
    const int PaymentStreamCompoundingPeriodSkip = 42614;
    const int PaymentStreamCompoundingFrequencyPeriod = 42615;
    const int PaymentStreamCompoundingFrequencyUnit = 42616;
    const int PaymentStreamCompoundingRollConvention = 42617;
    const int PaymentStreamBoundsFirstDateUnadjusted = 42618;
    const int PaymentStreamBoundsLastDateUnadjusted = 42619;
    const int NoPaymentStreamCompoundingDatesBusinessCenters = 42620;
    const int PaymentStreamCompoundingDatesBusinessCenter = 42621;
    const int PaymentStreamCompoundingEndDateUnadjusted = 42622;
    const int PaymentStreamCompoundingEndDateRelativeTo = 42623;
    const int PaymentStreamCompoundingEndDateOffsetPeriod = 42624;
    const int PaymentStreamCompoundingEndDateOffsetUnit = 42625;
    const int PaymentStreamCompoundingEndDateOffsetDayType = 42626;
    const int PaymentStreamCompoundingEndDateAdjusted = 42627;
    const int PaymentStreamCompoundingRateIndex = 42628;
    const int PaymentStreamCompoundingRateIndexCurvePeriod = 42629;
    const int PaymentStreamCompoundingRateIndexCurveUnit = 42630;
    const int PaymentStreamCompoundingRateMultiplier = 42631;
    const int PaymentStreamCompoundingRateSpread = 42632;
    const int PaymentStreamCompoundingRateSpreadPositionType = 42633;
    const int PaymentStreamCompoundingRateTreatment = 42634;
    const int PaymentStreamCompoundingCapRate = 42635;
    const int PaymentStreamCompoundingCapRateBuySide = 42636;
    const int PaymentStreamCompoundingCapRateSellSide = 42637;
    const int PaymentStreamCompoundingFloorRate = 42638;
    const int PaymentStreamCompoundingFloorRateBuySide = 42639;
    const int PaymentStreamCompoundingFloorRateSellSide = 42640;
    const int PaymentStreamCompoundingInitialRate = 42641;
    const int PaymentStreamCompoundingFinalRateRoundingDirection = 42642;
    const int PaymentStreamCompoundingFinalRatePrecision = 42643;
    const int PaymentStreamCompoundingAveragingMethod = 42644;
    const int PaymentStreamCompoundingNegativeRateTreatment = 42645;
    const int PaymentStreamCompoundingStartDateUnadjusted = 42646;
    const int PaymentStreamCompoundingStartDateRelativeTo = 42647;
    const int PaymentStreamCompoundingStartDateOffsetPeriod = 42648;
    const int PaymentStreamCompoundingStartDateOffsetUnit = 42649;
    const int PaymentStreamCompoundingStartDateOffsetDayType = 42650;
    const int PaymentStreamCompoundingStartDateAdjusted = 42651;
    const int PaymentStreamFormulaImageLength = 42652;
    const int PaymentStreamFormulaImage = 42653;
    const int PaymentStreamFinalPricePaymentDateUnadjusted = 42654;
    const int PaymentStreamFinalPricePaymentDateRelativeTo = 42655;
    const int PaymentStreamFinalPricePaymentDateOffsetfPeriod = 42656;
    const int PaymentStreamFinalPricePaymentDateOffsetUnit = 42657;
    const int PaymentStreamFinalPricePaymentDateOffsetDayType = 42658;
    const int PaymentStreamFinalPricePaymentDateAdjusted = 42659;
    const int NoPaymentStreamFixingDates = 42660;
    const int PaymentStreamFixingDate = 42661;
    const int PaymentStreamFixingDateType = 42662;
    const int PaymentStreamFirstObservationDateUnadjusted = 42663;
    const int PaymentStreamFirstObservationDateRelativeTo = 42664;
    const int PaymentStreamFirstObservationDateOffsetDayType = 42665;
    const int PaymentStreamFirstObservationDateAdjusted = 42666;
    const int PaymentStreamUnderlierRefID = 42667;
    const int ReturnRateNotionalReset = 42668;
    const int PaymentStreamLinkInitialLevel = 42669;
    const int PaymentStreamLinkClosingLevelIndicator = 42670;
    const int PaymentStreamLinkExpiringLevelIndicator = 42671;
    const int PaymentStreamLinkEstimatedTradingDays = 42672;
    const int PaymentStreamLinkStrikePrice = 42673;
    const int PaymentStreamLinkStrikePriceType = 42674;
    const int PaymentStreamLinkMaximumBoundary = 42675;
    const int PaymentStreamLinkMinimumBoundary = 42676;
    const int PaymentStreamLinkNumberOfDataSeries = 42677;
    const int PaymentStreamVarianceUnadjustedCap = 42678;
    const int PaymentStreamRealizedVarianceMethod = 42679;
    const int PaymentStreamDaysAdjustmentIndicator = 42680;
    const int PaymentStreamNearestExchangeContractRefID = 42681;
    const int PaymentStreamVegaNotionalAmount = 42682;
    const int NoPaymentStreamFormulas = 42683;
    const int PaymentStreamFormula = 42684;
    const int PaymentStreamFormulaDesc = 42685;
    const int PaymentStreamFormulaCurrency = 42686;
    const int PaymentStreamFormulaCurrencyDeterminationMethod = 42687;
    const int PaymentStreamFormulaReferenceAmount = 42688;
    const int PaymentStubEndDateUnadjusted = 42689;
    const int PaymentStubEndDateBusinessDayConvention = 42690;
    const int PaymentStubEndDateRelativeTo = 42691;
    const int PaymentStubEndDateOffsetPeriod = 42692;
    const int PaymentStubEndDateOffsetUnit = 42693;
    const int PaymentStubEndDateOffsetDayType = 42694;
    const int PaymentStubEndDateAdjusted = 42695;
    const int NoPaymentStubEndDateBusinessCenters = 42696;
    const int PaymentStubEndDateBusinessCenter = 42697;
    const int PaymentStubStartDateUnadjusted = 42698;
    const int PaymentStubStartDateBusinessDayConvention = 42699;
    const int PaymentStubStartDateRelativeTo = 42700;
    const int PaymentStubStartDateOffsetPeriod = 42701;
    const int PaymentStubStartDateOffsetUnit = 42702;
    const int PaymentStubStartDateOffsetDayType = 42703;
    const int PaymentStubStartDateAdjusted = 42704;
    const int NoPaymentStubStartDateBusinessCenters = 42705;
    const int PaymentStubStartDateBusinessCenter = 42706;
    const int ProvisionBreakFeeElection = 42707;
    const int ProvisionBreakFeeRate = 42708;
    const int RelatedToDividendPeriodXIDRef = 2417;
    const int NoReturnRateDates = 42709;
    const int ReturnRateDateMode = 42710;
    const int ReturnRateValuationDateRelativeTo = 42711;
    const int ReturnRateValuationDateOffsetPeriod = 42712;
    const int ReturnRateValuationDateOffsetUnit = 42713;
    const int ReturnRateValuationDateOffsetDayType = 42714;
    const int ReturnRateValuationStartDateUnadjusted = 42715;
    const int ReturnRateValuationStartDateRelativeTo = 42716;
    const int ReturnRateValuationStartDateOffsetPeriod = 42717;
    const int ReturnRateValuationStartDateOffsetUnit = 42718;
    const int ReturnRateValuationStartDateOffsetDayType = 42719;
    const int ReturnRateValuationStartDateAdjusted = 42720;
    const int ReturnRateValuationEndDateUnadjusted = 42721;
    const int ReturnRateValuationEndDateRelativeTo = 42722;
    const int ReturnRateValuationEndDateOffsetPeriod = 42723;
    const int ReturnRateValuationEndDateOffsetUnit = 42724;
    const int ReturnRateValuationEndDateOffsetDayType = 42725;
    const int ReturnRateValuationEndDateAdjusted = 42726;
    const int ReturnRateValuationFrequencyPeriod = 42727;
    const int ReturnRateValuationFrequencyUnit = 42728;
    const int ReturnRateValuationFrequencyRollConvention = 42729;
    const int ReturnRateValuationDateBusinessDayConvention = 42730;
    const int NoReturnRateFXConversions = 42731;
    const int ReturnRateFXCurrencySymbol = 42732;
    const int ReturnRateFXRate = 42733;
    const int ReturnRateFXRateCalc = 42734;
    const int NoReturnRates = 42735;
    const int ReturnRatePriceSequence = 42736;
    const int ReturnRateCommissionBasis = 42737;
    const int ReturnRateCommissionAmount = 42738;
    const int ReturnRateCommissionCurrency = 42739;
    const int ReturnRateTotalCommissionPerTrade = 42740;
    const int ReturnRateDeterminationMethod = 42741;
    const int ReturnRateAmountRelativeTo = 42742;
    const int ReturnRateQuoteMeasureType = 42743;
    const int ReturnRateQuoteUnits = 42744;
    const int ReturnRateQuoteMethod = 42745;
    const int ReturnRateQuoteCurrency = 42746;
    const int ReturnRateQuoteCurrencyType = 42747;
    const int ReturnRateQuoteTimeType = 42748;
    const int ReturnRateQuoteTime = 42749;
    const int ReturnRateQuoteDate = 42750;
    const int ReturnRateQuoteExpirationTime = 42751;
    const int ReturnRateQuoteBusinessCenter = 42752;
    const int ReturnRateQuoteExchange = 42753;
    const int ReturnRateQuotePricingModel = 42754;
    const int ReturnRateCashFlowType = 42755;
    const int ReturnRateValuationTimeType = 42756;
    const int ReturnRateValuationTime = 42757;
    const int ReturnRateValuationTimeBusinessCenter = 42758;
    const int ReturnRateValuationPriceOption = 42759;
    const int ReturnRateFinalPriceFallback = 42760;
    const int NoReturnRateInformationSources = 42761;
    const int ReturnRateInformationSource = 42762;
    const int ReturnRateReferencePage = 42763;
    const int ReturnRateReferencePageHeading = 42764;
    const int NoReturnRatePrices = 42765;
    const int ReturnRatePriceBasis = 42766;
    const int ReturnRatePrice = 42767;
    const int ReturnRatePriceCurrency = 42768;
    const int ReturnRatePriceType = 42769;
    const int NoReturnRateValuationDateBusinessCenters = 42770;
    const int ReturnRateValuationDateBusinessCenter = 42771;
    const int NoReturnRateValuationDates = 42772;
    const int ReturnRateValuationDate = 42773;
    const int ReturnRateValuationDateType = 42774;
    const int NoSettlMethodElectionDateBusinessCenters = 42775;
    const int SettlMethodElectionDateBusinessCenter = 42776;
    const int SettlMethodElectionDateUnadjusted = 42777;
    const int SettlMethodElectionDateBusinessDayConvention = 42778;
    const int SettlMethodElectionDateRelativeTo = 42779;
    const int SettlMethodElectionDateOffsetPeriod = 42780;
    const int SettlMethodElectionDateOffsetUnit = 42781;
    const int SettlMethodElectionDateOffsetDayType = 42782;
    const int SettlMethodElectionDateAdjusted = 42783;
    const int StreamVersion = 42784;
    const int StreamVersionEffectiveDate = 42785;
    const int StreamNotionalDeterminationMethod = 42786;
    const int StreamNotionalAdjustments = 42787;
    const int NoUnderlyingCashSettlDateBusinessCenters = 42788;
    const int UnderlyingCashSettlDateBusinessCenter = 42789;
    const int UnderlyingCashSettlDateUnadjusted = 42790;
    const int UnderlyingCashSettlDateBusinessDayConvention = 42791;
    const int UnderlyingCashSettlDateRelativeTo = 42792;
    const int UnderlyingCashSettlDateOffsetPeriod = 42793;
    const int UnderlyingCashSettlDateOffsetUnit = 42794;
    const int UnderlyingCashSettlDateOffsetDayType = 42795;
    const int UnderlyingCashSettlDateAdjusted = 42796;
    const int UnderlyingCashSettlPriceSource = 42797;
    const int UnderlyingCashSettlPriceDefault = 42798;
    const int UnderlyingComplexEventFuturesPriceValuation = 2611;
    const int UnderlyingComplexEventOptionsPriceValuation = 2612;
    const int UnderlyingComplexEventPVFinalPriceElectionFallback = 2613;
    const int NoUnderlyingDividendAccrualPaymentDateBusinessCenters = 42799;
    const int UnderlyingDividendAccrualPaymentDateBusinessCenter = 42800;
    const int UnderlyingDividendFloatingRateIndex = 42801;
    const int UnderlyingDividendFloatingRateIndexCurvePeriod = 42802;
    const int UnderlyingDividendFloatingRateIndexCurveUnit = 42803;
    const int UnderlyingDividendFloatingRateMultiplier = 42804;
    const int UnderlyingDividendFloatingRateSpread = 42805;
    const int UnderlyingDividendFloatingRateSpreadPositionType = 42806;
    const int UnderlyingDividendFloatingRateTreatment = 42807;
    const int UnderlyingDividendCapRate = 42808;
    const int UnderlyingDividendCapRateBuySide = 42809;
    const int UnderlyingDividendCapRateSellSide = 42810;
    const int UnderlyingDividendFloorRate = 42811;
    const int UnderlyingDividendFloorRateBuySide = 42812;
    const int UnderlyingDividendFloorRateSellSide = 42813;
    const int UnderlyingDividendInitialRate = 42814;
    const int UnderlyingDividendFinalRateRoundingDirection = 42815;
    const int UnderlyingDividendFinalRatePrecision = 42816;
    const int UnderlyingDividendAveragingMethod = 42817;
    const int UnderlyingDividendNegativeRateTreatment = 42818;
    const int UnderlyingDividendAccrualPaymentDateRelativeTo = 42819;
    const int UnderlyingDividendAccrualPaymentDateOffsetPeriod = 42820;
    const int UnderlyingDividendAccrualPaymentDateOffsetUnit = 42821;
    const int UnderlyingDividendAccrualPaymentDateOffsetDayType = 42822;
    const int UnderlyingDividendAccrualPaymentDateUnadjusted = 42823;
    const int UnderlyingDividendAccrualPaymentDateBusinessDayConvention = 42824;
    const int UnderlyingDividendAccrualPaymentDateAdjusted = 42825;
    const int UnderlyingDividendReinvestmentIndicator = 42826;
    const int UnderlyingDividendEntitlementEvent = 42827;
    const int UnderlyingDividendAmountType = 42828;
    const int UnderlyingDividendUnderlierRefID = 42829;
    const int UnderlyingExtraordinaryDividendPartySide = 42830;
    const int UnderlyingExtraordinaryDividendAmountType = 42831;
    const int UnderlyingExtraordinaryDividendCurrency = 42832;
    const int UnderlyingExtraordinaryDividendDeterminationMethod = 42833;
    const int UnderlyingDividendAccrualFixedRate = 42834;
    const int UnderlyingDividendCompoundingMethod = 42835;
    const int UnderlyingDividendNumOfIndexUnits = 42836;
    const int UnderlyingDividendCashPercentage = 42837;
    const int UnderlyingDividendCashEquivalentPercentage = 42838;
    const int UnderlyingNonCashDividendTreatment = 42839;
    const int UnderlyingDividendComposition = 42840;
    const int UnderlyingSpecialDividendsIndicator = 42841;
    const int UnderlyingMaterialDividendsIndicator = 42842;
    const int UnderlyingOptionsExchangeDividendsIndicator = 42843;
    const int UnderlyingAdditionalDividendsIndicator = 42844;
    const int UnderlyingAllDividendsIndicator = 42845;
    const int UnderlyingDividendFXTriggerDateRelativeTo = 42846;
    const int UnderlyingDividendFXTriggerDateOffsetPeriod = 42847;
    const int UnderlyingDividendFXTriggerDateOffsetUnit = 42848;
    const int UnderlyingDividendFXTriggerDateOffsetDayType = 42849;
    const int UnderlyingDividendFXTriggerDateUnadjusted = 42850;
    const int UnderlyingDividendFXTriggerDateBusinessDayConvention = 42851;
    const int UnderlyingDividendFXTriggerDateAdjusted = 42852;
    const int NoUnderlyingDividendFXTriggerDateBusinessCenters = 42853;
    const int UnderlyingDividendFXTriggerDateBusinessCenter = 42854;
    const int NoUnderlyingDividendPayments = 42855;
    const int UnderlyingDividendPaymentDate = 42856;
    const int UnderlyingDividendPaymentAmount = 42857;
    const int UnderlyingDividendPaymentCurrency = 42858;
    const int UnderlyingDividendAccruedInterest = 42859;
    const int UnderlyingDividendPayoutRatio = 42860;
    const int UnderlyingDividendPayoutConditions = 42861;
    const int NoUnderlyingDividendPeriods = 42862;
    const int UnderlyingDividendPeriodSequence = 42863;
    const int UnderlyingDividendPeriodStartDateUnadjusted = 42864;
    const int UnderlyingDividendPeriodEndDateUnadjusted = 42865;
    const int UnderlyingDividendPeriodUnderlierRefID = 42866;
    const int UnderlyingDividendPeriodStrikePrice = 42867;
    const int UnderlyingDividendPeriodBusinessDayConvention = 42868;
    const int UnderlyingDividendPeriodValuationDateUnadjusted = 42869;
    const int UnderlyingDividendPeriodValuationDateRelativeTo = 42870;
    const int UnderlyingDividendPeriodValuationDateOffsetPeriod = 42871;
    const int UnderlyingDividendPeriodValuationDateOffsetUnit = 42872;
    const int UnderlyingDividendPeriodValuationDateOffsetDayType = 42873;
    const int UnderlyingDividendPeriodValuationDateAdjusted = 42874;
    const int UnderlyingDividendPeriodPaymentDateUnadjusted = 42875;
    const int UnderlyingDividendPeriodPaymentDateRelativeTo = 42876;
    const int UnderlyingDividendPeriodPaymentDateOffsetPeriod = 42877;
    const int UnderlyingDividendPeriodPaymentDateOffsetUnit = 42878;
    const int UnderlyingDividendPeriodPaymentDateOffsetDayType = 42879;
    const int UnderlyingDividendPeriodPaymentDateAdjusted = 42880;
    const int UnderlyingDividendPeriodXID = 42881;
    const int NoUnderlyingDividendPeriodBusinessCenters = 42882;
    const int UnderlyingDividendPeriodBusinessCenter = 42883;
    const int NoUnderlyingExtraordinaryEvents = 42884;
    const int UnderlyingExtraordinaryEventType = 42885;
    const int UnderlyingExtraordinaryEventValue = 42886;
    const int UnderlyingNotional = 2614;
    const int UnderlyingNotionalCurrency = 2615;
    const int UnderlyingNotionalDeterminationMethod = 2616;
    const int UnderlyingNotionalAdjustments = 2617;
    const int UnderlyingNotionalXIDRef = 2619;
    const int UnderlyingFutureID = 2620;
    const int UnderlyingFutureIDSource = 2621;
    const int UnderlyingStrikeIndexCurvePoint = 2622;
    const int UnderlyingStrikeIndexQuote = 2623;
    const int UnderlyingExtraordinaryEventAdjustmentMethod = 2624;
    const int UnderlyingExchangeLookAlike = 2625;
    const int UnderlyingAverageVolumeLimitationPercentage = 2626;
    const int UnderlyingAverageVolumeLimitationPeriodDays = 2627;
    const int UnderlyingDepositoryReceiptIndicator = 2628;
    const int UnderlyingOpenUnits = 2629;
    const int UnderlyingBasketDivisor = 2630;
    const int UnderlyingInstrumentXID = 2631;
    const int UnderlyingSettlMethodElectingPartySide = 42887;
    const int UnderlyingMakeWholeDate = 42888;
    const int UnderlyingMakeWholeAmount = 42889;
    const int UnderlyingMakeWholeBenchmarkCurveName = 42890;
    const int UnderlyingMakeWholeBenchmarkCurvePoint = 42891;
    const int UnderlyingMakeWholeRecallSpread = 42892;
    const int UnderlyingMakeWholeBenchmarkQuote = 42893;
    const int UnderlyingMakeWholeInterpolationMethod = 42894;
    const int UnderlyingPaymentStreamCashSettlIndicator = 42895;
    const int UnderlyingPaymentStreamCompoundingXIDRef = 42896;
    const int UnderlyingPaymentStreamCompoundingSpread = 42897;
    const int UnderlyingPaymentStreamInterpolationMethod = 42898;
    const int UnderlyingPaymentStreamInterpolationPeriod = 42899;
    const int UnderlyingPaymentStreamCompoundingFixedRate = 42900;
    const int NoUnderlyingPaymentStreamCompoundingDates = 42901;
    const int UnderlyingPaymentStreamCompoundingDate = 42902;
    const int UnderlyingPaymentStreamCompoundingDateType = 42903;
    const int UnderlyingPaymentStreamCompoundingDatesBusinessDayConvention = 42904;
    const int UnderlyingPaymentStreamCompoundingDatesRelativeTo = 42905;
    const int UnderlyingPaymentStreamCompoundingDatesOffsetPeriod = 42906;
    const int UnderlyingPaymentStreamCompoundingDatesOffsetUnit = 42907;
    const int UnderlyingPaymentStreamCompoundingDatesOffsetDayType = 42908;
    const int UnderlyingPaymentStreamCompoundingPeriodSkip = 42909;
    const int UnderlyingPaymentStreamCompoundingFrequencyPeriod = 42910;
    const int UnderlyingPaymentStreamCompoundingFrequencyUnit = 42911;
    const int UnderlyingPaymentStreamCompoundingRollConvention = 42912;
    const int UnderlyingPaymentStreamBoundsFirstDateUnadjusted = 42913;
    const int UnderlyingPaymentStreamBoundsLastDateUnadjusted = 42914;
    const int NoUnderlyingPaymentStreamCompoundingDatesBusinessCenters = 42915;
    const int UnderlyingPaymentStreamCompoundingDatesBusinessCenter = 42916;
    const int UnderlyingPaymentStreamCompoundingEndDateUnadjusted = 42917;
    const int UnderlyingPaymentStreamCompoundingEndDateRelativeTo = 42918;
    const int UnderlyingPaymentStreamCompoundingEndDateOffsetPeriod = 42919;
    const int UnderlyingPaymentStreamCompoundingEndDateOffsetUnit = 42920;
    const int UnderlyingPaymentStreamCompoundingEndDateOffsetDayType = 42921;
    const int UnderlyingPaymentStreamCompoundingEndDateAdjusted = 42922;
    const int UnderlyingPaymentStreamCompoundingRateIndex = 42923;
    const int UnderlyingPaymentStreamCompoundingRateIndexCurvePeriod = 42924;
    const int UnderlyingPaymentStreamCompoundingRateIndexCurveUnit = 42925;
    const int UnderlyingPaymentStreamCompoundingRateMultiplier = 42926;
    const int UnderlyingPaymentStreamCompoundingRateSpread = 42927;
    const int UnderlyingPaymentStreamCompoundingRateSpreadPositionType = 42928;
    const int UnderlyingPaymentStreamCompoundingRateTreatment = 42929;
    const int UnderlyingPaymentStreamCompoundingCapRate = 42930;
    const int UnderlyingPaymentStreamCompoundingCapRateBuySide = 42931;
    const int UnderlyingPaymentStreamCompoundingCapRateSellSide = 42932;
    const int UnderlyingPaymentStreamCompoundingFloorRate = 42933;
    const int UnderlyingPaymentStreamCompoundingFloorRateBuySide = 42934;
    const int UnderlyingPaymentStreamCompoundingFloorRateSellSide = 42935;
    const int UnderlyingPaymentStreamCompoundingInitialRate = 42936;
    const int UnderlyingPaymentStreamCompoundingFinalRateRoundingDirection = 42937;
    const int UnderlyingPaymentStreamCompoundingFinalRatePrecision = 42938;
    const int UnderlyingPaymentStreamCompoundingAveragingMethod = 42939;
    const int UnderlyingPaymentStreamCompoundingNegativeRateTreatment = 42940;
    const int UnderlyingPaymentStreamCompoundingStartDateUnadjusted = 42941;
    const int UnderlyingPaymentStreamCompoundingStartDateRelativeTo = 42942;
    const int UnderlyingPaymentStreamCompoundingStartDateOffsetPeriod = 42943;
    const int UnderlyingPaymentStreamCompoundingStartDateOffsetUnit = 42944;
    const int UnderlyingPaymentStreamCompoundingStartDateOffsetDayType = 42945;
    const int UnderlyingPaymentStreamCompoundingStartDateAdjusted = 42946;
    const int UnderlyingPaymentStreamFormulaImageLength = 42947;
    const int UnderlyingPaymentStreamFormulaImage = 42948;
    const int UnderlyingPaymentStreamFinalPricePaymentDateUnadjusted = 42949;
    const int UnderlyingPaymentStreamFinalPricePaymentDateRelativeTo = 42950;
    const int UnderlyingPaymentStreamFinalPricePaymentDateOffsetPeriod = 42951;
    const int UnderlyingPaymentStreamFinalPricePaymentDateOffsetUnit = 42952;
    const int UnderlyingPaymentStreamFinalPricePaymentDateOffsetDayType = 42953;
    const int UnderlyingPaymentStreamFinalPricePaymentDateAdjusted = 42954;
    const int NoUnderlyingPaymentStreamFixingDates = 42955;
    const int UnderlyingPaymentStreamFixingDate = 42956;
    const int UnderlyingPaymentStreamFixingDateType = 42957;
    const int UnderlyingPaymentStreamFirstObservationDateUnadjusted = 42958;
    const int UnderlyingPaymentStreamFirstObservationDateRelativeTo = 42959;
    const int UnderlyingPaymentStreamFirstObservationDateOffsetDayType = 42960;
    const int UnderlyingPaymentStreamFirstObservationDateAdjusted = 42961;
    const int UnderlyingPaymentStreamUnderlierRefID = 42962;
    const int UnderlyingReturnRateNotionalReset = 42963;
    const int UnderlyingPaymentStreamLinkInitialLevel = 42964;
    const int UnderlyingPaymentStreamLinkClosingLevelIndicator = 42965;
    const int UnderlyingPaymentStreamLinkExpiringLevelIndicator = 42966;
    const int UnderlyingPaymentStreamLinkEstimatedTradingDays = 42967;
    const int UnderlyingPaymentStreamLinkStrikePrice = 42968;
    const int UnderlyingPaymentStreamLinkStrikePriceType = 42969;
    const int UnderlyingPaymentStreamLinkMaximumBoundary = 42970;
    const int UnderlyingPaymentStreamLinkMinimumBoundary = 42971;
    const int UnderlyingPaymentStreamLinkNumberOfDataSeries = 42972;
    const int UnderlyingPaymentStreamVarianceUnadjustedCap = 42973;
    const int UnderlyingPaymentStreamRealizedVarianceMethod = 42974;
    const int UnderlyingPaymentStreamDaysAdjustmentIndicator = 42975;
    const int UnderlyingPaymentStreamNearestExchangeContractRefID = 42976;
    const int UnderlyingPaymentStreamVegaNotionalAmount = 42977;
    const int UnderlyingPaymentStreamFormulaCurrency = 42978;
    const int UnderlyingPaymentStreamFormulaCurrencyDeterminationMethod = 42979;
    const int UnderlyingPaymentStreamFormulaReferenceAmount = 42980;
    const int NoUnderlyingPaymentStreamFormulas = 42981;
    const int UnderlyingPaymentStreamFormula = 42982;
    const int UnderlyingPaymentStreamFormulaDesc = 42983;
    const int UnderlyingPaymentStubEndDateUnadjusted = 42984;
    const int UnderlyingPaymentStubEndDateBusinessDayConvention = 42985;
    const int UnderlyingPaymentStubEndDateRelativeTo = 42986;
    const int UnderlyingPaymentStubEndDateOffsetPeriod = 42987;
    const int UnderlyingPaymentStubEndDateOffsetUnit = 42988;
    const int UnderlyingPaymentStubEndDateOffsetDayType = 42989;
    const int UnderlyingPaymentStubEndDateAdjusted = 42990;
    const int NoUnderlyingPaymentStubEndDateBusinessCenters = 42991;
    const int UnderlyingPaymentStubEndDateBusinessCenter = 42992;
    const int UnderlyingPaymentStubStartDateUnadjusted = 42993;
    const int UnderlyingPaymentStubStartDateBusinessDayConvention = 42994;
    const int UnderlyingPaymentStubStartDateRelativeTo = 42995;
    const int UnderlyingPaymentStubStartDateOffsetPeriod = 42996;
    const int UnderlyingPaymentStubStartDateOffsetUnit = 42997;
    const int UnderlyingPaymentStubStartDateOffsetDayType = 42998;
    const int UnderlyingPaymentStubStartDateAdjusted = 42999;
    const int NoUnderlyingPaymentStubStartDateBusinessCenters = 43000;
    const int UnderlyingPaymentStubStartDateBusinessCenter = 43001;
    const int UnderlyingProvisionBreakFeeElection = 43002;
    const int UnderlyingProvisionBreakFeeRate = 43003;
    const int UnderlyingRateSpreadInitialValue = 43004;
    const int NoUnderlyingRateSpreadSteps = 43005;
    const int UnderlyingRateSpreadStepDate = 43006;
    const int UnderlyingRateSpreadStepValue = 43007;
    const int NoUnderlyingReturnRateDates = 43008;
    const int UnderlyingReturnRateDateMode = 43009;
    const int UnderlyingReturnRateValuationDateRelativeTo = 43010;
    const int UnderlyingReturnRateValuationDateOffsetPeriod = 43011;
    const int UnderlyingReturnRateValuationDateOffsetUnit = 43012;
    const int UnderlyingReturnRateValuationDateOffsetDayType = 43013;
    const int UnderlyingReturnRateValuationStartDateUnadjusted = 43014;
    const int UnderlyingReturnRateValuationStartDateRelativeTo = 43015;
    const int UnderlyingReturnRateValuationStartDateOffsetPeriod = 43016;
    const int UnderlyingReturnRateValuationStartDateOffsetUnit = 43017;
    const int UnderlyingReturnRateValuationStartDateOffsetDayType = 43018;
    const int UnderlyingReturnRateValuationStartDateAdjusted = 43019;
    const int UnderlyingReturnRateValuationEndDateUnadjusted = 43020;
    const int UnderlyingReturnRateValuationEndDateRelativeTo = 43021;
    const int UnderlyingReturnRateValuationEndDateOffsetPeriod = 43022;
    const int UnderlyingReturnRateValuationEndDateOffsetUnit = 43023;
    const int UnderlyingReturnRateValuationEndDateOffsetDayType = 43024;
    const int UnderlyingReturnRateValuationEndDateAdjusted = 43025;
    const int UnderlyingReturnRateValuationFrequencyPeriod = 43026;
    const int UnderlyingReturnRateValuationFrequencyUnit = 43027;
    const int UnderlyingReturnRateValuationFrequencyRollConvention = 43028;
    const int UnderlyingReturnRateValuationDateBusinessDayConvention = 43029;
    const int NoUnderlyingReturnRateFXConversions = 43030;
    const int UnderlyingReturnRateFXCurrencySymbol = 43031;
    const int UnderlyingReturnRateFXRate = 43032;
    const int UnderlyingReturnRateFXRateCalc = 43033;
    const int NoUnderlyingReturnRates = 43034;
    const int UnderlyingReturnRatePriceSequence = 43035;
    const int UnderlyingReturnRateCommissionBasis = 43036;
    const int UnderlyingReturnRateCommissionAmount = 43037;
    const int UnderlyingReturnRateCommissionCurrency = 43038;
    const int UnderlyingReturnRateTotalCommissionPerTrade = 43039;
    const int UnderlyingReturnRateDeterminationMethod = 43040;
    const int UnderlyingReturnRateAmountRelativeTo = 43041;
    const int UnderlyingReturnRateQuoteMeasureType = 43042;
    const int UnderlyingReturnRateQuoteUnits = 43043;
    const int UnderlyingReturnRateQuoteMethod = 43044;
    const int UnderlyingReturnRateQuoteCurrency = 43045;
    const int UnderlyingReturnRateQuoteCurrencyType = 43046;
    const int UnderlyingReturnRateQuoteTimeType = 43047;
    const int UnderlyingReturnRateQuoteTime = 43048;
    const int UnderlyingReturnRateQuoteDate = 43049;
    const int UnderlyingReturnRateQuoteExpirationTime = 43050;
    const int UnderlyingReturnRateQuoteBusinessCenter = 43051;
    const int UnderlyingReturnRateQuoteExchange = 43052;
    const int UnderlyingReturnRateQuotePricingModel = 43053;
    const int UnderlyingReturnRateCashFlowType = 43054;
    const int UnderlyingReturnRateValuationTimeType = 43055;
    const int UnderlyingReturnRateValuationTime = 43056;
    const int UnderlyingReturnRateValuationTimeBusinessCenter = 43057;
    const int UnderlyingReturnRateValuationPriceOption = 43058;
    const int UnderlyingReturnRateFinalPriceFallback = 43059;
    const int NoUnderlyingReturnRateInformationSources = 43060;
    const int UnderlyingReturnRateInformationSource = 43061;
    const int UnderlyingReturnRateReferencePage = 43062;
    const int UnderlyingReturnRateReferencePageHeading = 43063;
    const int NoUnderlyingReturnRatePrices = 43064;
    const int UnderlyingReturnRatePriceBasis = 43065;
    const int UnderlyingReturnRatePrice = 43066;
    const int UnderlyingReturnRatePriceCurrency = 43067;
    const int UnderlyingReturnRatePriceType = 43068;
    const int NoUnderlyingReturnRateValuationDateBusinessCenters = 43069;
    const int UnderlyingReturnRateValuationDateBusinessCenter = 43070;
    const int NoUnderlyingReturnRateValuationDates = 43071;
    const int UnderlyingReturnRateValuationDate = 43072;
    const int UnderlyingReturnRateValuationDateType = 43073;
    const int NoUnderlyingSettlMethodElectionDateBusinessCenters = 43074;
    const int UnderlyingSettlMethodElectionDateBusinessCenter = 43075;
    const int UnderlyingSettlMethodElectionDateUnadjusted = 43076;
    const int UnderlyingSettlMethodElectionDateBusinessDayConvention = 43077;
    const int UnderlyingSettlMethodElectionDateRelativeTo = 43078;
    const int UnderlyingSettlMethodElectionDateOffsetPeriod = 43079;
    const int UnderlyingSettlMethodElectionDateOffsetUnit = 43080;
    const int UnderlyingSettlMethodElectionDateOffsetDayType = 43081;
    const int UnderlyingSettlMethodElectionDateAdjusted = 43082;
    const int UnderlyingStreamVersion = 43083;
    const int UnderlyingStreamVersionEffectiveDate = 43084;
    const int UnderlyingStreamNotionalDeterminationMethod = 43085;
    const int UnderlyingStreamNotionalAdjustments = 43086;
    const int RemunerationIndicator = 2356;
    const int CompressionGroupID = 2361;
    const int SelfMatchPreventionID = 2362;
    const int PartyRiskLimitStatus = 2355;
    const int TradeConfirmationReferenceID = 2390;
    const int AlgorithmicTradeIndicator = 2667;
    const int NoTrdRegPublications = 2668;
    const int TrdRegPublicationType = 2669;
    const int TrdRegPublicationReason = 2670;
    const int LegDifferentialPrice = 2492;
    const int CrossedIndicator = 2523;
    const int NoOrderAttributes = 2593;
    const int OrderAttributeType = 2594;
    const int OrderAttributeValue = 2595;
    const int TradeReportingIndicator = 2524;
    const int SideTradeReportingIndicator = 2671;
    const int CrossRequestID = 2672;
    const int FillMatchID = 2673;
    const int FillMatchSubID = 2674;
    const int MassActionReason = 2675;
    const int MaximumPriceDeviation = 2676;
    const int NotAffectedReason = 2677;
    const int TotalNotAffectedOrders = 2678;
    const int OrderOwnershipIndicator = 2679;
    const int LegAccount = 2680;
    const int InTheMoneyCondition = 2681;
    const int LegInTheMoneyCondition = 2682;
    const int UnderlyingInTheMoneyCondition = 2683;
    const int DerivativeInTheMoneyCondition = 2684;
    const int ContraryInstructionEligibilityIndicator = 2685;
    const int LegContraryInstructionEligibilityIndicator = 2686;
    const int UnderlyingContraryInstructionEligibilityIndicator = 2687;
    const int DerivativeContraryInstructionEligibilityIndicator = 2688;
    const int CollateralMarketPrice = 2689;
    const int CollateralPercentOverage = 2690;
    const int NoSideCollateralAmounts = 2691;
    const int SideCollateralAmountMarketID = 2692;
    const int SideCollateralAmountMarketSegmentID = 2693;
    const int SideCollateralAmountType = 2694;
    const int SideCollateralCurrency = 2695;
    const int SideCollateralFXRate = 2696;
    const int SideCollateralFXRateCalc = 2697;
    const int SideCollateralMarketPrice = 2698;
    const int SideCollateralPercentOverage = 2699;
    const int SideCollateralPortfolioID = 2700;
    const int SideCollateralType = 2701;
    const int SideCurrentCollateralAmount = 2702;
    const int SideHaircutIndicator = 2703;
    const int ExDestinationType = 2704;
    const int MarketCondition = 2705;
    const int NoQuoteAttributes = 2706;
    const int QuoteAttributeType = 2707;
    const int QuoteAttributeValue = 2708;
    const int NoPriceQualifiers = 2709;
    const int PriceQualifier = 2710;
    const int MDValueTier = 2711;
    const int MiscFeeQualifier = 2712;
    const int MiscFeeDesc = 2713;
    const int FinancialInstrumentFullName = 2714;
    const int EncodedFinancialInstrumentFullNameLen = 2715;
    const int EncodedFinancialInstrumentFullName = 2716;
    const int LegFinancialInstrumentFullName = 2717;
    const int EncodedLegFinancialInstrumentFullNameLen = 2718;
    const int EncodedLegFinancialInstrumentFullName = 2719;
    const int UnderlyingFinancialInstrumentFullName = 2720;
    const int EncodedUnderlyingFinancialInstrumentFullNameLen = 2721;
    const int EncodedUnderlyingFinancialInstrumentFullName = 2722;
    const int UnderlyingIndexCurveUnit = 2723;
    const int UnderlyingIndexCurvePeriod = 2724;
    const int CommissionAmountSubType = 2725;
    const int AllocCommissionAmountSubType = 2726;
    const int AllocLegRefID = 2727;
    const int FloatingRateIndexCurvePeriod = 2728;
    const int FloatingRateIndexCurveSpread = 2729;
    const int FloatingRateIndexCurveUnit = 2730;
    const int FloatingRateIndexID = 2731;
    const int FloatingRateIndexIDSource = 2732;
    const int IndexRollMonth = 2733;
    const int NoIndexRollMonths = 2734;
    const int AssetSubType = 2735;
    const int CommodityFinalPriceType = 2736;
    const int FinancialInstrumentShortName = 2737;
    const int NextIndexRollDate = 2738;
    const int LegAssetSubType = 2739;
    const int LegFinancialInstrumentShortName = 2740;
    const int LegPaymentStreamRateIndexID = 43088;
    const int LegPaymentStreamRateIndexIDSource = 43089;
    const int LegSecondaryAssetSubType = 2743;
    const int PaymentStreamRateIndexID = 43090;
    const int PaymentStreamRateIndexIDSource = 43091;
    const int NoReferenceDataDates = 2746;
    const int ReferenceDataDate = 2747;
    const int ReferenceDataDateType = 2748;
    const int SecondaryAssetSubType = 2741;
    const int UnderlyingFinancialInstrumentShortName = 2742;
    const int UnderlyingAssetSubType = 2744;
    const int UnderlyingPaymentStreamRateIndexID = 43092;
    const int UnderlyingPaymentStreamRateIndexIDSource = 43093;
    const int UnderlyingSecondaryAssetSubType = 2745;
    const int DeliveryStreamRouteOrCharter = 43094;
    const int LegDeliveryStreamRouteOrCharter = 43095;
    const int UnderlyingDeliveryStreamRouteOrCharter = 43096;
    const int ExecutionTimestamp = 2749;
    const int ReportingPx = 2750;
    const int ReportingQty = 2751;
    const int DeliveryRouteOrCharter = 2752;
    const int ReturnTrigger = 2753;
    const int LegDeliveryRouteOrCharter = 2754;
    const int LegReturnTrigger = 2755;
    const int UnderlyingDeliveryRouteOrCharter = 2756;
    const int UnderlyingReturnTrigger = 2757;
    const int AllocRequestID = 2758;
    const int GroupAmount = 2759;
    const int GroupRemainingAmount = 2760;
    const int AllocGroupAmount = 2761;
    const int PriceMarkup = 2762;
    const int AveragePriceType = 2763;
    const int AveragePriceStartTime = 2764;
    const int AveragePriceEndTime = 2765;
    const int OrderPercentOfTotalVolume = 2766;
    const int AllocGroupStatus = 2767;
    const int AllocRequestStatus = 2768;
    const int AllocAvgPxIndicator = 2769;
    const int AllocAvgPxGroupID = 2770;
    const int PreviousAllocGroupID = 2771;
    const int NoMatchExceptions = 2772;
    const int MatchExceptionType = 2773;
    const int MatchExceptionElementType = 2774;
    const int MatchExceptionElementName = 2775;
    const int MatchExceptionAllocValue = 2776;
    const int MatchExceptionConfirmValue = 2777;
    const int MatchExceptionToleranceValue = 2778;
    const int MatchExceptionToleranceValueType = 2779;
    const int MatchExceptionText = 2780;
    const int NoMatchingDataPoints = 2781;
    const int MatchingDataPointIndicator = 2782;
    const int MatchingDataPointValue = 2783;
    const int MatchingDataPointType = 2784;
    const int MatchingDataPointName = 2785;
    const int EncodedMatchExceptionTextLen = 2797;
    const int EncodedMatchExceptionText = 2798;
    const int TradeAggregationRequestID = 2786;
    const int TradeAggregationRequestRefID = 2787;
    const int TradeAggregationTransType = 2788;
    const int AggregatedQty = 2789;
    const int TradeAggregationRequestStatus = 2790;
    const int TradeAggregationRejectReason = 2791;
    const int TradeAggregationReportID = 2792;
    const int AvgSpotRate = 2793;
    const int AvgForwardPoints = 2794;
    const int OffshoreIndicator = 2795;
    const int FXBenchmarkRateFix = 2796;
    const int PayReportID = 2799;
    const int PayDisputeReason = 2800;
    const int EncodedReplaceText = 2801;
    const int EncodedReplaceTextLen = 2802;
    const int PayReportRefID = 2803;
    const int PayReportTransType = 2804;
    const int ReplaceText = 2805;
    const int PayReportStatus = 2806;
    const int CancelText = 2807;
    const int EncodedCancelText = 2808;
    const int EncodedCancelTextLen = 2809;
    const int PayRequestRefID = 2810;
    const int PayRequestTransType = 2811;
    const int PayRequestID = 2812;
    const int PayRequestStatus = 2813;
    const int EncodedPostTradePaymentDesc = 2814;
    const int EncodedPostTradePaymentDescLen = 2815;
    const int PostTradePaymentAccount = 2816;
    const int PostTradePaymentAmount = 2817;
    const int PostTradePaymentCurrency = 2818;
    const int PostTradePaymentDebitOrCredit = 2819;
    const int PostTradePaymentDesc = 2820;
    const int PostTradePaymentID = 2821;
    const int PostTradePaymentLinkID = 2822;
    const int PostTradePaymentStatus = 2823;
    const int PostTradePaymentType = 2824;
    const int PostTradePaymentCalculationDate = 2825;
    const int PostTradePaymentValueDate = 2826;
    const int PostTradePaymentFinalValueDate = 2827;
    const int CurrentDisplayPrice = 2828;
    const int DuplicateClOrdIDIndicator = 2829;
    const int EventInitiatorType = 2830;
    const int NBBOEntryType = 2831;
    const int NBBOPrice = 2832;
    const int NBBOQty = 2833;
    const int NBBOSource = 2834;
    const int OrderOriginationFirmID = 2835;
    const int RelatedOrderTime = 2836;
    const int SingleQuoteIndicator = 2837;
    const int CurrentWorkingPrice = 2838;
    const int TrdRegTimestampManualIndicator = 2839;
    const int CollateralReinvestmentRate = 2840;
    const int UnderlyingRefID = 2841;
    const int CollateralReinvestmentAmount = 2842;
    const int CollateralReinvestmentCurrency = 2843;
    const int CollateralReinvestmentType = 2844;
    const int NoCollateralReinvestments = 2845;
    const int FundingSource = 2846;
    const int FundingSourceCurrency = 2847;
    const int FundingSourceMarketValue = 2848;
    const int NoFundingSources = 2849;
    const int LegPaymentStreamOtherDayCount = 43108;
    const int MarginDirection = 2851;
    const int PaymentFixedRate = 43097;
    const int PaymentFloatingRateIndex = 43098;
    const int PaymentFloatingRateIndexCurvePeriod = 43099;
    const int PaymentFloatingRateIndexCurveUnit = 43100;
    const int PaymentFloatingRateSpread = 43101;
    const int PaymentFrequencyPeriod = 43102;
    const int PaymentFrequencyUnit = 43103;
    const int PaymentRateResetFrequencyPeriod = 43104;
    const int PaymentRateResetFrequencyUnit = 43105;
    const int PaymentStreamOtherDayCount = 43106;
    const int SideCollateralReinvestmentRate = 2862;
    const int SideUnderlyingRefID = 2863;
    const int NoSideCollateralReinvestments = 2864;
    const int SideCollateralReinvestmentAmount = 2865;
    const int SideCollateralReinvestmentCurrency = 2866;
    const int SideCollateralReinvestmentType = 2867;
    const int CollateralizationValueDate = 2868;
    const int RegulatoryReportTypeBusinessDate = 2869;
    const int ClearingPortfolioID = 2870;
    const int NoTransactionAttributes = 2871;
    const int TransactionAttributeType = 2872;
    const int TransactionAttributeValue = 2873;
    const int UnderlyingID = 2874;
    const int UnderlyingPaymentStreamOtherDayCount = 43107;
    const int PosAmtPrice = 2876;
    const int PosAmtPriceType = 2877;
    const int TerminationDate = 2878;
    const int CouponOtherDayCount = 2879;
    const int LegCouponOtherDayCount = 2880;
    const int UnderlyingCouponOtherDayCount = 2881;
    const int ContraOrderOrigination = 2882;
    const int RoutingArrangmentIndicator = 2883;
    const int ContraRoutingArrangmentIndicator = 2884;
    const int PaymentStreamFormulaLength = 43109;
    const int LegPaymentStreamFormulaLength = 43110;
    const int UnderlyingPaymentStreamFormulaLength = 43111;
    const int UnderlyingAccruedInterestAmt = 2885;
    const int UnderlyingNumDaysInterest = 2886;
    const int RelatedOrderID = 2887;
    const int RelatedOrderIDSource = 2888;
    const int RelatedOrderQty = 2889;
    const int OrderRelationship = 2890;
    const int UPICode = 2891;
    const int DerivativeUPICode = 2892;
    const int LegUPICode = 2893;
    const int UnderlyingUPICode = 2894;
    const int InstrumentScopeUPICode = 2895;
    const int TertiaryTrdType = 2896;
    const int PaymentStreamRateIndex2 = 43112;
    const int PaymentStreamRateIndex2Source = 43113;
    const int PaymentStreamRateIndex2ID = 43114;
    const int PaymentStreamRateIndex2IDSource = 43115;
    const int LegPaymentStreamRateIndex2 = 43116;
    const int LegPaymentStreamRateIndex2Source = 43117;
    const int LegPaymentStreamRateIndex2ID = 43118;
    const int LegPaymentStreamRateIndex2IDSource = 43119;
    const int UnderlyingPaymentStreamRateIndex2 = 43120;
    const int UnderlyingPaymentStreamRateIndex2Source = 43121;
    const int UnderlyingPaymentStreamRateIndex2ID = 43122;
    const int UnderlyingPaymentStreamRateIndex2IDSource = 43123;
    const int CurrencyCodeSource = 2897;
    const int LegCurrencyCodeSource = 2898;
    const int SettlCurrencyCodeSource = 2899;
    const int LegSettlCurrencyCodeSource = 2900;
    const int SideCurrencyCodeSource = 2901;
    const int SideSettlCurrencyCodeSource = 2902;
    const int SettlementAmountCurrencyCodeSource = 2903;
    const int StrikeCurrencyCodeSource = 2904;
    const int UnitOfMeasureCurrencyCodeSource = 2905;
    const int PriceUnitOfMeasureCurrencyCodeSource = 2906;
    const int PriceQuoteCurrencyCodeSource = 2907;
    const int LegStrikeCurrencyCodeSource = 2908;
    const int LegUnitOfMeasureCurrencyCodeSource = 2909;
    const int LegPriceUnitOfMeasureCurrencyCodeSource = 2910;
    const int LegPriceQuoteCurrencyCodeSource = 2911;
    const int DerivativeStrikeCurrencyCodeSource = 2912;
    const int DerivativeUnitOfMeasureCurrencyCodeSource = 2913;
    const int DerivativePriceUnitOfMeasureCurrencyCodeSource = 2914;
    const int DerivativePriceQuoteCurrencyCodeSource = 2915;
    const int UnderlyingCurrencyCodeSource = 2916;
    const int UnderlyingStrikeCurrencyCodeSource = 2917;
    const int UnderlyingUnitOfMeasureCurrencyCodeSource = 2918;
    const int UnderlyingPriceUnitOfMeasureCurrencyCodeSource = 2919;
    const int UnderlyingPriceQuoteCurrencyCodeSource = 2920;
    const int UnderlyingNotionalCurrencyCodeSource = 2921;
    const int CommCurrencyCodeSource = 2922;
    const int CommissionCurrencyCodeSource = 2923;
    const int CommissionUnitOfMeasureCurrencyCodeSource = 2924;
    const int AllocCommissionCurrencyCodeSource = 2925;
    const int AllocCommissionUnitOfMeasureCurrencyCodeSource = 2926;
    const int AllocSettlCurrencyCodeSource = 2927;
    const int LegAllocSettlCurrencyCodeSource = 2928;
    const int CollateralCurrencyCodeSource = 2929;
    const int SideCollateralCurrencyCodeSource = 2930;
    const int CollateralReinvestmentCurrencyCodeSource = 2931;
    const int SideCollateralReinvestmentCurrencyCodeSource = 2932;
    const int TradeAllocCurrencyCodeSource = 2933;
    const int TradingCurrencyCodeSource = 2934;
    const int LimitAmtCurrencyCodeSource = 2935;
    const int PosQtyUnitOfMeasureCurrencyCodeSource = 2936;
    const int PositionCurrencyCodeSource = 2937;
    const int LegPosCurrencyCodeSource = 2938;
    const int RiskLimitCurrencyCodeSource = 2939;
    const int EntitlementAttribCurrencyCodeSource = 2940;
    const int ComplexOptPayoutCurrencyCodeSource = 2941;
    const int ComplexEventCurrencyOneCodeSource = 2942;
    const int ComplexEventCurrencyTwoCodeSource = 2943;
    const int LegComplexOptPayoutCurrencyCodeSource = 2944;
    const int LegComplexEventCurrencyOneCodeSource = 2945;
    const int LegComplexEventCurrencyTwoCodeSource = 2946;
    const int UnderlyingComplexOptPayoutCurrencyCodeSource = 2947;
    const int UnderlyingComplexEventCurrencyOneCodeSource = 2948;
    const int UnderlyingComplexEventCurrencyTwoCodeSource = 2949;
    const int BenchmarkCurveCurrencyCodeSource = 2950;
    const int LegBenchmarkCurveCurrencyCodeSource = 2951;
    const int AgreementCurrencyCodeSource = 2952;
    const int LegAgreementCurrencyCodeSource = 2953;
    const int FundingSourceCurrencyCodeSource = 2954;
    const int PayCollectCurrencyCodeSource = 2955;
    const int PostTradePaymentCurrencyCodeSource = 2956;
    const int SymbolPositionNumber = 2957;
    const int LegSymbolPositionNumber = 2958;
    const int UnderlyingSymbolPositionNumber = 2959;
    const int SettlPriceUnitOfMeasureCurrencyCodeSource = 2960;
    const int AnonymousTradeIndicator = 2961;
    const int SecurityReferenceDataSupplement = 2962;
    const int MultiJurisdictionReportingIndicator = 2963;
    const int SelfMatchPreventionInstruction = 2964;
  }
}
#endif //FIX_FIELDNUMBERS_H
